package br.com.centralit.api.dao;

import java.util.Collection;
import java.util.Date;
import java.util.List;

import br.com.centralit.api.model.ContratoEvento;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 09/03/2016 - 11:41:01
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
public interface ContratoEventoDao extends CitGenericDAO {

	/**
	 *
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por buscar todos os eventos de um determinado contrato
	 *
	 * @author geovane.filho
	 *
	 * @param contratoId
	 * @return
	 */
	Collection<ContratoEvento> findAllByContrato(Long contratoId);

	Collection<ContratoEvento> findAllByContratoTipoEvento(Long contratoId, Long tipoEvento);

	Collection<ContratoEvento> findAllByContratoIntervalDataEmissao(Long contratoId, Date dataInicial, Date dateFinal);

	Collection<ContratoEvento> findAllByContratoTipoTermoDataEmissao(List<Long> codigosTermo, Date dataInicial, Date dateFinal);
	
	Collection<ContratoEvento> findAllByTipoEvento(List<Long> tiposEvento);
}