package br.com.centralit.api.dao;

import java.util.Collection;

import br.com.centralit.api.model.EstudoTecnico;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 05/01/2016 - 15:42:51
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
public interface EstudoTecnicoDao extends CitGenericDAO{

	/**
	 * <p><b>História(s):</b> <a href="LINK_PORTAL">2389</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por buscar os estudos tecnicos cadastrados pelo codigo
	 *
	 * @author juliana.barbosa
	 *
	 * @param nome
	 * @return
	 */
	public Collection<EstudoTecnico> listarEstudosPorCodigo(String codigo);

	/**
	 * Método responsável por listar estudos tecnicos por codigo e organizacao
	 *
	 * @author iago.almeida
	 *
	 * @param codigo
	 * @param idOrganizacao
	 * @return Collection<EstudoTecnico>
	 */
	public Collection<EstudoTecnico> findAutoCompleteEstudoTecnicoPorCodigoAndOrganizacao(String codigo, Long idOrganizacao);

	EstudoTecnico buscarUltimoRegistroPorDataEmissao(int ano, Long idOrganizacao);

}
