package br.com.centralit.api.dao;

import java.util.Calendar;
import java.util.Collection;

import br.com.centralit.api.model.EventoAditivo;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 15/03/2016 - 18:35:42
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
public interface EventoAditivoDao extends CitGenericDAO {

	/**
	 *
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por
	 *
	 * @author geovane.filho
	 *
	 * @param contratoId
	 * @return
	 */
	Collection<EventoAditivo> findAllByContrato(Long contratoId);

	/**
	 *
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por buscar o último registro de aditivo de um determinado contrato no ano da data de emissão
	 *
	 * @author geovane.filho
	 *
	 * @param property
	 * @param dataEmissao
	 * @param contratoId
	 * @param organizacaoId
	 * @return
	 */
	EventoAditivo buscarUltimoRegistroPorDataEmissaoEContrato(String property, Calendar dataEmissao, Long contratoId, Long organizacaoId);

	boolean existeAditivoPosterior(Calendar dataInicioAditivo, Long idContrato);
}
