package br.com.centralit.api.dao;

import java.util.Collection;

import br.com.centralit.api.model.Questionario;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">415</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 03/03/2015 - 11:01:12
 *
 * @version 1.0.0
 *
 * @author juliana.barbosa
 *	
 */
public interface QuestionarioDao extends CitGenericDAO {

	Collection<Questionario> listarQuestionarios(String nome);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por trazer todos os questionarios da organizacao do usuário logado.
	 *
	 * @author geovane.filho
	 *
	 * @param organizacaoId ID da organizacao a se buscar os questionarios
	 * @return
	 */
	Collection<Questionario> findAllByOrganizacao(Long organizacaoId);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por buscar todos os questionarios de um determinado tipo
	 *
	 * @author geovane.filho
	 *
	 * @param tipoQuestId Id do tipo de questionario a se buscar
	 * @param organizacaoId Organizacao a se buscar os questionarios
	 * @return
	 */
	Collection<Questionario> findAllByDominioTipoQuestionario(Long tipoQuestId, Long organizacaoId);
}
