package br.com.centralit.api.dao;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Collection;

import br.com.centralit.api.model.RegistroOcorrencia;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAO;
import br.com.centralit.framework.model.arquitetura.PersistentObject;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governan&ccedil;a Corporativa - </p>
 *
 * <p><b>Description: </b></p>
 *
 * @since 15/02/2016 - 14:59:00
 * @version 1.0.0
 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
 *
 */
public interface RegistroOcorrenciaDao extends CitGenericDAO {

	/**
	 * Retorna o &uacute;ltimo registro de ocorr&ecirc;ncia registrado para o ano informado.
	 * */
	PersistentObject buscarUltimoRegistroPorDataEmissao(String property, Calendar dataEmissaoOcorrencia, Long idOrganizacao);

	Collection<RegistroOcorrencia> findAllPorContrato(Long idContrato);

	BigDecimal getValorTotalGlosaOrdem(Long ordemFornecimentoId);

}
