package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.ContratoEmpenhoDao;
import br.com.centralit.api.model.ContratoEmpenho;
import br.com.centralit.api.model.DominioContrato;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

/**
 * 
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 09/03/2016 - 11:48:41
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Repository("contratoEmpenhoDao")
public class ContratoEmpenhoDaoHibernate extends CitGenericDAOImpl implements ContratoEmpenhoDao {
	
	public ContratoEmpenhoDaoHibernate() {
		super(ContratoEmpenho.class);
	}
	
	@Override
	public Collection<ContratoEmpenho> findAllByContrato(Long contratoId) {

		SearchSeven search = new SearchSeven();

		search.addFilterIn("contrato.id", contratoId);

		return this.search(search);
	}	
	
	@Override
	public Collection<ContratoEmpenho> findEmpenhoParaLiberacao(Long contratoId) {

		SearchSeven search = new SearchSeven();

		search.addFilterIn("contrato.id", contratoId);
		search.addFilterNotIn("dominioFinalidadeEmpenho.codigo", DominioContrato.CODIGO_TIPO_FINALIDADE_EMPENHO_CONTRATO_ANULACAO);

		return this.search(search);
	}

}
