package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.ContratoItemDao;
import br.com.centralit.api.model.ContratoItem;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Sort;

@Repository("contratoItemDao")
public class ContratoItemDaoHibernate extends CitGenericDAOImpl implements ContratoItemDao {
	
	private static final int MAX_RESULT_AUTO_COMPLETE = 10;
	
	public ContratoItemDaoHibernate() {
		super(ContratoItem.class);
	}
	
	@Override
	public Collection<ContratoItem> findAllByContrato(Long contratoId) {

		SearchSeven search = new SearchSeven();

		search.addFilterIn("contrato.id", contratoId);

		return this.search(search);
	}
	
	@Override
	public Collection<ContratoItem> findAutoCompleteContratoItemByNomeAndContrato(String nome, Long idContrato) {
		SearchSeven searchSeven = new SearchSeven(this.persistentClass);
		searchSeven.addFilterILike("estudoTecnicoBemServicoSolucao.nomeBemServicoSolucao", "%" + nome + "%");
		searchSeven.addFilterEqual("contrato.id", idContrato);

		searchSeven.addSort(Sort.asc("estudoTecnicoBemServicoSolucao.nomeBemServicoSolucao"));
		searchSeven.setMaxResults(MAX_RESULT_AUTO_COMPLETE);
		
		return this.search(searchSeven, this.persistentClass);
	}
}
