package br.com.centralit.api.dao.impl;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.CronogramaExecucaoDao;
import br.com.centralit.api.model.CronogramaExecucao;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;

import com.googlecode.genericdao.search.Search;

@Repository("cronogramaExecucaoDao")
public class CronogramaExecucaoDaoHibernate extends CitGenericDAOImpl implements CronogramaExecucaoDao {

	public CronogramaExecucaoDaoHibernate() {
		super(CronogramaExecucao.class);
	}

	@Override
	public CronogramaExecucao buscarUltimoRegistroAno(String property, int ano, Long idOrganizacao) {

		Search search = new Search();
		search.addFilterNotNull(property);
		search.addFilterEqual("organizacao.id", idOrganizacao);
		search.addSortDesc(property);
		search.setMaxResults(1);
		return searchUnique(search);
	}


}
