package br.com.centralit.api.dao.impl;

import java.util.Calendar;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.EncerramentoContratoDao;
import br.com.centralit.api.model.EncerramentoContrato;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;
import br.com.centralit.framework.util.UtilObjeto;

import com.googlecode.genericdao.search.Sort;

/**
 * 
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 24/02/2016 - 15:50:00
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Repository("encerramentoContratoDao")
public class EncerramentoContratoDaoHibernate extends CitGenericDAOImpl implements EncerramentoContratoDao {
	
	public EncerramentoContratoDaoHibernate() {
		super(EncerramentoContrato.class);
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public String geraNumeroTermo(Calendar dataEmissao) {
		SearchSeven search = new SearchSeven();

		search.addFilterILike("numTermo", "%" + dataEmissao.get(Calendar.YEAR));

		search.addSort(Sort.desc("id"));

		search.setMaxResults(1);
		
		EncerramentoContrato encerramento = this.searchUnique(search, EncerramentoContrato.class);
		
		String ultimoNumero = "";
		
		String proximoNum = "0001" + dataEmissao.get(Calendar.YEAR);
		
		if (UtilObjeto.isReferencia(encerramento)) {
			ultimoNumero = encerramento.getNumTermo();
			
			String num = ultimoNumero.substring(0, 4);
			
			int numValue = Integer.parseInt(num) + 1;
			
			proximoNum = String.format("%04d", numValue) + dataEmissao.get(Calendar.YEAR);
		}
		
		return proximoNum;
	}

}
