package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.EstudoTecnicoBemServicoSolucaoDao;
import br.com.centralit.api.model.EstudoTecnicoBemServicoSolucao;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Sort;


@Repository("estudoTecnicoBemServicoSolucaoDao")
public class EstudoTecnicoBemServicoSolucaoDaoHibernate extends CitGenericDAOImpl implements EstudoTecnicoBemServicoSolucaoDao {
	
	public EstudoTecnicoBemServicoSolucaoDaoHibernate() {
		super(EstudoTecnicoBemServicoSolucao.class);
	}
	
	/**
	 * <p><b>História(s):</b> <a href="LINK_PORTAL">2389</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por buscar os bens ou servicos definidos no estudo tecnico pelo campo nomeBemServicoSolucao 
	 *
	 * @author juliana.barbosa
	 *
	 * @param nome
	 * @return
	 */
	@Override
	public Collection<EstudoTecnicoBemServicoSolucao> listarBensServicosPorNome(String nome) {

		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterILike("nomeBemServicoSolucao", "%" + nome + "%");

		search.addFilterEmpty("dataInativo");

		search.addSort(Sort.asc("nomeBemServicoSolucao"));

		search.setMaxResults(10);

		return this.search(search, this.persistentClass);
	}	
}
