package br.com.centralit.api.dao.impl;

import java.util.Calendar;
import java.util.Collection;
import java.util.List;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.EventoAditivoDao;
import br.com.centralit.api.model.EventoAditivo;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Search;

/**
 *
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 15/03/2016 - 18:36:13
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Repository("eventoAditivoDao")
public class EventoAditivoDaoHibernate extends CitGenericDAOImpl implements EventoAditivoDao {

	public EventoAditivoDaoHibernate() {

		super(EventoAditivo.class);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Collection<EventoAditivo> findAllByContrato(Long contratoId) {

		SearchSeven search = new SearchSeven();

		search.addFilterIn("contrato.id", contratoId);

		return this.search(search);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public EventoAditivo buscarUltimoRegistroPorDataEmissaoEContrato(String property, Calendar dataEmissao, Long contratoId, Long organizacaoId) {

		int anoInformado = dataEmissao.get(Calendar.YEAR);

		Calendar dataInicial = Calendar.getInstance();
		dataInicial.set(anoInformado, Calendar.JANUARY, 1);
		dataInicial.set(Calendar.HOUR_OF_DAY, 00);
		dataInicial.set(Calendar.MINUTE, 00);
		dataInicial.set(Calendar.SECOND, 00);
		dataInicial.set(Calendar.MILLISECOND, 0);

		Calendar dataFinal = Calendar.getInstance();
		dataFinal.set(anoInformado, Calendar.DECEMBER, 31);
		dataFinal.set(Calendar.HOUR_OF_DAY, 23);
		dataFinal.set(Calendar.MINUTE, 59);
		dataFinal.set(Calendar.SECOND, 59);
		dataFinal.set(Calendar.MILLISECOND, 999);

		Search search = new Search();
		search.addFilterNotNull(property);
		search.addFilterEqual("organizacao.id", organizacaoId);
		search.addFilterGreaterOrEqual("dataEmissao", dataInicial);
		search.addFilterLessOrEqual("dataEmissao", dataFinal);
		search.addFilterEqual("contrato.id", contratoId);
		search.addSortDesc(property);
		search.setMaxResults(1);

		return searchUnique(search);
	}

	@Override
	public boolean existeAditivoPosterior(Calendar dataInicioAditivo, Long idContrato) {
		SearchSeven search = new SearchSeven();

		search.addFilterIn("contrato.id", idContrato);
		search.addFilterGreaterThan("dataEmissao", dataInicioAditivo);

		List<Object> list = this.search(search);

		return  list != null && list.size() > 0 ? true : false;
	}

}
