package br.com.centralit.api.dao.impl;

import java.math.BigDecimal;
import java.util.List;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.EventoLiberacaoPagamentoEmpenhoDao;
import br.com.centralit.api.model.EventoLiberacaoPagamentoEmpenho;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Search;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 */
@Repository("eventoLiberacaoPagamentoEmpenhoDao")
public class EventoLiberacaoPagamentoEmpenhoDaoHibernate extends CitGenericDAOImpl implements EventoLiberacaoPagamentoEmpenhoDao {

	public EventoLiberacaoPagamentoEmpenhoDaoHibernate() {
		super(EventoLiberacaoPagamentoEmpenho.class);
	}

	@Override
	public BigDecimal getValorTotalExecutadoEmpenho(Long empenhoId) {
		Search search = new Search();
		search.addFilterEqual("contratoEmpenho.id", empenhoId);
		List<EventoLiberacaoPagamentoEmpenho> result = this.search(search, this.persistentClass);
		BigDecimal valorTotalOs = new BigDecimal("0");
		if(result == null || result.size() == 0){
			return valorTotalOs;
		}else{
			for (EventoLiberacaoPagamentoEmpenho item : result) {
				if(item.getLiberacaoPagamento().getDataInativo() == null){
					valorTotalOs = valorTotalOs.add(item.getValorLiberado());
				}
			}
		}
		return valorTotalOs;
	}

	@Override
	public Boolean existeVinculoEmpenhoComLiberacaoPagamento(Long idEmpenho) {
		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterEqual("contratoEmpenho.id", idEmpenho);

		List<Object> lista = this.search(search, this.persistentClass);

		return lista == null || lista.isEmpty() ? false : true;
	}

}
