package br.com.centralit.api.dao.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.EventoRegistroNaoConformidadeDao;
import br.com.centralit.api.model.EventoRegistroNaoConformidade;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;
import br.com.centralit.framework.util.UtilColecao;

import com.googlecode.genericdao.search.Sort;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 10/03/2016 - 16:06:15
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Repository("eventoRegistroNaoConformidadeDao")
public class EventoRegistroNaoConformidadeDaoHibernate extends CitGenericDAOImpl implements EventoRegistroNaoConformidadeDao {

	public EventoRegistroNaoConformidadeDaoHibernate() {
		super(EventoRegistroNaoConformidade.class);
	}

	@Override
	public List<String> aplicacoesNaoConformidadeContrato(Long idContrato) {

		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterEqual("contrato.id", idContrato);

		List<EventoRegistroNaoConformidade> eventosNaoConformidade = this.search(search, this.persistentClass);

		Map<String, String> aplicacoesNaoConformidadeContrato = new TreeMap<String, String>();

		if(!UtilColecao.isVazio(eventosNaoConformidade)){
			for (EventoRegistroNaoConformidade eventoRegistroNaoConformidade : eventosNaoConformidade) {
				aplicacoesNaoConformidadeContrato.put(eventoRegistroNaoConformidade.getTipoNaoConformidade().getDominioTipoSancao().getNome(), eventoRegistroNaoConformidade.getTipoNaoConformidade().getDominioTipoSancao().getNome());
			}
		}

		return new ArrayList<String>(aplicacoesNaoConformidadeContrato.values());
	}

	@Override
	public Boolean existeVinculoSancoesComNaoConformidade(Long sancaoId) {
		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterEqual("tipoNaoConformidade.id", sancaoId);

		List<Object> lista = this.search(search, this.persistentClass);

		return lista == null || lista.isEmpty() ? false : true;
	}

}
