package br.com.centralit.api.dao.impl;

import java.util.Calendar;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.EventoRescisaoContratoDao;
import br.com.centralit.api.model.EventoRescisaoContrato;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;

import com.googlecode.genericdao.search.Search;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 10/03/2016 - 16:06:15
 *
 * @version 1.0.0
 *
 * @author erick.sato
 *
 */
@Repository("eventoRescisaoContratoDao")
public class EventoRescisaoContratoDaoHibernate extends CitGenericDAOImpl implements EventoRescisaoContratoDao {

	public EventoRescisaoContratoDaoHibernate() {
		super(EventoRescisaoContrato.class);
	}

	@Override
	public EventoRescisaoContrato buscarUltimoRegistroPorDataEmissaoPorContrato(String property, String anoInformado, Long organizacaoId, Long contratoId) {

		Calendar dataInicial = Calendar.getInstance();
		dataInicial.set(Integer.valueOf(anoInformado), Calendar.JANUARY, 1);
		dataInicial.set(Calendar.HOUR_OF_DAY, 00);
		dataInicial.set(Calendar.MINUTE, 00);
		dataInicial.set(Calendar.SECOND, 00);
		dataInicial.set(Calendar.MILLISECOND, 0);

		Calendar dataFinal = Calendar.getInstance();
		dataFinal.set(Integer.valueOf(anoInformado), Calendar.DECEMBER, 31);
		dataFinal.set(Calendar.HOUR_OF_DAY, 23);
		dataFinal.set(Calendar.MINUTE, 59);
		dataFinal.set(Calendar.SECOND, 59);
		dataFinal.set(Calendar.MILLISECOND, 999);

		Search search = new Search();
		search.addFilterNotNull(property);
		search.addFilterEqual("organizacao.id", organizacaoId);
		search.addFilterGreaterOrEqual("dataRescisao", dataInicial);
		search.addFilterLessOrEqual("dataRescisao", dataFinal);
		search.addFilterEqual("contrato.id", contratoId);
		search.addSortDesc(property);
		search.setMaxResults(1);

		return searchUnique(search);
	}

}
