package br.com.centralit.api.dao.impl;

import org.springframework.stereotype.Repository;
import java.util.Collection;

import br.com.centralit.api.dao.ObjetivoEstrategicoNecessidadeDao;
import br.com.centralit.api.model.ObjetivoEstrategicoNecessidade;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Sort;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 08/01/2016 - 13:53:30
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Repository("objetivoEstrategicoNecessidadeDao")
public class ObjetivoEstrategicoNecessidadeDaoHibernate extends CitGenericDAOImpl implements ObjetivoEstrategicoNecessidadeDao{

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 */
	public ObjetivoEstrategicoNecessidadeDaoHibernate() {

		super(ObjetivoEstrategicoNecessidade.class);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Collection<ObjetivoEstrategicoNecessidade> findAllByObjetivoEstrategico(Long objEstrategicoId) {
		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterEqual("objetivoEstrategico.id", objEstrategicoId);

		search.addSort(Sort.asc("descricao"));

		return this.search(search, this.persistentClass);
	}

}
