package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.OrdemFornecimentoDao;
import br.com.centralit.api.model.OrdemFornecimento;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Sort;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 03/02/2016 - 16:55:53
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Repository("ordemFornecimentoDao")
public class OrdemFornecimentoDaoHibernate extends CitGenericDAOImpl implements OrdemFornecimentoDao {

	private static final int MAX_RESULT_AUTO_COMPLETE = 10;

	public OrdemFornecimentoDaoHibernate() {
		super(OrdemFornecimento.class);
	}


	public Collection<OrdemFornecimento> findOrdemFornecimentoPorContrato(Long idContrato){
		SearchSeven search = new SearchSeven();

		search.addFilterEqual("contrato.id", idContrato);
		search.addSort(Sort.asc("contrato.id"));
		search.setMaxResults(MAX_RESULT_AUTO_COMPLETE);

		return this.search(search, OrdemFornecimento.class);
	}

}
