package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import com.googlecode.genericdao.search.Sort;

import br.com.centralit.api.dao.ProgramaAcaoDao;
import br.com.centralit.api.model.ProgramaAcao;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

@Repository("programaAcaoDao")
public class ProgramaAcaoDaoHibernate extends CitGenericDAOImpl implements ProgramaAcaoDao {
	
	public ProgramaAcaoDaoHibernate() {
		super(ProgramaAcao.class);
	}

	@Override
	public Collection<ProgramaAcao> findAllByPrograma(Long programaId) {
		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterEqual("programa.id", programaId);

		search.addSort(Sort.asc("nome"));

		return this.search(search, this.persistentClass);
	}

}
