package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.QuestionarioDao;
import br.com.centralit.api.model.Questionario;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Sort;

@Repository("questionarioDao")
public class QuestionarioDaoHibernate extends CitGenericDAOImpl implements QuestionarioDao {

	public QuestionarioDaoHibernate() {

		super(Questionario.class);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Collection<Questionario> listarQuestionarios(String nome) {

		SearchSeven search = new SearchSeven(this.persistentClass);

		search.addFilterILike("nome", "%" + nome + "%");

    	search.addFilterEmpty("dataInativo");

		search.addSort(Sort.asc("nome"));

		search.setMaxResults(10);
		
		return this.search(search, this.persistentClass);
	}

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por trazer todos os questionarios da organizacao do usuário logado.
	 *
	 * @author geovane.filho
	 *
	 * @param organizacaoId ID da organizacao a se buscar os questionarios
	 * @return
	 */
	@Override
	public Collection<Questionario> findAllByOrganizacao(Long organizacaoId) {

		SearchSeven search = new SearchSeven(this.persistentClass);
		
		search.addFilterEqual("organizacao.id", organizacaoId);
		
		return this.search(search, this.persistentClass);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Collection<Questionario> findAllByDominioTipoQuestionario(Long tipoQuestId, Long organizacaoId) {
		SearchSeven search = new SearchSeven(this.persistentClass);
		
		search.addFilterEqual("organizacao.id", organizacaoId);
		
		search.addFilterEqual("dominioTipoQuestionario.id", tipoQuestId);
		
		return this.search(search, this.persistentClass);
	}

}
