package br.com.centralit.api.dao.impl;

import java.util.Collection;

import org.springframework.stereotype.Repository;

import com.googlecode.genericdao.search.Filter;
import com.googlecode.genericdao.search.Sort;

import br.com.centralit.api.dao.TermoReferenciaDao;
import br.com.centralit.api.model.TermoReferencia;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

@Repository("termoReferenciaDao")
public class TermoReferenciaDaoHibernate extends CitGenericDAOImpl implements TermoReferenciaDao {

	private static final int MAX_RESULT_AUTO_COMPLETE = 10;

	public TermoReferenciaDaoHibernate() {

		super(TermoReferencia.class);
	}

	@Override
	public TermoReferencia findTermoByEstudoTecnico(long estudoTecnicoId) {
		SearchSeven searchSeven = new SearchSeven();
		searchSeven.addFilterEqual("estudoTecnico.id", estudoTecnicoId);
		return searchUnique(searchSeven);
	}

	@Override
	public Collection<TermoReferencia> findAutoCompleteTermoReferencia(String value, Long idOrganizacao) {
		SearchSeven searchSeven = new SearchSeven(this.persistentClass);

		searchSeven.addFilter(Filter.ilike("codigo", "%" + value + "%"));

		searchSeven.addFilterEqual("organizacao.id", idOrganizacao);

		searchSeven.setMaxResults(MAX_RESULT_AUTO_COMPLETE);

		return this.search(searchSeven, this.persistentClass);
	}

}
