package br.com.centralit.api.dao.impl;

import java.util.Collection;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.TermoReferenciaPenalidadeDao;
import br.com.centralit.api.model.TermoReferenciaPenalidade;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;

@Repository("termoReferenciaPenalidadeDao")
public class TermoReferenciaPenalidadeDaoHibernate extends CitGenericDAOImpl implements TermoReferenciaPenalidadeDao {

	public TermoReferenciaPenalidadeDaoHibernate() {

		super(TermoReferenciaPenalidade.class);
	}

	@SuppressWarnings("unchecked")
	@Override
	public Collection<TermoReferenciaPenalidade> findAllByContrato(Long idContrato) {

		StringBuilder query = new StringBuilder();
		query.append("select distinct trp.* ")
		.append(" from cnt_tr_penalidade trp ")
		.append(" inner join cnt_termoreferencia tr on tr.id = trp.termo_id ")
		.append(" inner join cnt_estudoTecnico et on et.id = tr.estudotecnico_id ")
		.append(" inner join cnt_cn_item ci on ci.estudotecnico_id = et.id")
		.append(" inner join cnt_contrato c on c.id = ci.contrato_id ")
		.append(" where ci.contrato_id =  :idContrato ");

		Query resultado = em().createNativeQuery(query.toString(), TermoReferenciaPenalidade.class);
		resultado.setParameter("idContrato", idContrato);
		return resultado.getResultList();
	}

}
