package br.com.centralit.api.dao.impl;

import java.util.Collection;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.TermoReferenciaSancaoDao;
import br.com.centralit.api.model.TermoReferenciaSancao;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;

@Repository("termoReferenciaSancaoDao")
public class TermoReferenciaSancaoDaoHibernate extends CitGenericDAOImpl implements TermoReferenciaSancaoDao {

	public TermoReferenciaSancaoDaoHibernate() {

		super(TermoReferenciaSancao.class);
	}

	public Collection<TermoReferenciaSancao> buscaSancoesTermo(Long idContrato) {

		StringBuilder query = new StringBuilder();
		query.append("select distinct trp.* ")
		.append(" from cnt_tr_sancao trp ")
		.append(" inner join cnt_termoreferencia tr on tr.id = trp.termo_id ")
		.append(" inner join cnt_estudoTecnico et on et.id = tr.estudotecnico_id ")
		.append(" inner join cnt_cn_item ci on ci.estudotecnico_id = et.id")
		.append(" inner join cnt_contrato c on c.id = ci.contrato_id ")
		.append(" where ci.contrato_id =  :idContrato ");

		Query resultado = em().createNativeQuery(query.toString(), persistentClass);
		resultado.setParameter("idContrato", idContrato);
		return resultado.getResultList();
	}
}
