package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 19/01/2016 - 16:47:54
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Audited
@AuditTable(value = "cnt_cn_envolvido_aud")
@Entity
@Table(name = "cnt_cn_envolvido")
@JsonIgnoreProperties({ "$checked", "justificativasAnterioresLength" })
public class ContratoEnvolvido extends PersistentObjectAudit {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo contrato. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private Contrato contrato;

	/** Atributo contratoInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private Contrato contratoInativo;

	/** Atributo colaborador. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsContrato.ContratoEditView.class, Views.ContratoView.class })
	private Colaborador envolvido;

	/** Atributo dominioFormaPagamentoContrato. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JoinColumn(name = "papelenvolvidocontrato_id")
	@JsonView({ ViewsContrato.ContratoEditView.class })
	private Dominio dominioPapelEnvolvidoContrato;

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "contratoEnvolvido", cascade = CascadeType.ALL)
	@JsonView({ ViewsContrato.ContratoEditView.class })
	private Collection<ContratoEnvolvidoJustificativa> justificativas;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>contrato</code>
	 *
	 * @return <code>Contrato</code>
	 */
	public Contrato getContrato() {

		return contrato;
	}

	/**
	 * Define o valor do atributo <code>contrato</code>.
	 *
	 * @param contrato
	 */
	public void setContrato(Contrato contrato) {

		this.contrato = contrato;
	}

	/**
	 * Retorna o valor do atributo <code>contratoInativo</code>
	 *
	 * @return <code>Contrato</code>
	 */
	public Contrato getContratoInativo() {

		return contratoInativo;
	}

	/**
	 * Define o valor do atributo <code>contratoInativo</code>.
	 *
	 * @param contratoInativo
	 */
	public void setContratoInativo(Contrato contratoInativo) {

		this.contratoInativo = contratoInativo;
	}

	public Colaborador getEnvolvido() {

		return envolvido;
	}

	public void setEnvolvido(Colaborador envolvido) {

		this.envolvido = envolvido;
	}

	public Dominio getDominioPapelEnvolvidoContrato() {

		return dominioPapelEnvolvidoContrato;
	}

	public void setDominioPapelEnvolvidoContrato(Dominio dominioPapelEnvolvidoContrato) {

		this.dominioPapelEnvolvidoContrato = dominioPapelEnvolvidoContrato;
	}

	public Collection<ContratoEnvolvidoJustificativa> getJustificativas() {

		return justificativas;
	}

	public void setJustificativas(Collection<ContratoEnvolvidoJustificativa> justificativas) {

		this.justificativas = justificativas;
	}

}
