package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 25/02/2016 - 14:47:40
 *
 * @version 1.0.0
 *
 * @author luis.camargo
 *
 */
@Audited
@AuditTable(value = "cnt_en_justificativa_aud")
@Entity
@Table(name="cnt_en_justificativa")
public class ContratoEnvolvidoJustificativa extends PersistentObjectAudit {

	private static final long serialVersionUID = 2475333324040603906L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ Views.GenericView.class })
    private Long id;

    @Column(length = 500, nullable=true)
    @JsonView({ ViewsContrato.ContratoEditView.class })
    private String descricao;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private ContratoEnvolvido contratoEnvolvido;

	public Long getId() {

		return id;
	}

	public void setId(Long id) {

		this.id = id;
	}

	public String getDescricao() {
		return descricao;
	}

	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}


	public ContratoEnvolvido getContratoEnvolvido() {

		return contratoEnvolvido;
	}


	public void setContratoEnvolvido(ContratoEnvolvido contratoEnvolvido) {

		this.contratoEnvolvido = contratoEnvolvido;
	}

}
