package br.com.centralit.api.model;

import java.util.Calendar;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 *
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 09/03/2016 - 10:24:44
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Audited
@AuditTable(value = "cnt_cn_evento_aud")
@Entity
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "cnt_cn_evento")
public class ContratoEvento extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo contrato. */
	@ManyToOne(fetch = FetchType.EAGER, optional = true)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class, ViewsContrato.EventoApostilamentoEditView.class, ViewsContrato.EventoPenalidadeEditView.class, ViewsContrato.EventoRecebimentoObjetoEditView.class })
	private Contrato contrato;

	/** Atributo contratoInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private Contrato contratoInativo;

	/** Atributo tipoEvento. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.GenericView.class })
	private Dominio tipoEvento;

	/** Atributo dataEvento. */
	@Column(nullable = false)
	@Temporal(TemporalType.TIMESTAMP)
	@JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
	@JsonView({ Views.GenericView.class })
	private Calendar dataEvento;

	@Column(length = 500, nullable = false)
	@JsonView({ Views.GenericView.class, ViewsContrato.ContratoEventoEditView.class })
	private String descricao;

	@Column(length = 255, nullable = true)
	@JsonView({ Views.GenericView.class })
	private String justificativaExclusao;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>contrato</code>
	 *
	 * @return <code>Contrato</code>
	 */
	public Contrato getContrato() {

		return contrato;
	}

	/**
	 * Define o valor do atributo <code>contrato</code>.
	 *
	 * @param contrato
	 */
	public void setContrato(Contrato contrato) {

		this.contrato = contrato;
	}

	/**
	 * Retorna o valor do atributo <code>tipoEvento</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoEvento() {

		return tipoEvento;
	}

	/**
	 * Define o valor do atributo <code>tipoEvento</code>.
	 *
	 * @param tipoEvento
	 */
	public void setTipoEvento(Dominio tipoEvento) {

		this.tipoEvento = tipoEvento;
	}

	/**
	 * Retorna o valor do atributo <code>contratoInativo</code>
	 *
	 * @return <code>Contrato</code>
	 */
	public Contrato getContratoInativo() {

		return contratoInativo;
	}

	/**
	 * Define o valor do atributo <code>contratoInativo</code>.
	 *
	 * @param contratoInativo
	 */
	public void setContratoInativo(Contrato contratoInativo) {

		this.contratoInativo = contratoInativo;
	}

	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}

	/**
	 * Define o valor do atributo <code>descricao</code>.
	 *
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}

	/**
	 * Retorna o valor do atributo <code>dataEvento</code>
	 *
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataEvento() {

		return dataEvento;
	}

	/**
	 * Define o valor do atributo <code>dataEvento</code>.
	 *
	 * @param dataEvento
	 */
	public void setDataEvento(Calendar dataEvento) {

		this.dataEvento = dataEvento;
	}

	public String getJustificativaExclusao() {
		return justificativaExclusao;
	}

	public void setJustificativaExclusao(String justificativaExclusao) {
		this.justificativaExclusao = justificativaExclusao;
	}

}
