package br.com.centralit.api.model;

import java.math.BigDecimal;
import java.util.Calendar;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;
import br.com.centralit.framework.json.MoneyDeserializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 19/01/2016 - 16:57:26
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Entity
@Table(name="cnt_cn_garantia")
public class ContratoGarantia extends PersistentObjectAudit{

	 /** Atributo serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** Atributo id. */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ Views.GenericView.class })
    private Long id;

	/** Atributo contrato. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private Contrato contrato;

	/** Atributo contratoInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private Contrato contratoInativo;

    /** Atributo dominioModalidadeGarantia. */
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ ViewsContrato.ContratoEditView.class })
    private Dominio dominioModalidadeGarantia;

	/** Atributo dataVigencia. */
    @Temporal(TemporalType.TIMESTAMP)
    @JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
    @JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
    @JsonView({ ViewsContrato.ContratoEditView.class })
    private Calendar dataVigencia;

    /** Atributo valor. */
    @Column(precision = 20, scale = 4)
    @JsonDeserialize(using = MoneyDeserializer.class)
    @JsonView({ ViewsContrato.ContratoEditView.class })
    private BigDecimal valor;

    /** Atributo percentual. */
    @Column(precision = 20, scale = 4)
    @JsonDeserialize(using = MoneyDeserializer.class)
    @JsonView({ ViewsContrato.ContratoEditView.class })
    private BigDecimal percentual;


	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}


	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}


	/**
	 * Retorna o valor do atributo <code>contrato</code>
	 *
	 * @return <code>Contrato</code>
	 */
	public Contrato getContrato() {

		return contrato;
	}


	/**
	 * Define o valor do atributo <code>contrato</code>.
	 *
	 * @param contrato
	 */
	public void setContrato(Contrato contrato) {

		this.contrato = contrato;
	}


	/**
	 * Retorna o valor do atributo <code>contratoInativo</code>
	 *
	 * @return <code>Contrato</code>
	 */
	public Contrato getContratoInativo() {

		return contratoInativo;
	}


	/**
	 * Define o valor do atributo <code>contratoInativo</code>.
	 *
	 * @param contratoInativo
	 */
	public void setContratoInativo(Contrato contratoInativo) {

		this.contratoInativo = contratoInativo;
	}


	/**
	 * Retorna o valor do atributo <code>dominioModalidadeGarantia</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioModalidadeGarantia() {

		return dominioModalidadeGarantia;
	}


	/**
	 * Define o valor do atributo <code>dominioModalidadeGarantia</code>.
	 *
	 * @param dominioModalidadeGarantia
	 */
	public void setDominioModalidadeGarantia(Dominio dominioModalidadeGarantia) {

		this.dominioModalidadeGarantia = dominioModalidadeGarantia;
	}


	/**
	 * Retorna o valor do atributo <code>dataVigencia</code>
	 *
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataVigencia() {

		return dataVigencia;
	}


	/**
	 * Define o valor do atributo <code>dataVigencia</code>.
	 *
	 * @param dataVigencia
	 */
	public void setDataVigencia(Calendar dataVigencia) {

		this.dataVigencia = dataVigencia;
	}


	/**
	 * Retorna o valor do atributo <code>valor</code>
	 *
	 * @return <code>BigDecimal</code>
	 */
	public BigDecimal getValor() {

		return valor;
	}


	/**
	 * Define o valor do atributo <code>valor</code>.
	 *
	 * @param valor
	 */
	public void setValor(BigDecimal valor) {

		this.valor = valor;
	}


	/**
	 * Retorna o valor do atributo <code>percentual</code>
	 *
	 * @return <code>BigDecimal</code>
	 */
	public BigDecimal getPercentual() {

		return percentual;
	}


	/**
	 * Define o valor do atributo <code>percentual</code>.
	 *
	 * @param percentual
	 */
	public void setPercentual(BigDecimal percentual) {

		this.percentual = percentual;
	}

}
