package br.com.centralit.api.model;

import java.util.Calendar;
import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.json.JsonCalendarSimpleDateSerializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 05/01/2016 - 15:30:37
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Audited
@AuditTable(value = "cnt_etla_questionario_aud")
@Entity
@Table(name="cnt_etla_questionario")
public class EstudoTecnicoLevantamentoAlternativaQuestionario extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -5289767346909495557L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
    private EstudoTecnicoQuestionario etQuestionario;
	
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "etlaQuestionario", cascade = CascadeType.ALL)
    @JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
    private Collection<EstudoTecnicoQuestionarioResposta> etQuestionarioRespostas;

    @Temporal(TemporalType.TIMESTAMP)
    @JsonSerialize(using = JsonCalendarSimpleDateSerializer.class)
    @JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
    @JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
    private Calendar data;

    @OneToOne(fetch = FetchType.LAZY)
    private EstudoTecnico estudoTecnico;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}


	/**
	 * Retorna o valor do atributo <code>etQuestionario</code>
	 *
	 * @return <code>EstudoTecnicoQuestionario</code>
	 */
	public EstudoTecnicoQuestionario getEtQuestionario() {

		return etQuestionario;
	}


	/**
	 * Define o valor do atributo <code>etQuestionario</code>.
	 *
	 * @param etQuestionario
	 */
	public void setEtQuestionario(EstudoTecnicoQuestionario etQuestionario) {

		this.etQuestionario = etQuestionario;
	}

	/**
	 * Retorna o valor do atributo <code>data</code>
	 *
	 * @return <code>Calendar</code>
	 */
	public Calendar getData() {

		return data;
	}

	/**
	 * Define o valor do atributo <code>data</code>.
	 *
	 * @param data
	 */
	public void setData(Calendar data) {

		this.data = data;
	}

	/**
	 * Retorna o valor do atributo <code>estudoTecnico</code>
	 *
	 * @return <code>EstudoTecnico</code>
	 */
	public EstudoTecnico getEstudoTecnico() {

		return estudoTecnico;
	}

	/**
	 * Define o valor do atributo <code>estudoTecnico</code>.
	 *
	 * @param estudoTecnico
	 */
	public void setEstudoTecnico(EstudoTecnico estudoTecnico) {

		this.estudoTecnico = estudoTecnico;
	}

	
	/**
	 * Retorna o valor do atributo <code>etQuestionarioRespostas</code>
	 *
	 * @return <code>Collection<EstudoTecnicoQuestionarioResposta></code>
	 */
	public Collection<EstudoTecnicoQuestionarioResposta> getEtQuestionarioRespostas() {
	
		return etQuestionarioRespostas;
	}

	
	/**
	 * Define o valor do atributo <code>etQuestionarioRespostas</code>.
	 *
	 * @param etQuestionarioRespostas 
	 */
	public void setEtQuestionarioRespostas(Collection<EstudoTecnicoQuestionarioResposta> etQuestionarioRespostas) {
	
		this.etQuestionarioRespostas = etQuestionarioRespostas;
	}
}
