package br.com.centralit.api.model;

import java.math.BigDecimal;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.MoneyDeserializer;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 05/01/2016 - 14:41:20
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Audited
@AuditTable(value = "cnt_et_levantalternat_aud")
@Entity
@Table(name="cnt_et_levantamentoalternativa")
@JsonIgnoreProperties({ "$index", "$checked" })
public class EstudoTecnicoLevantamentoAlternativas extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -5714793304760343921L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo orgaoExterno. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private Parceiro orgaoExterno;

	/** Atributo fornecedor. */
	@ManyToOne(fetch = FetchType.LAZY)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private Parceiro fornecedor;

	/** Atributo valor. */
	@Column(precision = 20, scale = 4, nullable = false)
	@JsonDeserialize(using = MoneyDeserializer.class)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private BigDecimal valor;

	@Column(length = 1000, nullable = false)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private String descricaoAlternativa;

	@OneToOne(fetch = FetchType.EAGER, cascade = CascadeType.ALL, optional = false)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private EstudoTecnicoLevantamentoAlternativaQuestionario etlaQuestionario;

	/** Atributo estudoTecnico. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EstudoTecnico estudoTecnico;

	/** Atributo estudoTecnicoInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EstudoTecnico estudoTecnicoInativo;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}


	/**
	 * Retorna o valor do atributo <code>orgaoExterno</code>
	 *
	 * @return <code>Parceiro</code>
	 */
	public Parceiro getOrgaoExterno() {

		return orgaoExterno;
	}


	/**
	 * Define o valor do atributo <code>orgaoExterno</code>.
	 *
	 * @param orgaoExterno
	 */
	public void setOrgaoExterno(Parceiro orgaoExterno) {

		this.orgaoExterno = orgaoExterno;
	}


	/**
	 * Retorna o valor do atributo <code>fornecedor</code>
	 *
	 * @return <code>Parceiro</code>
	 */
	public Parceiro getFornecedor() {

		return fornecedor;
	}


	/**
	 * Define o valor do atributo <code>fornecedor</code>.
	 *
	 * @param fornecedor
	 */
	public void setFornecedor(Parceiro fornecedor) {

		this.fornecedor = fornecedor;
	}


	/**
	 * Retorna o valor do atributo <code>valor</code>
	 *
	 * @return <code>BigDecimal</code>
	 */
	public BigDecimal getValor() {

		return valor;
	}


	/**
	 * Define o valor do atributo <code>valor</code>.
	 *
	 * @param valor
	 */
	public void setValor(BigDecimal valor) {

		this.valor = valor;
	}


	/**
	 * Retorna o valor do atributo <code>descricaoAlternativa</code>
	 *
	 * @return <code>String</code>
	 */
	public String getDescricaoAlternativa() {

		return descricaoAlternativa;
	}


	/**
	 * Define o valor do atributo <code>descricaoAlternativa</code>.
	 *
	 * @param descricaoAlternativa
	 */
	public void setDescricaoAlternativa(String descricaoAlternativa) {

		this.descricaoAlternativa = descricaoAlternativa;
	}



	/**
	 * Retorna o valor do atributo <code>etlaQuestionario</code>
	 *
	 * @return <code>EstudoTecnicoLevantamentoAlternativaQuestionario</code>
	 */
	public EstudoTecnicoLevantamentoAlternativaQuestionario getEtlaQuestionario() {

		return etlaQuestionario;
	}


	/**
	 * Define o valor do atributo <code>etlaQuestionario</code>.
	 *
	 * @param etlaQuestionario
	 */
	public void setEtlaQuestionario(EstudoTecnicoLevantamentoAlternativaQuestionario etlaQuestionario) {

		this.etlaQuestionario = etlaQuestionario;
	}

	/**
	 * Retorna o valor do atributo <code>estudoTecnico</code>
	 *
	 * @return <code>EstudoTecnico</code>
	 */
	public EstudoTecnico getEstudoTecnico() {

		return estudoTecnico;
	}


	/**
	 * Define o valor do atributo <code>estudoTecnico</code>.
	 *
	 * @param estudoTecnico
	 */
	public void setEstudoTecnico(EstudoTecnico estudoTecnico) {

		this.estudoTecnico = estudoTecnico;
	}


	/**
	 * Retorna o valor do atributo <code>estudoTecnicoInativo</code>
	 *
	 * @return <code>EstudoTecnico</code>
	 */
	public EstudoTecnico getEstudoTecnicoInativo() {

		return estudoTecnicoInativo;
	}


	/**
	 * Define o valor do atributo <code>estudoTecnicoInativo</code>.
	 *
	 * @param estudoTecnicoInativo
	 */
	public void setEstudoTecnicoInativo(EstudoTecnico estudoTecnicoInativo) {

		this.estudoTecnicoInativo = estudoTecnicoInativo;
	}

}
