package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 07/01/2016 - 16:06:37
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Audited
@AuditTable(value = "cnt_et_questionario_aud")
@Entity
@Table(name="cnt_et_questionario")
public class EstudoTecnicoQuestionario extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -5560984562308363541L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo Nome. */
	@Column(length = 100)
	@JsonView({ Views.GenericView.class })
	private String nome;

	/** Atributo questoes. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "etQuestionario", cascade = CascadeType.ALL)
	@JsonView({ Views.GenericView.class })
	private Collection<QuestionarioPergunta> questoes;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}



	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}


	/**
	 * Retorna o valor do atributo <code>nome</code>
	 *
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}


	/**
	 * Define o valor do atributo <code>nome</code>.
	 *
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}


	/**
	 * Retorna o valor do atributo <code>questoes</code>
	 *
	 * @return <code>Collection<QuestionarioPergunta></code>
	 */
	public Collection<QuestionarioPergunta> getQuestoes() {

		return questoes;
	}


	/**
	 * Define o valor do atributo <code>questoes</code>.
	 *
	 * @param questoes
	 */
	public void setQuestoes(Collection<QuestionarioPergunta> questoes) {

		this.questoes = questoes;
	}
}
