package br.com.centralit.api.model;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 05/01/2016 - 15:30:37
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *	
 */
@Audited
@AuditTable(value = "cnt_etq_resposta_aud")
@Entity
@Table(name="cnt_etq_resposta")
@JsonIgnoreProperties({ "index", "edit", "$checked" })
public class EstudoTecnicoQuestionarioResposta extends PersistentObjectAuditOrganizacao {
	
    /** Atributo serialVersionUID. */
	private static final long serialVersionUID = 2275559963690899257L;

	/** Atributo id. */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ Views.GenericView.class })
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY, cascade = CascadeType.ALL)
    @JsonView({ Views.GenericView.class })
    private QuestionarioPergunta questionarioPergunta;

    @JsonView({ Views.GenericView.class })
    private String resposta;

    @JsonView({ Views.GenericView.class })
    private Boolean respostaBoolean;

    @ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ Views.GenericView.class })
    private PossivelRespostaQuestionarioPergunta possivelRespostaSelecionada;

    @ManyToOne(fetch = FetchType.LAZY)
    private EstudoTecnicoQuestionario etQuestionario;
    
    @ManyToOne(fetch = FetchType.LAZY)
    private EstudoTecnicoLevantamentoAlternativaQuestionario etlaQuestionario;
	
	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {
	
		return id;
	}
	
	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id 
	 */
	public void setId(Long id) {
	
		this.id = id;
	}
	
	/**
	 * Retorna o valor do atributo <code>questionarioPergunta</code>
	 *
	 * @return <code>QuestionarioPergunta</code>
	 */
	public QuestionarioPergunta getQuestionarioPergunta() {
	
		return questionarioPergunta;
	}
	
	/**
	 * Define o valor do atributo <code>questionarioPergunta</code>.
	 *
	 * @param questionarioPergunta 
	 */
	public void setQuestionarioPergunta(QuestionarioPergunta questionarioPergunta) {
	
		this.questionarioPergunta = questionarioPergunta;
	}
	
	/**
	 * Retorna o valor do atributo <code>resposta</code>
	 *
	 * @return <code>String</code>
	 */
	public String getResposta() {
	
		return resposta;
	}
	
	/**
	 * Define o valor do atributo <code>resposta</code>.
	 *
	 * @param resposta 
	 */
	public void setResposta(String resposta) {
	
		this.resposta = resposta;
	}
	
	/**
	 * Retorna o valor do atributo <code>respostaBoolean</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getRespostaBoolean() {
	
		return respostaBoolean;
	}
	
	/**
	 * Define o valor do atributo <code>respostaBoolean</code>.
	 *
	 * @param respostaBoolean 
	 */
	public void setRespostaBoolean(Boolean respostaBoolean) {
	
		this.respostaBoolean = respostaBoolean;
	}
	
	/**
	 * Retorna o valor do atributo <code>possivelRespostaSelecionada</code>
	 *
	 * @return <code>PossivelRespostaQuestionarioPergunta</code>
	 */
	public PossivelRespostaQuestionarioPergunta getPossivelRespostaSelecionada() {
	
		return possivelRespostaSelecionada;
	}
	
	/**
	 * Define o valor do atributo <code>possivelRespostaSelecionada</code>.
	 *
	 * @param possivelRespostaSelecionada 
	 */
	public void setPossivelRespostaSelecionada(PossivelRespostaQuestionarioPergunta possivelRespostaSelecionada) {
	
		this.possivelRespostaSelecionada = possivelRespostaSelecionada;
	}
	
	/**
	 * Retorna o valor do atributo <code>etQuestionario</code>
	 *
	 * @return <code>EstudoTecnicoQuestionario</code>
	 */
	public EstudoTecnicoQuestionario getEtQuestionario() {
	
		return etQuestionario;
	}
	
	/**
	 * Define o valor do atributo <code>etQuestionario</code>.
	 *
	 * @param etQuestionario 
	 */
	public void setEtQuestionario(EstudoTecnicoQuestionario etQuestionario) {
	
		this.etQuestionario = etQuestionario;
	}

	
	/**
	 * Retorna o valor do atributo <code>etlaQuestionario</code>
	 *
	 * @return <code>EstudoTecnicoLevantamentoAlternativaQuestionario</code>
	 */
	public EstudoTecnicoLevantamentoAlternativaQuestionario getEtlaQuestionario() {
	
		return etlaQuestionario;
	}

	
	/**
	 * Define o valor do atributo <code>etlaQuestionario</code>.
	 *
	 * @param etlaQuestionario 
	 */
	public void setEtlaQuestionario(EstudoTecnicoLevantamentoAlternativaQuestionario etlaQuestionario) {
	
		this.etlaQuestionario = etlaQuestionario;
	}
    
}
