package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 05/01/2016 - 15:11:50
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Audited
@AuditTable(value = "cnt_et_recursohumano_aud")
@Entity
@Table(name="cnt_et_recursohumano")
@JsonIgnoreProperties({ "$index", "$checked" })
public class EstudoTecnicoRecursoHumano extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -5560984562308363541L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo estudoTecnico. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EstudoTecnico estudoTecnico;

	/** Atributo estudoTecnicoInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EstudoTecnico estudoTecnicoInativo;

	/** Atributo formacao. */
	@Column(length = 1000)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private String formacao;

	/** Atributo atividades. */
	@Column(length = 1000)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private String atividades;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}


	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}



	/**
	 * Retorna o valor do atributo <code>estudoTecnico</code>
	 *
	 * @return <code>EstudoTecnico</code>
	 */
	public EstudoTecnico getEstudoTecnico() {

		return estudoTecnico;
	}



	/**
	 * Define o valor do atributo <code>estudoTecnico</code>.
	 *
	 * @param estudoTecnico
	 */
	public void setEstudoTecnico(EstudoTecnico estudoTecnico) {

		this.estudoTecnico = estudoTecnico;
	}



	/**
	 * Retorna o valor do atributo <code>estudoTecnicoInativo</code>
	 *
	 * @return <code>EstudoTecnico</code>
	 */
	public EstudoTecnico getEstudoTecnicoInativo() {

		return estudoTecnicoInativo;
	}



	/**
	 * Define o valor do atributo <code>estudoTecnicoInativo</code>.
	 *
	 * @param estudoTecnicoInativo
	 */
	public void setEstudoTecnicoInativo(EstudoTecnico estudoTecnicoInativo) {

		this.estudoTecnicoInativo = estudoTecnicoInativo;
	}


	/**
	 * Retorna o valor do atributo <code>formacao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getFormacao() {

		return formacao;
	}


	/**
	 * Define o valor do atributo <code>formacao</code>.
	 *
	 * @param formacao
	 */
	public void setFormacao(String formacao) {

		this.formacao = formacao;
	}


	/**
	 * Retorna o valor do atributo <code>atividades</code>
	 *
	 * @return <code>String</code>
	 */
	public String getAtividades() {

		return atividades;
	}


	/**
	 * Define o valor do atributo <code>atividades</code>.
	 *
	 * @param atividade
	 */
	public void setAtividades(String atividades) {

		this.atividades = atividades;
	}

}
