package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 05/01/2016 - 15:10:01
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Audited
@AuditTable(value = "cnt_et_recursomaterial_aud")
@Entity
@Table(name="cnt_et_recursomaterial")
@JsonIgnoreProperties({ "$index", "$checked" })
public class EstudoTecnicoRecursoMaterial extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -5560984562308363541L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo estudoTecnico. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EstudoTecnico estudoTecnico;

	/** Atributo estudoTecnicoInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EstudoTecnico estudoTecnicoInativo;

	/** Atributo descricaoRecursoMaterial. */
	@Column(length = 1000)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private String descricaoRecursoMaterial;

	/** Atributo quantidade. */
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private Long quantidade;

	/** Atributo disponivel. */
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private Boolean disponivel;

	/** Atributo acaoObtencao. */
	@Column(length = 1000)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class })
	private String acaoObtencao;


	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}


	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}


	/**
	 * Retorna o valor do atributo <code>estudoTecnico</code>
	 *
	 * @return <code>EstudoTecnico</code>
	 */
	public EstudoTecnico getEstudoTecnico() {

		return estudoTecnico;
	}


	/**
	 * Define o valor do atributo <code>estudoTecnico</code>.
	 *
	 * @param estudoTecnico
	 */
	public void setEstudoTecnico(EstudoTecnico estudoTecnico) {

		this.estudoTecnico = estudoTecnico;
	}


	/**
	 * Retorna o valor do atributo <code>estudoTecnicoInativo</code>
	 *
	 * @return <code>EstudoTecnico</code>
	 */
	public EstudoTecnico getEstudoTecnicoInativo() {

		return estudoTecnicoInativo;
	}


	/**
	 * Define o valor do atributo <code>estudoTecnicoInativo</code>.
	 *
	 * @param estudoTecnicoInativo
	 */
	public void setEstudoTecnicoInativo(EstudoTecnico estudoTecnicoInativo) {

		this.estudoTecnicoInativo = estudoTecnicoInativo;
	}

	/**
	 * Retorna o valor do atributo <code>descricaoRecursoMaterial</code>
	 *
	 * @return <code>String</code>
	 */
	public String getDescricaoRecursoMaterial() {

		return descricaoRecursoMaterial;
	}


	/**
	 * Define o valor do atributo <code>descricaoRecursoMaterial</code>.
	 *
	 * @param descricaoRecursoMaterial
	 */
	public void setDescricaoRecursoMaterial(String descricaoRecursoMaterial) {

		this.descricaoRecursoMaterial = descricaoRecursoMaterial;
	}


	/**
	 * Retorna o valor do atributo <code>quantidade</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getQuantidade() {

		return quantidade;
	}


	/**
	 * Define o valor do atributo <code>quantidade</code>.
	 *
	 * @param quantidade
	 */
	public void setQuantidade(Long quantidade) {

		this.quantidade = quantidade;
	}


	/**
	 * Retorna o valor do atributo <code>disponivel</code>
	 *
	 * @return <code>Boolean</code>
	 */
	public Boolean getDisponivel() {

		return disponivel;
	}


	/**
	 * Define o valor do atributo <code>disponivel</code>.
	 *
	 * @param disponivel
	 */
	public void setDisponivel(Boolean disponivel) {

		this.disponivel = disponivel;
	}


	/**
	 * Retorna o valor do atributo <code>acaoObtencao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getAcaoObtencao() {

		return acaoObtencao;
	}


	/**
	 * Define o valor do atributo <code>acaoObtencao</code>.
	 *
	 * @param acaoObtencao
	 */
	public void setAcaoObtencao(String acaoObtencao) {

		this.acaoObtencao = acaoObtencao;
	}

}
