package br.com.centralit.api.model;

import java.util.Calendar;
import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;
import org.hibernate.envers.NotAudited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.JsonCalendarSimpleDateDeserializer;
import br.com.centralit.framework.model.Dominio;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;


/**
 * 
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 09/03/2016 - 18:07:56
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Audited
@AuditTable(value = "cnt_ev_atualizacaostatus_aud")
@Entity
@Table(name="cnt_ev_atualizacaostatus")
@JsonIgnoreProperties({ "$checked" })
public class EventoAtualizacaoStatus extends ContratoEvento {

    /** Atributo serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** Atributo tipoSituacaoAntiga. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JsonView({ ViewsContrato.EventoAtualizacaoStatusEditView.class })
    private Dominio tipoSituacaoAntiga;
	
    /** Atributo tipoSituacaoNova. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JsonView({ ViewsContrato.EventoAtualizacaoStatusEditView.class })
    private Dominio tipoSituacaoNova;
	
	/** Atributo justificativa. */
	@Column(length = 2000, nullable = false)
	@JsonView({ ViewsContrato.EventoAtualizacaoStatusEditView.class })
    private String justificativa;
	
	/** Atributo dataAtualizacao. */
    @Column(nullable = false)
	@Temporal(TemporalType.TIMESTAMP)
	@JsonDeserialize(using = JsonCalendarSimpleDateDeserializer.class)
    @JsonView({ ViewsContrato.EventoAtualizacaoStatusEditView.class })
	private Calendar dataAtualizacao;
    
    /** Atributo documentos. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "eventoAtualizacaoStatus", cascade = CascadeType.ALL, orphanRemoval = true)
	@JsonView({ ViewsContrato.EventoAtualizacaoStatusEditView.class })
	private Collection<EventoAtualizacaoStatusDocumento> documentos;

	/** Atributo observacoes. */
	@NotAudited
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "eventoAtualizacaoStatus", cascade = CascadeType.ALL, orphanRemoval = true)
	@JsonView({ ViewsContrato.EventoAtualizacaoStatusEditView.class })
	private Collection<EventoAtualizacaoStatusObservacao> observacoes;

	
	/**
	 * Retorna o valor do atributo <code>tipoSituacaoAntiga</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoSituacaoAntiga() {
	
		return tipoSituacaoAntiga;
	}

	
	/**
	 * Define o valor do atributo <code>tipoSituacaoAntiga</code>.
	 *
	 * @param tipoSituacaoAntiga 
	 */
	public void setTipoSituacaoAntiga(Dominio tipoSituacaoAntiga) {
	
		this.tipoSituacaoAntiga = tipoSituacaoAntiga;
	}

	
	/**
	 * Retorna o valor do atributo <code>tipoSituacaoNova</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getTipoSituacaoNova() {
	
		return tipoSituacaoNova;
	}

	
	/**
	 * Define o valor do atributo <code>tipoSituacaoNova</code>.
	 *
	 * @param tipoSituacaoNova 
	 */
	public void setTipoSituacaoNova(Dominio tipoSituacaoNova) {
	
		this.tipoSituacaoNova = tipoSituacaoNova;
	}

	
	/**
	 * Retorna o valor do atributo <code>justificativa</code>
	 *
	 * @return <code>String</code>
	 */
	public String getJustificativa() {
	
		return justificativa;
	}

	
	/**
	 * Define o valor do atributo <code>justificativa</code>.
	 *
	 * @param justificativa 
	 */
	public void setJustificativa(String justificativa) {
	
		this.justificativa = justificativa;
	}

	
	/**
	 * Retorna o valor do atributo <code>dataAtualizacao</code>
	 *
	 * @return <code>Calendar</code>
	 */
	public Calendar getDataAtualizacao() {
	
		return dataAtualizacao;
	}

	
	/**
	 * Define o valor do atributo <code>dataAtualizacao</code>.
	 *
	 * @param dataAtualizacao 
	 */
	public void setDataAtualizacao(Calendar dataAtualizacao) {
	
		this.dataAtualizacao = dataAtualizacao;
	}

	
	/**
	 * Retorna o valor do atributo <code>documentos</code>
	 *
	 * @return <code>Collection<EventoAtualizacaoStatusDocumento></code>
	 */
	public Collection<EventoAtualizacaoStatusDocumento> getDocumentos() {
	
		return documentos;
	}

	
	/**
	 * Define o valor do atributo <code>documentos</code>.
	 *
	 * @param documentos 
	 */
	public void setDocumentos(Collection<EventoAtualizacaoStatusDocumento> documentos) {
	
		this.documentos = documentos;
	}

	
	/**
	 * Retorna o valor do atributo <code>observacoes</code>
	 *
	 * @return <code>Collection<EventoAtualizacaoStatusObservacao></code>
	 */
	public Collection<EventoAtualizacaoStatusObservacao> getObservacoes() {
	
		return observacoes;
	}

	
	/**
	 * Define o valor do atributo <code>observacoes</code>.
	 *
	 * @param observacoes 
	 */
	public void setObservacoes(Collection<EventoAtualizacaoStatusObservacao> observacoes) {
	
		this.observacoes = observacoes;
	}

}
