package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governan&ccedil;a Corporativa -
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * @version 1.0.0
 *
 * @author erick.sato
 *
 */
@Audited
@AuditTable(value = "cnt_lp_documento_aud")
@Entity
@Table(name = "cnt_lp_documento")
@JsonIgnoreProperties({ "uploadsDocumento", "$uuid", "$checked", "$index","size", "name", "$error" })
public class EventoLiberacaoPagamentoDocumento extends Documento {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EventoLiberacaoPagamento liberacaoPagamento;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EventoLiberacaoPagamento liberacaoPagamentoInativo;

	public EventoLiberacaoPagamento getLiberacaoPagamento() {
		return liberacaoPagamento;
	}

	public void setLiberacaoPagamento(EventoLiberacaoPagamento liberacaoPagamento) {
		this.liberacaoPagamento = liberacaoPagamento;
	}

	public EventoLiberacaoPagamento getLiberacaoPagamentoInativo() {
		return liberacaoPagamentoInativo;
	}

	public void setLiberacaoPagamentoInativo(
			EventoLiberacaoPagamento liberacaoPagamentoInativo) {
		this.liberacaoPagamentoInativo = liberacaoPagamentoInativo;
	}

}
