package br.com.centralit.api.model;

import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.MoneyDeserializer;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 09/03/2016 - 11:27:42
 *
 * @version 1.0.0
 *
 * @author erick.sato
 *
 */
@Audited
@AuditTable(value = "cnt_lp_empenho_aud")
@Entity
@Table(name = "cnt_lp_empenho")
public class EventoLiberacaoPagamentoEmpenho extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private EventoLiberacaoPagamento liberacaoPagamento;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	private ContratoEmpenho contratoEmpenho;

	@Column(name = "valorExecutado", precision = 20, scale = 4, nullable = true)
	@JsonDeserialize(using = MoneyDeserializer.class)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	private BigDecimal valorExecutado;

	@Column(name = "valorLiberado", precision = 20, scale = 4, nullable = true)
	@JsonDeserialize(using = MoneyDeserializer.class)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	private BigDecimal valorLiberado;

	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	@Column(name = "percentualExecutado", precision = 20, scale = 4, nullable = true)
	private BigDecimal percentualExecutado;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public EventoLiberacaoPagamento getLiberacaoPagamento() {
		return liberacaoPagamento;
	}

	public void setLiberacaoPagamento(EventoLiberacaoPagamento liberacaoPagamento) {
		this.liberacaoPagamento = liberacaoPagamento;
	}

	public ContratoEmpenho getContratoEmpenho() {
		return contratoEmpenho;
	}

	public void setContratoEmpenho(ContratoEmpenho contratoEmpenho) {
		this.contratoEmpenho = contratoEmpenho;
	}

	public BigDecimal getValorLiberado() {
		return valorLiberado;
	}

	public void setValorLiberado(BigDecimal valorLiberado) {
		this.valorLiberado = valorLiberado;
	}

	public BigDecimal getPercentualExecutado() {
		return percentualExecutado;
	}

	public void setPercentualExecutado(BigDecimal percentualExecutado) {
		this.percentualExecutado = percentualExecutado;
	}

	public BigDecimal getValorExecutado() {
		return valorExecutado;
	}

	public void setValorExecutado(BigDecimal valorExecutado) {
		this.valorExecutado = valorExecutado;
	}

}
