package br.com.centralit.api.model;

import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.MoneyDeserializer;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 09/03/2016 - 11:27:42
 *
 * @version 1.0.0
 *
 * @author erick.sato
 *
 */
@Audited
@AuditTable(value = "cnt_lp_odfornecimento_aud")
@Entity
@Table(name = "cnt_lp_ordemfornecimento")
public class EventoLiberacaoPagamentoOrdemFornecimento extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private EventoLiberacaoPagamento liberacaoPagamento;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	private OrdemFornecimento ordemFornecimento;

	@Column(name = "valorTotalOS", precision = 20, scale = 4, nullable = true)
	@JsonDeserialize(using = MoneyDeserializer.class)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	private BigDecimal valorTotalOS;

	@Column(name = "valorGlosa", precision = 20, scale = 4, nullable = true)
	@JsonDeserialize(using = MoneyDeserializer.class)
	@JsonView({ ViewsContrato.EventoLiberacaoPagamentoView.class })
	private BigDecimal valorGlosa;

	public EventoLiberacaoPagamento getLiberacaoPagamento() {
		return liberacaoPagamento;
	}

	public void setLiberacaoPagamento(EventoLiberacaoPagamento liberacaoPagamento) {
		this.liberacaoPagamento = liberacaoPagamento;
	}

	public OrdemFornecimento getOrdemFornecimento() {
		return ordemFornecimento;
	}

	public void setOrdemFornecimento(OrdemFornecimento ordemFornecimento) {
		this.ordemFornecimento = ordemFornecimento;
	}

	public BigDecimal getValorTotalOS() {
		return valorTotalOS;
	}

	public void setValorTotalOS(BigDecimal valorTotalOS) {
		this.valorTotalOS = valorTotalOS;
	}

	public BigDecimal getValorGlosa() {
		return valorGlosa;
	}

	public void setValorGlosa(BigDecimal valorGlosa) {
		this.valorGlosa = valorGlosa;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

}
