package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAudit;

import com.fasterxml.jackson.annotation.JsonView;


/**
 * 
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 15/03/2016 - 15:45:20
 *
 * @version 1.0.0
 *
 * @author luis.camargo
 *
 */
@Audited
@AuditTable(value = "cnt_pn_regocorrencia_aud")
@Entity
@Table(name="cnt_pn_registroocorrencia")
public class EventoPenalidadeRegistroOcorrencia extends PersistentObjectAudit {

	private static final long serialVersionUID = 4225378051914710550L;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ Views.GenericView.class })
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private EventoPenalidade eventoPenalidade;

    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JsonView({ ViewsContrato.EventoPenalidadeEditView.class })
    private RegistroOcorrencia registroOcorrencia;
    
	@Override
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}
	
	public EventoPenalidade getEventoPenalidade() {
		return eventoPenalidade;
	}

	public void setEventoPenalidade(EventoPenalidade eventoPenalidade) {
		this.eventoPenalidade = eventoPenalidade;
	}

	public RegistroOcorrencia getRegistroOcorrencia() {
		return registroOcorrencia;
	}

	public void setRegistroOcorrencia(RegistroOcorrencia registroOcorrencia) {
		this.registroOcorrencia = registroOcorrencia;
	}

}