package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governan&ccedil;a Corporativa - </p>
 *
 * <p><b>Description: </b></p>
 *
 * @since 16/03/2016 - 14:47:39
 * @version 1.0.0
 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
 *
 */

//@Entity
//@Table(name = "cnt_ev_ro_avaliacao")
@JsonIgnoreProperties({ "$checked", "$index" })
public class EventoRecebimentoObjetoAvaliacao extends PersistentObjectAuditOrganizacao{

	private static final long serialVersionUID = -7198161560292230107L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ ViewsContrato.EventoRecebimentoObjetoEditView.class })
	private Long id;

	@OneToMany(fetch = FetchType.LAZY)
	@JsonView({ ViewsContrato.EventoRecebimentoObjetoEditView.class })
	private Collection<Dominio> tipoAvaliacao;


	public Long getId() {

		return id;
	}


	public void setId(Long id) {

		this.id = id;
	}

	public Collection<Dominio> getTipoAvaliacao() {

		return tipoAvaliacao;
	}


	public void setTipoAvaliacao(Collection<Dominio> tipoAvaliacao) {

		this.tipoAvaliacao = tipoAvaliacao;
	}

}
