package br.com.centralit.api.model;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 24/02/2016 - 08:39:42
 *
 * @version 1.0.0
 *
 * @author erick.sato
 *
 */
@Audited
@AuditTable(value = "cnt_n_ocorrencia_aud")
@Entity
@Table(name="cnt_n_ocorrencia")
public class NotificacaoContratoOcorrencia extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private NotificacaoContrato notificacaoContrato;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private NotificacaoContrato notificacaoContratoInativo;

	@ManyToOne(fetch = FetchType.LAZY, optional = false, cascade = CascadeType.ALL)
	@JsonView(Views.GenericView.class)
	private RegistroOcorrencia registroOcorrencia;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public NotificacaoContrato getNotificacaoContrato() {
		return notificacaoContrato;
	}

	public void setNotificacaoContrato(NotificacaoContrato notificacaoContrato) {
		this.notificacaoContrato = notificacaoContrato;
	}

	public NotificacaoContrato getNotificacaoContratoInativo() {
		return notificacaoContratoInativo;
	}

	public void setNotificacaoContratoInativo(
			NotificacaoContrato notificacaoContratoInativo) {
		this.notificacaoContratoInativo = notificacaoContratoInativo;
	}

	public RegistroOcorrencia getRegistroOcorrencia() {
		return registroOcorrencia;
	}

	public void setRegistroOcorrencia(RegistroOcorrencia registroOcorrencia) {
		this.registroOcorrencia = registroOcorrencia;
	}

}
