package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * @author luis.camargo
 *
 */
@Audited
@AuditTable(value = "cnt_objetivoestrategico_aud")
@Entity
@Table(name="cnt_objetivoestrategico")
public class ObjetivoEstrategico extends PersistentObjectAuditOrganizacao {

	private static final long serialVersionUID = 8703626607908442443L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class})
	private Long id;

	@Column(length = 150, nullable=false)
	@JsonView({ ViewsContrato.EstudoTecnicoEditView.class, ViewsContrato.ObjetivoEstrategicoListView.class, ViewsContrato.ObjetivoEstrategicoNecessidadeSelectView.class, Views.GenericView.class })
	private String nome;

	@Column(length = 500, nullable=false)
	@JsonView({ ViewsContrato.ObjetivoEstrategicoEditView.class, ViewsContrato.ObjetivoEstrategicoNecessidadeSelectView.class, Views.GenericView.class })
	private String descricao;

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "objetivoEstrategico", orphanRemoval = true)
	@JsonView({ ViewsContrato.ObjetivoEstrategicoEditView.class})
	private Collection<ObjetivoEstrategicoNecessidade> necessidadesElencadas;

	@Transient
	@JsonView({ ViewsContrato.ObjetivoEstrategicoNecessidadeSelectView.class, Views.GenericView.class})
	private String necessidadeElecandasDesricao;

	@Override
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getDescricao() {
		return descricao;
	}

	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}

	public Collection<ObjetivoEstrategicoNecessidade> getNecessidadesElencadas() {
		return necessidadesElencadas;
	}

	public void setNecessidadesElencadas(
			Collection<ObjetivoEstrategicoNecessidade> necessidadesElencadas) {
		this.necessidadesElencadas = necessidadesElencadas;
	}

	public String getNecessidadeElecandasDesricao() {
		return necessidadeElecandasDesricao;
	}

	public void setNecessidadeElecandasDesricao(String necessidadeElecandasDesricao) {
		this.necessidadeElecandasDesricao = necessidadeElecandasDesricao;
	}

}
