package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * @author luis.camargo
 *
 */
@Audited
@AuditTable(value = "cnt_oe_necessidade_aud")
@Entity
@Table(name="cnt_oe_necessidade")
@JsonIgnoreProperties({ "$selected", "$index" })
public class ObjetivoEstrategicoNecessidade extends PersistentObjectAuditOrganizacao {


	private static final long serialVersionUID = -44646104212425014L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;
	
	@Column(length = 500, nullable=false)
	@JsonView({ ViewsContrato.ObjetivoEstrategicoEditView.class, ViewsContrato.ObjetivoEstrategicoNecessidadeSelectView.class, ViewsContrato.EstudoTecnicoEditView.class,
		ViewsContrato.TermoReferenciaEditView.class, ViewsContrato.ObjetivoEstrategicoEditView.class })
	private String descricao;
	
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsContrato.ObjetivoEstrategicoNecessidadeSelectView.class, ViewsContrato.EstudoTecnicoEditView.class, ViewsContrato.ObjetivoEstrategicoNecessidadeEditView.class })
	private ObjetivoEstrategico objetivoEstrategico;
	
	@Override
	public Long getId() {
		return this.id;
	}

	public void setId(Long id) {
		this.id = id;
	}
	
	public String getDescricao() {
		return descricao;
	}

	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}

	public ObjetivoEstrategico getObjetivoEstrategico() {
		return objetivoEstrategico;
	}

	public void setObjetivoEstrategico(ObjetivoEstrategico objetivoEstrategico) {
		this.objetivoEstrategico = objetivoEstrategico;
	}
	
}
