package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 13/04/2015 - 14:18:56
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *	
 */
@Audited
@AuditTable(value = "cnt_qp_possivelresposta_aud")
@Entity
@Table(name="cnt_qp_possivelresposta")
@JsonIgnoreProperties({ "$selected", "$index" })
public class PossivelRespostaQuestionarioPergunta extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 4423036753044362571L;
	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;
	
	/** Atributo Nome. */
	@Column(length = 100)
	@JsonView({ Views.GenericView.class })
	private String resposta;
	
	/** Atributo questionarioPergunta. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private QuestionarioPergunta questionarioPergunta;
	
	/** Atributo questionarioPerguntaInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private QuestionarioPergunta questionarioPerguntaInativo;

	public PossivelRespostaQuestionarioPergunta() {
		super();
	}

	public PossivelRespostaQuestionarioPergunta( String resposta ) {
		super();
		this.resposta = resposta;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>resposta</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getResposta() {
	
		return resposta;
	}

	/**
	 * Define o valor do atributo <code>resposta</code>.
	 * 
	 * @param resposta
	 */
	public void setResposta(String resposta) {
	
		this.resposta = resposta;
	}
	
	/**
	 * Retorna o valor do atributo <code>questionarioPergunta</code>
	 * 
	 * @return <code>QuestionarioPergunta</code>
	 */
	public QuestionarioPergunta getQuestionarioPergunta() {
	
		return questionarioPergunta;
	}

	/**
	 * Define o valor do atributo <code>questionarioPergunta</code>.
	 * 
	 * @param questionarioPergunta
	 */
	public void setQuestionarioPergunta(QuestionarioPergunta questionarioPergunta) {
	
		this.questionarioPergunta = questionarioPergunta;
	}

	/**
	 * Retorna o valor do atributo <code>questionarioPerguntaInativo</code>
	 * 
	 * @return <code>QuestionarioPergunta</code>
	 */
	public QuestionarioPergunta getQuestionarioPerguntaInativo() {
	
		return questionarioPerguntaInativo;
	}

	/**
	 * Define o valor do atributo <code>questionarioPerguntaInativo</code>.
	 * 
	 * @param questionarioPerguntaInativo
	 */
	public void setQuestionarioPerguntaInativo(QuestionarioPergunta questionarioPerguntaInativo) {
	
		this.questionarioPerguntaInativo = questionarioPerguntaInativo;
	}
}
