package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * @author luis.camargo
 *
 */
@Audited
@AuditTable(value = "cnt_programa_aud")
@Entity
@Table(name="cnt_programa")
public class Programa extends PersistentObjectAuditOrganizacao {

	private static final long serialVersionUID = 4228144398530225322L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@Column(length = 4, nullable=true)
	@JsonView({ ViewsContrato.ProgramaEditView.class, ViewsContrato.ProgramaAutoCompleteView.class })
	private Integer anoExercicio;

	@Column(length = 4, nullable=false)
	@JsonView({ ViewsContrato.ProgramaEditView.class, ViewsContrato.ProgramaAutoCompleteView.class, ViewsContrato.ContratoEditView.class})
	private String codigo;

	@Column(length = 150, nullable=false)
	@JsonView({ ViewsContrato.ProgramaEditView.class, ViewsContrato.ProgramaAutoCompleteView.class, ViewsContrato.ContratoEditView.class })
	private String nome;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsContrato.ProgramaEditView.class})
	private Dominio dominioTipoPrograma;

	@OneToMany(fetch = FetchType.LAZY, mappedBy = "programa")
	@JsonView({ ViewsContrato.ProgramaEditView.class, ViewsContrato.ProgramaAutoCompleteView.class })
	private Collection<ProgramaAcao> acoes;

	@Override
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Integer getAnoExercicio() {
		return anoExercicio;
	}
	
	public void setAnoExercicio(Integer anoExercicio) {
		this.anoExercicio = anoExercicio;
	}

	public String getCodigo() {
		return codigo;
	}

	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public Dominio getDominioTipoPrograma() {
		return dominioTipoPrograma;
	}

	public void setDominioTipoPrograma(Dominio dominioTipoPrograma) {
		this.dominioTipoPrograma = dominioTipoPrograma;
	}

	public Collection<ProgramaAcao> getAcoes() {
		return acoes;
	}

	public void setAcoes(Collection<ProgramaAcao> acoes) {
		this.acoes = acoes;
	}

}
