package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * @author luis.camargo
 *
 */
@Audited
@AuditTable(value = "cnt_p_acao_aud")
@Entity
@Table(name="cnt_p_acao")
@JsonIgnoreProperties({ "$selected", "$index" })
public class ProgramaAcao extends PersistentObjectAuditOrganizacao {

	private static final long serialVersionUID = 787553302509067126L;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	@Column(length = 4, nullable=false)
	@JsonView({ ViewsContrato.ProgramaEditView.class, ViewsContrato.ProgramaAcaoAutoCompleteView.class, ViewsContrato.ContratoEditView.class, ViewsContrato.ProgramaAutoCompleteView.class })
	private String codigo;

	@Column(length = 150, nullable=false)
	@JsonView({ ViewsContrato.ProgramaEditView.class, ViewsContrato.ProgramaAcaoAutoCompleteView.class, ViewsContrato.ContratoEditView.class, ViewsContrato.ProgramaAutoCompleteView.class })
	private String nome;

	@Column(length = 500, nullable=true)
	@JsonView({ ViewsContrato.ProgramaEditView.class, ViewsContrato.ProgramaAcaoAutoCompleteView.class, ViewsContrato.ContratoEditView.class, ViewsContrato.ProgramaAutoCompleteView.class })
	private String descricao;

	@Column(length = 150, nullable=true)
	@JsonView({ ViewsContrato.ProgramaEditView.class, ViewsContrato.ContratoEditView.class })
	private String baseLegal;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsContrato.ContratoEditView.class })
	private Programa programa;

	@Override
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCodigo() {
		return codigo;
	}

	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getDescricao() {
		return descricao;
	}

	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}

	public String getBaseLegal() {
		return baseLegal;
	}

	public void setBaseLegal(String baseLegal) {
		this.baseLegal = baseLegal;
	}

	public Programa getPrograma() {
		return programa;
	}

	public void setPrograma(Programa programa) {
		this.programa = programa;
	}

}
