package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b> Questionario</p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">415</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 02/03/2015 - 08:51:45
 *
 * @version 1.0.0
 *
 * @author juliana.barbosa
 *	
 */
@Audited
@AuditTable(value = "cnt_questionario_aud")
@Entity
@Table(name="cnt_questionario")
public class Questionario extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = -5560984562308363541L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.QuestionarioAutoCompleteView.class, Views.QuestionarioListView.class, Views.GenericView.class })
	private Long id;

	/** Atributo Nome. */
	@Column(length = 100)
	@JsonView({ Views.QuestionarioAutoCompleteView.class, Views.QuestionarioListView.class, Views.GenericView.class })
	private String nome;
	
	/** Atributo dominioTipoResposta. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.QuestionarioEditView.class })
	private Dominio dominioTipoQuestionario;
	
	/** Atributo questoes. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "questionario", cascade = CascadeType.ALL)
	@JsonView({ Views.QuestionarioEditView.class })
	private Collection<QuestionarioPergunta> questoes;

	public Questionario() {
		super();
	}

	public Questionario( String nome, Dominio dominioTipoQuestionario, Collection<QuestionarioPergunta> questoes ) {
		super();
		this.nome = nome;
		this.dominioTipoQuestionario = dominioTipoQuestionario;
		this.questoes = questoes;
	}

	/**
	 * Retorna o valor do atributo <code>nome</code>
	 * 
	 * @return <code>String</code>
	 */
	public String getNome() {

		return nome;
	}

	/**
	 * Define o valor do atributo <code>nome</code>.
	 * 
	 * @param nome
	 */
	public void setNome(String nome) {

		this.nome = nome;
	}
	
	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>questoes</code>
	 * 
	 * @return <code>Collection<QuestionarioPergunta></code>
	 */
	public Collection<QuestionarioPergunta> getQuestoes() {
	
		return questoes;
	}

	/**
	 * Define o valor do atributo <code>questoes</code>.
	 * 
	 * @param questoes
	 */
	public void setQuestoes(Collection<QuestionarioPergunta> questoes) {
	
		this.questoes = questoes;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoQuestionario</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoQuestionario() {
	
		return dominioTipoQuestionario;
	}
	
	/**
	 * Define o valor do atributo <code>dominioTipoQuestionario</code>.
	 *
	 * @param dominioTipoQuestionario 
	 */
	public void setDominioTipoQuestionario(Dominio dominioTipoQuestionario) {
	
		this.dominioTipoQuestionario = dominioTipoQuestionario;
	}
}
