package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 09/04/2015 - 10:28:15
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Audited
@AuditTable(value = "cnt_q_pergunta_aud")
@Entity
@Table(name="cnt_q_pergunta")
@JsonIgnoreProperties({ "$selected", "$index" })
public class QuestionarioPergunta extends PersistentObjectAuditOrganizacao {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 6645274982880198939L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ Views.GenericView.class })
	private Long id;

	/** Atributo questao. */
	@Column(length = 500)
	@JsonView({ Views.GenericView.class })
	private String questao;

	/** Atributo dominioTipoResposta. */
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ Views.QuestionarioEditView.class, ViewsContrato.EstudoTecnicoEditView.class })
	private Dominio dominioTipoResposta;

	/** Atributo respostasMultiplaEscolha. */
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "questionarioPergunta", cascade = CascadeType.ALL)
	@JsonView({ Views.QuestionarioEditView.class })
	private Collection<PossivelRespostaQuestionarioPergunta> respostasEscolha;

	/** Atributo questionario. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private Questionario questionario;

	/** Atributo questionarioInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private Questionario questionarioInativo;

	/** Atributo etQuestionarioQuestao. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EstudoTecnicoQuestionario etQuestionario;

	/** Atributo etQuestionarioQuestaoInativo. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private EstudoTecnicoQuestionario etQuestionarioInativo;

	public QuestionarioPergunta() {
		super();
	}

	public QuestionarioPergunta( String questao, Dominio dominioTipoResposta, Collection<PossivelRespostaQuestionarioPergunta> respostasEscolha ) {
		super();
		this.questao = questao;
		this.dominioTipoResposta = dominioTipoResposta;
		this.respostasEscolha = respostasEscolha;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	/**
	 * Retorna o valor do atributo <code>questao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getQuestao() {

		return questao;
	}

	/**
	 * Define o valor do atributo <code>questao</code>.
	 *
	 * @param questao
	 */
	public void setQuestao(String questao) {

		this.questao = questao;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoResposta</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoResposta() {

		return dominioTipoResposta;
	}

	/**
	 * Define o valor do atributo <code>dominioTipoResposta</code>.
	 *
	 * @param dominioTipoResposta
	 */
	public void setDominioTipoResposta(Dominio dominioTipoResposta) {

		this.dominioTipoResposta = dominioTipoResposta;
	}

	/**
	 * Retorna o valor do atributo <code>respostasEscolha</code>
	 *
	 * @return <code>Collection<String></code>
	 */
	public Collection<PossivelRespostaQuestionarioPergunta> getRespostasEscolha() {

		return respostasEscolha;
	}

	/**
	 * Define o valor do atributo <code>respostasEscolha</code>.
	 *
	 * @param respostasMultiplaEscolha
	 */
	public void setRespostasEscolha(Collection<PossivelRespostaQuestionarioPergunta> respostasEscolha) {

		this.respostasEscolha = respostasEscolha;
	}

	/**
	 * Retorna o valor do atributo <code>questionario</code>
	 *
	 * @return <code>Questionario</code>
	 */
	public Questionario getQuestionario() {

		return questionario;
	}

	/**
	 * Define o valor do atributo <code>questionario</code>.
	 *
	 * @param questionario
	 */
	public void setQuestionario(Questionario questionario) {

		this.questionario = questionario;
	}

	/**
	 * Retorna o valor do atributo <code>questionarioInativo</code>
	 *
	 * @return <code>Questionario</code>
	 */
	public Questionario getQuestionarioInativo() {

		return questionarioInativo;
	}

	/**
	 * Define o valor do atributo <code>questionarioInativo</code>.
	 *
	 * @param questionarioInativo
	 */
	public void setQuestionarioInativo(Questionario questionarioInativo) {

		this.questionarioInativo = questionarioInativo;
	}


	/**
	 * Retorna o valor do atributo <code>etQuestionarioQuestao</code>
	 *
	 * @return <code>EstudoTecnicoQuestionarioQuestao</code>
	 */
	public EstudoTecnicoQuestionario getEtQuestionarioQuestao() {

		return etQuestionario;
	}


	/**
	 * Define o valor do atributo <code>etQuestionarioQuestao</code>.
	 *
	 * @param etQuestionarioQuestao
	 */
	public void setEtQuestionarioQuestao(EstudoTecnicoQuestionario etQuestionarioQuestao) {

		this.etQuestionario = etQuestionarioQuestao;
	}

}
