package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governan&ccedil;a Corporativa - </p>
 *
 * <p><b>Description: </b></p>
 *
 * @since 15/02/2016 - 14:27:35
 * @version 1.0.0
 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
 *
 */
@Audited
@AuditTable(value = "cnt_ro_documento_aud")
@Entity
@Table(name="cnt_ro_documento")
@JsonIgnoreProperties({ "uploadsDocumento", "$uuid", "$checked", "$index", "size", "name", "$error" })
public class RegistroOcorrenciaDocumento extends Documento {

	private static final long serialVersionUID = 6046201960186949835L;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private RegistroOcorrencia registroOcorrencia;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private RegistroOcorrencia registroOcorrenciaInativo;

	public RegistroOcorrencia getRegistroOcorrencia() {

		return registroOcorrencia;
	}


	public void setRegistroOcorrencia(RegistroOcorrencia registroOcorrencia) {

		this.registroOcorrencia = registroOcorrencia;
	}

	public RegistroOcorrencia getRegistroOcorrenciaInativo() {

		return registroOcorrenciaInativo;
	}

	public void setRegistroOcorrenciaInativo(RegistroOcorrencia registroOcorrenciaInativo) {

		this.registroOcorrenciaInativo = registroOcorrenciaInativo;
	}

}
