package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

import org.apache.commons.lang.StringUtils;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.json.Views;

import com.fasterxml.jackson.annotation.JsonView;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governan&ccedil;a Corporativa - </p>
 *
 * <p><b>Description: </b></p> entidade criada para separar as propriedades de numeros sequenciais que podem ser reutilizadas em outras
 * funcionalidades.
 *
 * @since 23/02/2016 - 15:18:34
 * @version 1.0.0
 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
 *
 */
@Embeddable
public class RegistroSequencial {

	@Column(name = "numeroSequencial", nullable = false)
	@JsonView({ Views.GenericView.class })
	private Long numeroSequencial;

	@Column(name = "sequencialAno", length = 20, nullable = false)
	@JsonView({ ViewsContrato.EventoPenalidadeEditView.class, Views.GenericView.class })
	private String sequencialAno;

	@Transient
	@JsonView({ ViewsContrato.EventoPenalidadeEditView.class, Views.GenericView.class })
	private String sequencialAnoFormatado;

	public RegistroSequencial() {};

	public RegistroSequencial( Long numeroSequencial, String sequencialAno ) {

		this.numeroSequencial = numeroSequencial;
		this.sequencialAno = sequencialAno;
	}

	public Long getNumeroSequencial() {

		return numeroSequencial;
	}

	public void setNumeroSequencial(Long numeroSequencial) {

		this.numeroSequencial = numeroSequencial;
	}

	public String getSequencialAno() {

		return sequencialAno;
	}

	public void setSequencialAno(String sequencialAno) {

		this.sequencialAno = sequencialAno;
	}

	public String getSequencialAnoFormatado() {
		if (StringUtils.isNotEmpty(sequencialAno)) {
			sequencialAnoFormatado = StringUtils.leftPad(sequencialAno, 9, '0');
			sequencialAnoFormatado = sequencialAnoFormatado.substring(0, 5).concat("/").concat(sequencialAnoFormatado.substring(5));
		}
		return sequencialAnoFormatado;
	}

	public void setSequencialAnoFormatado(String sequencialAnoFormatado) {
		this.sequencialAnoFormatado = sequencialAnoFormatado;
	}

}
