package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p> Termo Referencia Documento
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">2389</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 05/01/2016 - 17:50:58
 *
 * @version 1.0.0
 *
 * @author juliana.barbosa
 *	
 */
@Audited
@AuditTable(value = "cnt_tr_documento_aud")
@Entity
@JsonIgnoreProperties({ "uploadsDocumento", "$uuid", "$checked", "$index", "size", "name", "$error" })
@Table(name="cnt_tr_documento")
public class TermoReferenciaDocumento extends Documento {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 4810063162923776584L;

	/** Atributo entrada. */
	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private TermoReferencia termo;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	private TermoReferencia termoInativo;

	
	/**
	 * Retorna o valor do atributo <code>termo</code>
	 *
	 * @return <code>TermoReferencia</code>
	 */
	public TermoReferencia getTermo() {
	
		return termo;
	}

	
	/**
	 * Define o valor do atributo <code>termo</code>.
	 *
	 * @param termo 
	 */
	public void setTermo(TermoReferencia termo) {
	
		this.termo = termo;
	}

	
	/**
	 * Retorna o valor do atributo <code>termoInativo</code>
	 *
	 * @return <code>TermoReferencia</code>
	 */
	public TermoReferencia getTermoInativo() {
	
		return termoInativo;
	}

	
	/**
	 * Define o valor do atributo <code>termoInativo</code>.
	 *
	 * @param termoInativo 
	 */
	public void setTermoInativo(TermoReferencia termoInativo) {
	
		this.termoInativo = termoInativo;
	}


}
