package br.com.centralit.api.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;

import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p> Termo de Referencia - Sancao
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Redmine(s):</b> <a href="LINK_PORTAL">2389</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 05/01/2016 - 17:17:06
 *
 * @version 1.0.0
 *
 * @author juliana.barbosa
 *
 */
@Audited
@AuditTable(value = "cnt_tr_sancao_aud")
@Entity
@Table(name="cnt_tr_sancao")
@JsonIgnoreProperties({ "$checked", "$index" })
public class TermoReferenciaSancao extends PersistentObjectAuditOrganizacao {

    /** Atributo serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** Atributo id. */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ ViewsContrato.GenericView.class, ViewsContrato.TermoReferenciaSancaoEditView.class, ViewsContrato.EventoRegistroNaoConformidadeView.class })
    private Long id;


    @Column(length = 500, nullable=false)
    @JsonView({ ViewsContrato.TermoReferenciaEditView.class, ViewsContrato.TermoReferenciaSancaoEditView.class, ViewsContrato.EventoRegistroNaoConformidadeView.class, ViewsContrato.ContratoAutoCompleteView.class })
    private String descricao;

    @Column(length = 150, nullable=false)
    @JsonView({ ViewsContrato.TermoReferenciaEditView.class, ViewsContrato.TermoReferenciaSancaoEditView.class, ViewsContrato.EventoRegistroNaoConformidadeView.class, ViewsContrato.ContratoAutoCompleteView.class })
    private String sancao;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	//@JsonView({ViewsContrato.TermoReferenciaEditView.class })
	private TermoReferencia termo;

	@ManyToOne(fetch = FetchType.LAZY, optional = true)
	//@JsonView({ViewsContrato.TermoReferenciaEditView.class })
	@JoinColumn(name="termoinativo_id")
	private TermoReferencia termoInativo;

	@ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ ViewsContrato.GenericView.class })
    private Dominio dominioTipoSancao;

	/**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}



	/**
	 * Retorna o valor do atributo <code>termo</code>
	 *
	 * @return <code>TermoReferencia</code>
	 */
	public TermoReferencia getTermo() {

		return termo;
	}


	/**
	 * Define o valor do atributo <code>termo</code>.
	 *
	 * @param termo
	 */
	public void setTermo(TermoReferencia termo) {

		this.termo = termo;
	}


	/**
	 * Retorna o valor do atributo <code>termoInativo</code>
	 *
	 * @return <code>TermoReferencia</code>
	 */
	public TermoReferencia getTermoInativo() {

		return termoInativo;
	}


	/**
	 * Define o valor do atributo <code>termoInativo</code>.
	 *
	 * @param termoInativo
	 */
	public void setTermoInativo(TermoReferencia termoInativo) {

		this.termoInativo = termoInativo;
	}


	/**
	 * Retorna o valor do atributo <code>descricao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getDescricao() {

		return descricao;
	}


	/**
	 * Define o valor do atributo <code>descricao</code>.
	 *
	 * @param descricao
	 */
	public void setDescricao(String descricao) {

		this.descricao = descricao;
	}


	/**
	 * Retorna o valor do atributo <code>sancao</code>
	 *
	 * @return <code>String</code>
	 */
	public String getSancao() {

		return sancao;
	}


	/**
	 * Define o valor do atributo <code>sancao</code>.
	 *
	 * @param sancao
	 */
	public void setSancao(String sancao) {

		this.sancao = sancao;
	}

	public Dominio getDominioTipoSancao() {
		return dominioTipoSancao;
	}

	public void setDominioTipoSancao(Dominio dominioTipoSancao) {
		this.dominioTipoSancao = dominioTipoSancao;
	}

}
