package br.com.centralit.api.service;

import java.sql.Connection;
import java.util.Collection;
import java.util.Date;

import javax.servlet.http.HttpServletResponse;

import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperPrint;
import br.com.centralit.api.model.ContratoEmpenho;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.service.arquitetura.GenericService;

public interface ContratoEmpenhoService extends GenericService<ContratoEmpenho, Long> {

	/**
	 *
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por
	 *
	 * @author geovane.filho
	 *
	 * @param contratoId
	 * @return
	 */
	Collection<ContratoEmpenho> findAllByContrato(Long contratoId);

	void gerarPdfEmpenho(Long idEmpenho, boolean download, HttpServletResponse response);

	Collection<ContratoEmpenho> findEmpenhoParaLiberacao(Long contratoId);

	JasperPrint getJasperPrintEmpenho(Long id, Connection conn, Usuario usuarioLogado, String titulo) throws JRException;

	JasperPrint getJasperPrintRelatorioEmpenho(Long idContrato, Date dataInicial, Date dataFinal, 
			Connection conn, Usuario usuarioLogado, String titulo) throws JRException;

}
