package br.com.centralit.api.service;

import java.util.Collection;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import br.com.centralit.api.model.ContratoEvento;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 09/03/2016 - 11:39:02
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
public interface ContratoEventoService extends GenericService<ContratoEvento, Long> {

	/**
	 *
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por buscar todos os eventos acontecidos em um determinado contrato
	 *
	 * @author geovane.filho
	 *
	 * @param contratoId
	 * @return
	 */
	Collection<ContratoEvento> findAllByContrato(Long contratoId);

	Boolean removeEventoContrato(String justificativaRemocao, Long idEvento);

	Collection<ContratoEvento> findAllByContratoTipoEvento(Long contratoId, String tipoEvento);

	Collection<ContratoEvento> findAllByContratoIntervalDataEmissao(Long contratoId, Date dataInicial, Date dateFinal);

	void gerarTermos(Long[] tiposTermo, Long idContrato, Date dataInicial, Date dateFinal, boolean download,HttpServletResponse response);

	Collection<ContratoEvento> findAllByContratoTipoTermoDataEmissao(Long[] codigosTermo,Date dataInicial, Date dateFinal);

	void gerarRelatorios(Long[] arrayLong, Long idContrato, Date dataInicio, Date dataFim, boolean download,
			HttpServletResponse response);
}
