package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.ContratoItem;
import br.com.centralit.framework.service.arquitetura.GenericService;

public interface ContratoItemService extends GenericService<ContratoItem, Long> {
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">638</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsavel por buscar todos os itens de um contrato
	 *
	 * @author juliana.barbosa
	 *
	 * @param contratoId
	 * @return
	 */
	Collection<ContratoItem> findAllByContrato(Long contratoId);

	/**
	 * Método responsável por listar os itens de um contrato por nome
	 *
	 * @author luis.camargo
	 *
	 * @param nome
	 * @param idContrato
	 * 
	 * @return Collection<ContratoItem>
	 */
	Collection<ContratoItem> findAutoCompleteContratoItemByNomeAndContrato(String nome, Long idContrato);

}
