package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.Colaborador;
import br.com.centralit.api.model.Contrato;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 25/01/2016 - 15:23:44
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
public interface ContratoService extends GenericService<Contrato, Long> {


	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por buscar contratos a partir do numero/ano
	 *
	 * @author geovane.filho
	 *
	 * @param value
	 * @param idOrganizacao
	 * @return
	 */
	Collection<Contrato> findContrato(String numeroAnoContrato, Long idOrganizacao);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por buscar o gestor do contrato
	 *
	 * @author geovane.filho
	 *
	 * @param idContrato
	 * @return
	 */
	Colaborador getGestor(Long idContrato);

	/**
	 * Método responsável por listar contratos por numero e organizacao
	 *
	 * @author luis.camargo
	 *
	 * @param numeroAnoContrato
	 * @param idOrganizacao
	 *
	 * @return Collection<Contrato>
	 */
	Collection<Contrato> findAutoCompleteContratoByNumeroAndOrganizacao(String numeroAnoContrato, Long idOrganizacao);

	Collection<Contrato> findAutoCompleteContratoPorNumeroAndOrganizacao(String numeroAnoContrato, Long idOrganizacao);

}
