package br.com.centralit.api.service;

import java.sql.Connection;

import javax.servlet.http.HttpServletResponse;

import br.com.centralit.api.model.EventoApostilamento;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.service.arquitetura.GenericService;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperPrint;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governan&ccedil;a Corporativa - </p>
 *
 * <p><b>Description: </b></p>
 *
 * @since 10/03/2016 - 10:08:45
 * @version 1.0.0
 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
 *
 */
public interface EventoApostilamentoService extends GenericService<EventoApostilamento, Long>, RegistroSequencialInterface<EventoApostilamento> {

	/**
	 * M&eacute;todo respons&aacute;vel por gerar o relat&oacute;rio de apostilamento
	 *
	 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
	 * @param idApostilamento
	 * @param download
	 * @param response
	 */
	void gerarPdfApostilamento(Long idApostilamento, boolean download, HttpServletResponse response);

	JasperPrint getJasperPrintApostilamento(Long id, Connection conn, Usuario usuarioLogado, String titulo) throws JRException;

}
