package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.Programa;
import br.com.centralit.framework.service.arquitetura.GenericService;

public interface ProgramaService extends GenericService<Programa, Long> {

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por trazer todos os programas da organizacao do usuário logado.
	 *
	 * @author luis.camargo
	 *
	 * @param organizacaoId ID da organizacao a se buscar os programas
	 * @return
	 */
	Collection<Programa> findAllByOrganizacao(Long organizacaoId);

	/**
	 * Método responsável por listar programas por numero ou nome e organizacao
	 *
	 * @author iago.almeida
	 *
	 * @param numeroOrNome
	 * @param idOrganizacao
	 * @return Collection<Programa>
	 */
	Collection <Programa> findAutoCompleteProgramaByNumeroOrNomeAndOrganizacao(String numeroOrNome, Long idOrganizacao);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 * Método responsável por trazer um programa através do id do programa ação.
	 *
	 * @author luis.camargo
	 *
	 * @param idProgramaAcao
	 * @return
	 */
	Programa findByProgramaAcao(Long idProgramaAcao);

}
