package br.com.centralit.api.service;

import java.util.Collection;

import br.com.centralit.api.model.Questionario;
import br.com.centralit.framework.service.arquitetura.GenericService;

public interface QuestionarioService extends GenericService<Questionario, Long> {


	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por
	 *
	 * @author juliana.barbosa
	 *
	 * @param nome
	 * @return
	 */
	Collection<Questionario> listarQuestionarios(String nome);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por trazer todos os questionarios da organizacao do usuário logado.
	 *
	 * @author geovane.filho
	 *
	 * @param organizacaoId ID da organizacao a se buscar os questionarios
	 * @return
	 */
	Collection<Questionario> findAllByOrganizacao(Long organizacaoId);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por buscar todos os questionarios de um determinado tipo
	 *
	 * @author geovane.filho
	 *
	 * @param tipoQuestCodigo Codigo do tipo de questionario a ser buscado
	 * @param organizacaoId Organizacao a se buscar os questionarios
	 * @return
	 */
	Collection<Questionario> findAllByDominioTipoQuestionario(Long tipoQuestCodigo, Long organizacaoId);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por criar o questionário padrão utilizado no estudo técnico
	 *
	 * @author geovane.filho
	 *
	 * @return
	 */
	public Questionario createQuestionarioPadrao();
	
}
