package br.com.centralit.api.service.impl;

import java.util.Collection;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.ContratoEnvolvidoDao;
import br.com.centralit.api.model.ContratoEnvolvido;
import br.com.centralit.api.service.ContratoEnvolvidoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 04/02/2016 - 15:23:44
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Service("contratoEnvolvidoService")
public class ContratoEnvolvidoServiceImpl extends GenericServiceImpl<ContratoEnvolvido, Long> implements ContratoEnvolvidoService {

	/** Atributo contratoEnvolvidoDao. */
	private ContratoEnvolvidoDao contratoEnvolvidoDao;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param contratoEnvolvidoDao
	 * @param validator
	 */
	@Autowired
	public ContratoEnvolvidoServiceImpl(ContratoEnvolvidoDao contratoEnvolvidoDao) {

		this.dao = contratoEnvolvidoDao;

		this.contratoEnvolvidoDao = contratoEnvolvidoDao;
	}

	@Override
	public void removeByIdsList(List<Long> ids) {
		for (Long id : ids) {
			ContratoEnvolvido envolvido = this.find(id);
			envolvido.setContratoInativo(envolvido.getContrato());
			envolvido.setContrato(null);

			super.remove(envolvido);
		}
	}

	@Override
	public Collection<ContratoEnvolvido> findProfissionaisContrato(Long idContrato) {
		return this.contratoEnvolvidoDao.findProfissionaisContrato(idContrato);
	}

}
