package br.com.centralit.api.service.impl;

import java.util.ArrayList;
import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.ContratoItemDao;
import br.com.centralit.api.model.ContratoItem;
import br.com.centralit.api.service.ContratoItemService;
import br.com.centralit.api.service.ContratoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilColecao;

@Service("contratoItemService")
public class ContratoItemServiceImpl extends GenericServiceImpl<ContratoItem, Long> implements ContratoItemService {

    private ContratoItemDao contratoItemDao;

	@Autowired
	private ContratoService contratoService;

    @Autowired
	public ContratoItemServiceImpl(ContratoItemDao contratoItemDao) {
    	this.dao = contratoItemDao;
        this.contratoItemDao = contratoItemDao;
	}

	@Override
	public Collection<ContratoItem> findAllByContrato(Long contratoId) {

		Collection<ContratoItem> listaRescisoes = this.contratoItemDao.findAllByContrato(contratoId);

		return UtilColecao.isVazio(listaRescisoes) ? new ArrayList<ContratoItem>() : listaRescisoes;
	}
	
	/**
	 * Método responsável por listar os itens do contrato por nome
	 *
	 * @author luis.camargo
	 *
	 * @param nome
	 * @param idContrato
	 *
	 * @return Collection<ContratoItem>
	 */
	@Override
	public Collection<ContratoItem> findAutoCompleteContratoItemByNomeAndContrato(String nome, Long idContrato) {
		return contratoItemDao.findAutoCompleteContratoItemByNomeAndContrato(nome, idContrato);
	}	
}
