package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.EstudoTecnicoBeneficioEsperadoDao;
import br.com.centralit.api.model.EstudoTecnicoBeneficioEsperado;
import br.com.centralit.api.service.EstudoTecnicoBeneficioEsperadoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;



/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">2389</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 12/01/2016 - 11:59:59
 *
 * @version 1.0.0
 *
 * @author juliana.barbosa
 *	
 */
@Service("estudoTecnicoBeneficioEsperadoService")
public class EstudoTecnicoBeneficioEsperadoServiceImpl extends GenericServiceImpl<EstudoTecnicoBeneficioEsperado, Long> implements EstudoTecnicoBeneficioEsperadoService {

	/** Atributo estudoTecnicoDao. */
	private EstudoTecnicoBeneficioEsperadoDao estudoTecnicoBeneficioEsperadoDao;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param estudoTecnicoDao
	 * @param validator
	 */
	@Autowired
	public EstudoTecnicoBeneficioEsperadoServiceImpl( EstudoTecnicoBeneficioEsperadoDao estudoTecnicoBeneficioEsperadoDao) {

		this.dao = estudoTecnicoBeneficioEsperadoDao;

		this.estudoTecnicoBeneficioEsperadoDao = estudoTecnicoBeneficioEsperadoDao;	

	}

	@Override
	public boolean removeById(Long id){

		EstudoTecnicoBeneficioEsperado benefEsperado = this.find(id);

		if(benefEsperado != null){
			benefEsperado.setEstudoTecnicoInativo(benefEsperado.getEstudoTecnico());
			benefEsperado.setEstudoTecnico(null);

			return super.remove(benefEsperado);
		}

		return true;
	}

}
