package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.EstudoTecnicoRecursoMaterialDao;
import br.com.centralit.api.model.EstudoTecnicoRecursoMaterial;
import br.com.centralit.api.service.EstudoTecnicoRecursoMaterialService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * 
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 20/01/2016 - 09:54:38
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Service("estudoTecnicoRecursoMaterialService")
public class EstudoTecnicoRecursoMaterialServiceImpl extends GenericServiceImpl<EstudoTecnicoRecursoMaterial, Long> implements EstudoTecnicoRecursoMaterialService {

	/** Atributo estudoTecnicoRequisitoNegocioDao. */
	private EstudoTecnicoRecursoMaterialDao estudoTecnicoRecursoMaterialDao;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param estudoTecnicoDao
	 * @param validator
	 */
	@Autowired
	public EstudoTecnicoRecursoMaterialServiceImpl( EstudoTecnicoRecursoMaterialDao estudoTecnicoRecursoMaterialDao) {

		this.dao = estudoTecnicoRecursoMaterialDao;

		this.estudoTecnicoRecursoMaterialDao = estudoTecnicoRecursoMaterialDao;
	}
	
	@Override
	public boolean removeById(Long id){

		EstudoTecnicoRecursoMaterial recursoMat = this.find(id);

		if(recursoMat != null){
			recursoMat.setEstudoTecnicoInativo(recursoMat.getEstudoTecnico());
			recursoMat.setEstudoTecnico(null);

			return super.remove(recursoMat);
		}

		return true;
	}
}
