package br.com.centralit.api.service.impl;

import java.math.BigDecimal;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.EventoLiberacaoPagamentoEmpenhoDao;
import br.com.centralit.api.model.EventoLiberacaoPagamentoEmpenho;
import br.com.centralit.api.service.EventoLiberacaoPagamentoEmpenhoService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 *
 */
@Service("eventoLiberacaoPagamentoEmpenhoService")
public class EventoLiberacaoPagamentoEmpenhoServiceImpl extends GenericServiceImpl<EventoLiberacaoPagamentoEmpenho, Long> implements EventoLiberacaoPagamentoEmpenhoService {

	private EventoLiberacaoPagamentoEmpenhoDao eventoLiberacaoPagamentoEmpenhoDao;

	@Autowired
	public EventoLiberacaoPagamentoEmpenhoServiceImpl( EventoLiberacaoPagamentoEmpenhoDao eventoLiberacaoPagamentoEmpenhoDao) {
		this.dao = eventoLiberacaoPagamentoEmpenhoDao;
		this.eventoLiberacaoPagamentoEmpenhoDao = eventoLiberacaoPagamentoEmpenhoDao;
	}

	@Override
	public BigDecimal getValorTotalExecutadoEmpenho(Long empenhoId) {
		return this.eventoLiberacaoPagamentoEmpenhoDao.getValorTotalExecutadoEmpenho(empenhoId);
	}

	@Override
	public Boolean existeVinculoEmpenhoComLiberacaoPagamento(Long idEmpenho) {
		return this.eventoLiberacaoPagamentoEmpenhoDao.existeVinculoEmpenhoComLiberacaoPagamento(idEmpenho);
	}

}
