package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.PossivelRespostaQuestionarioPerguntaDao;
import br.com.centralit.api.model.PossivelRespostaQuestionarioPergunta;
import br.com.centralit.api.service.PossivelRespostaQuestionarioPerguntaService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;



@Service("possivelRespostaQuestionarioPerguntaService")
public class PossivelRespostaQuestionarioPerguntaServiceImpl extends GenericServiceImpl<PossivelRespostaQuestionarioPergunta, Long> implements PossivelRespostaQuestionarioPerguntaService {

	/** Atributo RegraEventoDao. */
	private PossivelRespostaQuestionarioPerguntaDao possivelRespostaQuestionarioPerguntaDao;	


	@Autowired
	public PossivelRespostaQuestionarioPerguntaServiceImpl( PossivelRespostaQuestionarioPerguntaDao possivelRespostaQuestionarioPerguntaDao) {

		this.dao = possivelRespostaQuestionarioPerguntaDao;

		this.possivelRespostaQuestionarioPerguntaDao = possivelRespostaQuestionarioPerguntaDao;

	}
	
	@Override
	public boolean removeById(Long id){

		//busca a questão
		PossivelRespostaQuestionarioPergunta possivelResposta = this.find(id);

		//Verifica se a possivel resposta não está nula
		if(possivelResposta != null){
			possivelResposta.setQuestionarioPerguntaInativo(possivelResposta.getQuestionarioPergunta());
			possivelResposta.setQuestionarioPergunta(null);

			return super.remove(possivelResposta);
		}

		return true;
	}

}
