package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.dao.QuestionarioPerguntaDao;
import br.com.centralit.api.model.QuestionarioPergunta;
import br.com.centralit.api.service.DominioService;
import br.com.centralit.api.service.QuestionarioPerguntaService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;



@Service("questionarioPerguntaService")
public class QuestionarioPerguntaServiceImpl extends GenericServiceImpl<QuestionarioPergunta, Long> implements QuestionarioPerguntaService {

	/** Atributo dominioService. */
	@Autowired
	private DominioService dominioService;

	/** Atributo RegraEventoDao. */
	private QuestionarioPerguntaDao questionarioPerguntaDao;	
	
	QuestionarioPergunta questionarioPergunta = new QuestionarioPergunta();


	@Autowired
	public QuestionarioPerguntaServiceImpl( QuestionarioPerguntaDao questionarioPerguntaDao) {

		this.dao = questionarioPerguntaDao;

		this.questionarioPerguntaDao = questionarioPerguntaDao;

	}
	
	@Override
	public boolean removeById(Long id){

		//busca a questão
		QuestionarioPergunta questao = this.find(id);

		//Verifica se a questao não está nula
		if(questao != null){
			questao.setQuestionarioInativo(questao.getQuestionario());
			questao.setQuestionario(null);

			return super.remove(questao);
		}

		return true;
	}

}
