package br.com.centralit.api.service.impl;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.TermoReferenciaPenalidadeDao;
import br.com.centralit.api.model.TermoReferenciaPenalidade;
import br.com.centralit.api.service.TermoReferenciaPenalidadeService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;



/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p> Termo Referencia
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">2359</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 06/01/2016 - 10:36:39
 *
 * @version 1.0.0
 *
 * @author juliana.barbosa
 *	
 */
@Service("termoReferenciaPenalidadeService")
public class TermoReferenciaPenalidadeServiceImpl extends GenericServiceImpl<TermoReferenciaPenalidade, Long> implements TermoReferenciaPenalidadeService {

	private TermoReferenciaPenalidadeDao termoReferenciaPenalidadeDao;
	
	@Autowired
	public TermoReferenciaPenalidadeServiceImpl( TermoReferenciaPenalidadeDao termoReferenciaPenalidadeDao, @Qualifier("termoReferenciaPenalidadeValidator") Validator validator ) {

		this.dao = termoReferenciaPenalidadeDao;

		this.termoReferenciaPenalidadeDao = termoReferenciaPenalidadeDao;

		this.validator = validator;
	}

	@Override
	public Collection<TermoReferenciaPenalidade> findAllByContrato(Long idContrato) {
		return termoReferenciaPenalidadeDao.findAllByContrato(idContrato);
	}
}
