package br.com.centralit.api.service.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.TermoReferenciaSancaoDao;
import br.com.centralit.api.model.ContratoItem;
import br.com.centralit.api.model.TermoReferencia;
import br.com.centralit.api.model.TermoReferenciaSancao;
import br.com.centralit.api.service.ContratoItemService;
import br.com.centralit.api.service.TermoReferenciaSancaoService;
import br.com.centralit.api.service.TermoReferenciaService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilColecao;



/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p> Termo Referencia
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">2359</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 06/01/2016 - 10:36:39
 *
 * @version 1.0.0
 *
 * @author juliana.barbosa
 *
 */
@Service("termoReferenciaSancaoService")
public class TermoReferenciaSancaoServiceImpl extends GenericServiceImpl<TermoReferenciaSancao, Long> implements TermoReferenciaSancaoService {

	private TermoReferenciaSancaoDao termoReferenciaSancaoDao;

	@Autowired
	private ContratoItemService contratoItemService;

	@Autowired
	private TermoReferenciaService termoReferenciaService;

	@Autowired
	public TermoReferenciaSancaoServiceImpl( TermoReferenciaSancaoDao termoReferenciaSancaoDao, @Qualifier("termoReferenciaSancaoValidator") Validator validator ) {

		this.dao = termoReferenciaSancaoDao;

		this.termoReferenciaSancaoDao = termoReferenciaSancaoDao;

		this.validator = validator;
	}

	@Override
	public Collection<TermoReferenciaSancao> buscaSancoesContrato(Long idContrato) {
		return this.termoReferenciaSancaoDao.buscaSancoesTermo(idContrato);
	}


}
