package br.com.centralit.api.service.validation;

import br.com.centralit.api.model.ContratoEmpenho;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.framework.exception.CodigoErro;

@Component("contratoEmpenhoValidator")
public class ContratoEmpenhoValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return ContratoEmpenho.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
        
        ValidationUtils.rejectIfEmpty(errors, "contrato", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.CONTRATO");
                   
        ValidationUtils.rejectIfEmpty(errors, "data", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DATA");
                   
        ValidationUtils.rejectIfEmpty(errors, "numero", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.NUMERO");
                   
        ValidationUtils.rejectIfEmpty(errors, "valor", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.VALOR");
                   
        ValidationUtils.rejectIfEmpty(errors, "objetivo", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.OBJETIVO");
                   
	}
}

