package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.CronogramaExecucaoItem;
import br.com.centralit.framework.exception.CodigoErro;
import br.com.centralit.framework.util.UtilColecao;

@Component("cronogramaExecucaoItemValidator")
public class CronogramaExecucaoItemValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return CronogramaExecucaoItem.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
        
		ValidationUtils.rejectIfEmpty(errors, "pagamentoParcelado", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.LABEL.PAGAMENTO_PARCELADO");
		
		CronogramaExecucaoItem cronogramaExecucaoItem = (CronogramaExecucaoItem) target;
		if (UtilColecao.isVazio(cronogramaExecucaoItem.getParcelas())) {

			errors.rejectValue("parcelas", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.LABEL.ITENS_CRONOGRAMA");
		} 
	}

}

