package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.CronogramaExecucao;
import br.com.centralit.framework.exception.CodigoErro;
import br.com.centralit.framework.util.UtilColecao;

@Component("cronogramaExecucaoValidator")
public class CronogramaExecucaoValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return CronogramaExecucao.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
        
//		ValidationUtils.rejectIfEmpty(errors, "codigo", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.LABEL.CODIGO_CRONOGRAMA");
		ValidationUtils.rejectIfEmpty(errors, "contrato", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.NUMERO_ANO_CONTRATO");
		
		CronogramaExecucao cronogramaExecucao = (CronogramaExecucao) target;
		if (UtilColecao.isVazio(cronogramaExecucao.getItensCronogramaExecucao())) {

			errors.rejectValue("itensCronogramaExecucao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.LABEL.ITENS_CRONOGRAMA");
		}
	}
}

