package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.EncerramentoContrato;
import br.com.centralit.framework.exception.CodigoErro;
import br.com.centralit.framework.util.UtilObjeto;

/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 24/02/2016 - 15:53:35
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Component("encerramentoContratoValidator")
public class EncerramentoContratoValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return EncerramentoContrato.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {

		ValidationUtils.rejectIfEmpty(errors, "contrato", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.NUM_CONTRATO");

		ValidationUtils.rejectIfEmpty(errors, "contratante", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.SELECIONE_CONTRATANTE");

		ValidationUtils.rejectIfEmpty(errors, "numTermo", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.NUM_TERMO_ANO");

		ValidationUtils.rejectIfEmpty(errors, "dataEmissao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DATA_EMISSAO");

		ValidationUtils.rejectIfEmpty(errors, "introducao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.INTRODUCAO");

		ValidationUtils.rejectIfEmpty(errors, "motivo", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.MOTIVO");

		ValidationUtils.rejectIfEmpty(errors, "encaminhamentos", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.ENCAMINHAMENTOS");

		ValidationUtils.rejectIfEmpty(errors, "decisao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DECISAO");

		EncerramentoContrato encerramento = (EncerramentoContrato) target;

		if (UtilObjeto.isReferencia(encerramento.getContrato()) && UtilObjeto.isReferencia(encerramento.getDataEmissao())) {
			if (encerramento.getDataEmissao().before(encerramento.getContrato().getDataUltimaVigenciaFinal())) {
				errors.rejectValue("dataEmissao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "VALIDACAO.DATA_EMISSAO_MENOR_VIGENCIA_FINAL");
			}
		}

	}
}

