package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.EventoRegistroNaoConformidade;
import br.com.centralit.framework.exception.CodigoErro;


/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 */
@Component("eventoRegistroNaoConformidadeValidator")
public class EventoRegistroNaoConformidadeValidator implements Validator {

	@Override
	public boolean supports(Class<?> clazz) {

		return EventoRegistroNaoConformidadeValidator.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {

		EventoRegistroNaoConformidade evento = (EventoRegistroNaoConformidade) target;

		ValidationUtils.rejectIfEmpty(errors, "dataNaoConformidade", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.REGISTRO_NAO_CONFORMIDADE.DATA");
		ValidationUtils.rejectIfEmpty(errors, "tipoNaoConformidade", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.REGISTRO_NAO_CONFORMIDADE.APLICAVEL");

		if (evento.getDataNaoConformidade() != null && evento.getContrato() != null && evento.getContrato().getDataVigenciaInicial() != null) {
			if(evento.getDataNaoConformidade().getTimeInMillis() < evento.getContrato().getDataVigenciaInicial().getTimeInMillis()
					|| evento.getDataNaoConformidade().getTimeInMillis() > evento.getContrato().getDataUltimaVigenciaFinal().getTimeInMillis()){

				errors.rejectValue("dataNaoConformidade", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.MSG.DATA_NAO_CONFORMIDADE_INVALIDA");
			}
		}

	}

}
