package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.NotificacaoContrato;
import br.com.centralit.framework.exception.CodigoErro;

@Component("notificacaoContratoValidator")
public class NotificacaoContratoValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return NotificacaoContrato.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {

		ValidationUtils.rejectIfEmpty(errors, "contrato", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "NOTIFICACAO_CONTRATO.NUMERO_CONTRATO_ABREV");
		ValidationUtils.rejectIfEmpty(errors, "emissao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "NOTIFICACAO_CONTRATO.DATA_EMISSAO");
		ValidationUtils.rejectIfEmpty(errors, "associarOcorrencia", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "NOTIFICACAO_CONTRATO.ASSOCIAR_OCORRENCIA");
		ValidationUtils.rejectIfEmpty(errors, "dominioTipoSancao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "NOTIFICACAO_CONTRATO.TIPO_SANCAO");
		ValidationUtils.rejectIfEmpty(errors, "descricao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "NOTIFICACAO_CONTRATO.DESCRICAO_NOTIFICACAO");

	}
}

