package br.com.centralit.api.service.validation;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.ObjetivoEstrategico;
import br.com.centralit.framework.exception.CodigoErro;

@Component("objetivoEstrategicoValidator")
public class ObjetivoEstrategicoValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return ObjetivoEstrategico.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {

		ValidationUtils.rejectIfEmpty(errors, "nome", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.NOME");
		ValidationUtils.rejectIfEmpty(errors, "descricao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DESCRICAO");

		ObjetivoEstrategico objetivoEstrategico = (ObjetivoEstrategico) target;
		if (CollectionUtils.isEmpty(objetivoEstrategico.getNecessidadesElencadas())) {

			errors.rejectValue("necessidadesElencadas", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.NECESSIDADES");
		}
	}
}

