package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.Programa;
import br.com.centralit.framework.exception.CodigoErro;
import br.com.centralit.framework.util.UtilColecao;

@Component("programaValidator")
public class ProgramaValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return Programa.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
        
		ValidationUtils.rejectIfEmpty(errors, "dominioTipoPrograma", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.LABEL.TIPO_PROGRAMA");
		ValidationUtils.rejectIfEmpty(errors, "codigo", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.LABEL.CODIGO_PROGRAMA");
		ValidationUtils.rejectIfEmpty(errors, "nome", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "CONTRATOS.LABEL.NOME_PROGRAMA");

		Programa programa = (Programa) target;
		if (UtilColecao.isVazio(programa.getAcoes())) {

			errors.rejectValue("acoes", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.ACOES_PROGRAMA");
		}
	}
}

