package br.com.centralit.api.service.validation;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.TermoReferencia;
import br.com.centralit.framework.exception.CodigoErro;



@Component("termoReferenciaValidator")
public class TermoReferenciaValidator implements Validator{
	@Override
	public boolean supports(Class<?> clazz) {

		return TermoReferenciaValidator.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {

		ValidationUtils.rejectIfEmpty(errors, "objetoContratacao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.OBJETO_CONTRATACAO");
		ValidationUtils.rejectIfEmpty(errors, "estudoTecnico", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.ESTUDO_TECNICO");
		ValidationUtils.rejectIfEmpty(errors, "deveresContratante", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DEVERES_RESPONSABILIDADES_CONTRATANTE");
		ValidationUtils.rejectIfEmpty(errors, "deveresContratada", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DEVERES_RESPONSABILIDADES_CONTRATADA");
		ValidationUtils.rejectIfEmpty(errors, "documentacaoMinima", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DOCUMENTACAO_MINIMA");
		ValidationUtils.rejectIfEmpty(errors, "empreitada", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.EMPREITADA");
		ValidationUtils.rejectIfEmpty(errors, "adjudicacaoObjeto", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.ADJUDICACAO");
		ValidationUtils.rejectIfEmpty(errors, "justificativa", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.JUSTIFICATIVA");
		ValidationUtils.rejectIfEmpty(errors, "modalidade", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.MODALIDADE");
		ValidationUtils.rejectIfEmpty(errors, "justificativaModalidade", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.JUSTIFICATIVA_MODALIDADE");

		TermoReferencia termoReferencia = (TermoReferencia) target;
		if(CollectionUtils.isEmpty(termoReferencia.getDetalhamentosSolucoes())){
			ValidationUtils.rejectIfEmpty(errors, "detalhamentosSolucoes", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "LABEL.DETALHAMENTO_SOLUCAO");
		}
	}
}
