package br.com.centralit.api.viewHelper;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;

import br.com.centralit.api.model.Contrato;
import br.com.centralit.api.model.ContratoEmpenho;
import br.com.centralit.api.model.ContratoEvento;
import br.com.centralit.framework.model.Dominio;

import com.fasterxml.jackson.annotation.JsonView;

/**
 *
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 09/03/2016 - 10:22:53
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
public class ContratoEventosVH implements Serializable {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1317225449654175547L;

	/** Atributo contrato. */
	@JsonView({ ViewsContrato.ContratoEventoListView.class })
	private Contrato contrato;

	/** Atributo eventos. */
	@JsonView({ ViewsContrato.ContratoEventoListView.class })
	private Collection<ContratoEvento> eventos;

	/** Atributo empenhos. */
	@JsonView({ ViewsContrato.ContratoEventoListView.class })
	private Collection<ContratoEmpenho> empenhos;

	@JsonView({ ViewsContrato.ContratoEventoListView.class })
	private Dominio tipoEvento;

	/**
	 *
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param contrato
	 * @param eventos
	 * @param totalOcorrencia
	 */
	public ContratoEventosVH(Contrato contrato,
			Collection<ContratoEvento> eventos, Integer totalOcorrencia) {
		super();
		this.contrato = contrato;
		this.eventos = eventos;
	}

	/**
	 *
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param contrato
	 * @param eventos
	 */
	public ContratoEventosVH(Contrato contrato,
			Collection<ContratoEvento> eventos,
			Collection<ContratoEmpenho> empenhos, Integer totalOcorrencia) {
		super();
		this.contrato = contrato;
		this.eventos = eventos;
		this.empenhos = empenhos;
	}

	/**
	 *
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param contrato
	 * @param eventos
	 */
	public ContratoEventosVH(Contrato contrato,
			Collection<ContratoEvento> eventos,
			Collection<ContratoEmpenho> empenhos) {
		super();
		this.contrato = contrato;
		this.eventos = eventos;
		this.empenhos = empenhos;
	}

	public ContratoEventosVH() {
		super();
	}

	/**
	 * Retorna o valor do atributo <code>contrato</code>
	 *
	 * @return <code>Contrato</code>
	 */
	public Contrato getContrato() {
		return contrato;
	}

	/**
	 * Define o valor do atributo <code>contrato</code>.
	 *
	 * @param contrato
	 */
	public void setContrato(Contrato contrato) {
		this.contrato = contrato;
	}

	/**
	 * Retorna o valor do atributo <code>eventos</code>
	 *
	 * @return <code>Collection<ContratoEvento></code>
	 */
	public Collection<ContratoEvento> getOcorrencias() {
		return eventos;
	}

	/**
	 * Define o valor do atributo <code>eventos</code>.
	 *
	 * @param eventos
	 */
	public void setOcorrencias(Collection<ContratoEvento> eventos) {
		this.eventos = eventos;
	}

	public Collection<ContratoEmpenho> getEmpenhos() {

		return empenhos;
	}

	public void setEmpenhos(Collection<ContratoEmpenho> empenhos) {

		this.empenhos = empenhos;
	}

	public Collection<ContratoEvento> getEventos() {
		return eventos;
	}

	public void setEventos(Collection<ContratoEvento> eventos) {
		this.eventos = eventos;
	}

	public Dominio getTipoEvento() {
		return tipoEvento;
	}

	public void setTipoEvento(Dominio tipoEvento) {
		this.tipoEvento = tipoEvento;
	}

	public void addEventos(ContratoEvento evento) {
		if(eventos == null){
			eventos = new ArrayList<ContratoEvento>();
		}
		eventos.add(evento);
	}

}
