package br.com.centralit.api.service.impl;

import java.util.HashSet;

import org.junit.Before;
import org.junit.BeforeClass;
import org.mockito.internal.util.reflection.Whitebox;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;

import br.com.centralit.framework.model.Organizacao;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.model.UsuarioPrivilegio;
import br.com.six2six.fixturefactory.loader.FixtureFactoryLoader;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 12/01/2016 - 15:07:49
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
public abstract class GenericServiceImplTest<T> {

	/** Atributo PACOTE_FIXTURE_TEMPLATE.
	 * Utilizado para armazenar o caminho dos templates criados
	 * */
	public static final String PACOTE_FIXTURE_TEMPLATE = "br.com.centralit.framework.test.utils";

	@BeforeClass
	public static void setUpGeneric() throws Exception {
		FixtureFactoryLoader.loadTemplates(PACOTE_FIXTURE_TEMPLATE);
	}

    @Before
    public void setUp() throws Exception {
        inicializarMocksDasDependencias();
    }
 
    protected void definirAtributo(T base, String atributo, Object valor) {
        Whitebox.setInternalState(base, atributo, valor);
    }

    protected abstract void inicializarMocksDasDependencias();
    
    protected UsernamePasswordAuthenticationToken getPrincipal() {

    	Organizacao organizacao = new Organizacao();
    	organizacao.setId(1L);
    	
        Usuario user = new Usuario();
        user.setUsername("admin");
        user.setPassword("admin");
        user.setUsuarioPrivilegios(new HashSet<UsuarioPrivilegio>());
		user.setOrganizacao(organizacao);

        UsernamePasswordAuthenticationToken authentication = 
                new UsernamePasswordAuthenticationToken(
                        user, 
                        user.getPassword(), 
                        user.getAuthorities());

        return authentication;
    }
}
