package br.com.centralit.framework.test.utils;

import java.text.SimpleDateFormat;

import br.com.centralit.api.model.Colaborador;
import br.com.centralit.api.model.EstudoTecnico;
import br.com.centralit.api.model.EstudoTecnicoAcaoContingencia;
import br.com.centralit.api.model.EstudoTecnicoBemServicoSolucao;
import br.com.centralit.api.model.EstudoTecnicoBeneficioEsperado;
import br.com.centralit.api.model.EstudoTecnicoLevantamentoAlternativas;
import br.com.centralit.api.model.EstudoTecnicoRecursoHumano;
import br.com.centralit.api.model.EstudoTecnicoRecursoMaterial;
import br.com.centralit.api.model.EstudoTecnicoRequisitoNegocio;
import br.com.six2six.fixturefactory.Fixture;
import br.com.six2six.fixturefactory.Rule;
import br.com.six2six.fixturefactory.loader.TemplateLoader;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 12/01/2016 - 14:50:22
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
public class EstudoTecnicoTemplateLoader implements TemplateLoader{

	@Override
    public void load() {

		Fixture.of(EstudoTecnico.class).addTemplate("valid", new Rule() {
			{
				add("numeroPortaria", random("06608000", "17720000"));
				add("dataInstituicaoEquipe", afterDate("2015-01-01", new SimpleDateFormat("yyyy-MM-dd")));
				add("integranteTecnico", one(Colaborador.class, "valid"));
				add("integranteRequisitante", one(Colaborador.class, "valid"));
				add("integranteAdministrativo", one(Colaborador.class, "valid"));
				add("descricaoSolucao", random("descricao de solucao do estudoTecnico 01", "descricao de solucao do estudoTecnico 02"));
				add("etRequisitosNegocio", has(2).of(EstudoTecnicoRequisitoNegocio.class, "valid"));
				add("requisitosTecnicos", random("requisitos tecnicos do estudoTecnico 01", "requisitos tecnicos do estudoTecnico 02"));
				add("requisitosCapacitacao", random("requisitos capacitacao do estudoTecnico 01", "requisitos capacitacao do estudoTecnico 02"));
				add("etLevantamentoAlternativas", has(2).of(EstudoTecnicoLevantamentoAlternativas.class, "valid"));
				add("descricaoJustificativaSolucao", random("descricaoJustificativaSolucao do estudoTecnico 01", "descricaoJustificativaSolucao do estudoTecnico 02"));
				add("roiJustificativaSolucao", random("descricaoJustificativaSolucao do estudoTecnico 01", "descricaoJustificativaSolucao do estudoTecnico 02"));
				add("etBensServicosSolucoes", has(2).of(EstudoTecnicoBemServicoSolucao.class, "valid"));
				add("etBeneficiosEsperados", has(2).of(EstudoTecnicoBeneficioEsperado.class, "valid"));
				add("descricaoNecessidadeAdqcaoAmbiente", random("descricaoJustificativaSolucao do estudoTecnico 01", "descricaoJustificativaSolucao do estudoTecnico 02"));
				add("etRecursosMateriais", has(2).of(EstudoTecnicoRecursoMaterial.class, "valid"));
				add("etRecursosHumanos", has(2).of(EstudoTecnicoRecursoHumano.class, "valid"));
				add("etAcoesContingencia", has(2).of(EstudoTecnicoAcaoContingencia.class, "valid"));
				add("observacoes", null);
				add("documentos", null);
				add("organizacao", null);
			}
		});
	}
}
