package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.Contrato;
import br.com.centralit.api.model.ContratoEnvolvido;
import br.com.centralit.api.service.ContratoEnvolvidoService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 04/02/2016 - 15:23:44
 *
 * @version 1.0.0
 *
 * @author iago.almeida
 *
 */
@Controller
@RequestMapping("/rest/contratoEnvolvido")
public class ContratoEnvolvidoController extends GenericController<ContratoEnvolvido> {

	/** Atributo contratoEnvolvidoService. */
	private ContratoEnvolvidoService contratoEnvolvidoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param contratoEnvolvidoService
	 */
	@Autowired
	public ContratoEnvolvidoController( ContratoEnvolvidoService contratoEnvolvidoService ) {

		super(contratoEnvolvidoService);

		this.contratoEnvolvidoService = contratoEnvolvidoService;
	}

	@RequestMapping(value = "/findProfissionaisContrato", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findProfissionaisContrato(@RequestParam(value = "idContrato") Long idContrato) {

		Collection<ContratoEnvolvido> listaProfissionaisContrato = this.contratoEnvolvidoService.findProfissionaisContrato(idContrato);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(listaProfissionaisContrato, Views.ContratoView.class);

		return responseBody;
	}
}
