package br.com.centralit.controller;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.jasperreports.engine.JRException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.CronogramaExecucao;
import br.com.centralit.api.service.CronogramaExecucaoService;
import br.com.centralit.api.service.DominioService;
import br.com.centralit.api.service.InternacionalizacaoService;
import br.com.centralit.api.service.UsuarioService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.controller.ReportController;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b> Monitor </p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">415</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 03/02/2015 - 15:29:58
 *
 * @version 1.0.0
 *
 * @author luis.camargo
 *
 */
@Controller
@RequestMapping("/rest/cronogramaExecucao")
public class CronogramaExecucaoController extends GenericController<CronogramaExecucao> {


	private CronogramaExecucaoService cronogramaExecucaoService;

	@Autowired
	private InternacionalizacaoService internacionalizacaoService;
	
	@Autowired
	private DominioService dominioService;
	
	@Autowired
	private ReportController reportController;

	@Autowired
	private UsuarioService usuarioService;


	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param cronogramaExecucaoService
	 */
	@Autowired
	public CronogramaExecucaoController(CronogramaExecucaoService cronogramaExecucaoService) {

		super(cronogramaExecucaoService);

		this.cronogramaExecucaoService = cronogramaExecucaoService;
	}

	
	/**
	 * 
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por gerar o relatório de cronograma de execução
	 *
	 * @author luis.camargo
	 *
	 * @param idCronograma
	 * @param download
	 * @param response
	 * @param request
	 * @throws SQLException
	 * @throws JRException
	 * @throws IOException
	 */
	@RequestMapping(method = RequestMethod.GET, value = "/gerarCronograma")
	@ResponseBody
	public void gerarCronogramaExecucao(@RequestParam(value="idCronograma") Long idCronograma, @RequestParam(value="download") boolean download, HttpServletResponse response,
			HttpServletRequest request) throws SQLException, JRException, IOException {

		cronogramaExecucaoService.gerarPDFCronogramaExecucao(idCronograma, download, response);

	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.CronogramaExecucaoListView> getListView() {

		return ViewsContrato.CronogramaExecucaoListView.class;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.CronogramaExecucaoEditView> getEditView() {

		return ViewsContrato.CronogramaExecucaoEditView.class;
	}
}
