package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import br.com.centralit.api.model.CronogramaExecucaoItem;
import br.com.centralit.api.service.CronogramaExecucaoItemService;
import br.com.centralit.api.service.UsuarioService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b> Monitor </p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">415</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 18/02/2015 - 15:34:58
 *
 * @version 1.0.0
 *
 * @author luis.camargo
 *
 */
@Controller
@RequestMapping("/rest/cronogramaExecucaoItem")
public class CronogramaExecucaoItemController extends GenericController<CronogramaExecucaoItem> {

	private CronogramaExecucaoItemService cronogramaExecucaoItemService;

	@Autowired
	private UsuarioService usuarioService;


	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param cronogramaExecucaoItemService
	 */
	@Autowired
	public CronogramaExecucaoItemController(CronogramaExecucaoItemService cronogramaExecucaoItemService) {

		super(cronogramaExecucaoItemService);

		this.cronogramaExecucaoItemService = cronogramaExecucaoItemService;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.CronogramaExecucaoItemListView> getListView() {

		return ViewsContrato.CronogramaExecucaoItemListView.class;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.CronogramaExecucaoItemEditView> getEditView() {

		return ViewsContrato.CronogramaExecucaoItemEditView.class;
	}
}
