package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import br.com.centralit.api.model.EstudoTecnicoBeneficioEsperado;
import br.com.centralit.api.service.EstudoTecnicoBeneficioEsperadoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.Views;



@Controller
@RequestMapping("/rest/estudoTecnicoBeneficioEsperado")
public class EstudoTecnicoBeneficioEsperadoController extends GenericController<EstudoTecnicoBeneficioEsperado>{

	/** Atributo estudoTecnicoService. */
	private EstudoTecnicoBeneficioEsperadoService estudoTecnicoBeneficioEsperadoService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param estudoTecnicoBeneficioEsperadoService
	 */
	@Autowired
	public EstudoTecnicoBeneficioEsperadoController(EstudoTecnicoBeneficioEsperadoService estudoTecnicoBeneficioEsperadoService) {

		super(estudoTecnicoBeneficioEsperadoService);

		this.estudoTecnicoBeneficioEsperadoService = estudoTecnicoBeneficioEsperadoService;
	}

	@Override
	public Class<Views.GenericView> getEditView() {

		return Views.GenericView.class;
	}

	@Override
	public Class<Views.GenericView> getListView() {

		return Views.GenericView.class;
	}

}
