package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import br.com.centralit.api.model.EstudoTecnicoRequisitoNegocio;
import br.com.centralit.api.service.EstudoTecnicoRequisitoNegocioService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.Views;



@Controller
@RequestMapping("/rest/estudoTecnicoRequisitoNegocio")
public class EstudoTecnicoRequisitoNegocioController extends GenericController<EstudoTecnicoRequisitoNegocio>{

	/** Atributo estudoTecnicoService. */
	private EstudoTecnicoRequisitoNegocioService estudoTecnicoRequisitoNegocioService;

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param estudoTecnicoRequisitoNegocioService
	 */
	@Autowired
	public EstudoTecnicoRequisitoNegocioController(EstudoTecnicoRequisitoNegocioService estudoTecnicoRequisitoNegocioService) {

		super(estudoTecnicoRequisitoNegocioService);

		this.estudoTecnicoRequisitoNegocioService = estudoTecnicoRequisitoNegocioService;
	}

	@Override
	public Class<Views.GenericView> getEditView() {

		return Views.GenericView.class;
	}

	@Override
	public Class<Views.GenericView> getListView() {

		return Views.GenericView.class;
	}

}
