package br.com.centralit.controller;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.http.HttpServletResponse;

import net.sf.jasperreports.engine.JRException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.EventoApostilamento;
import br.com.centralit.api.service.EventoApostilamentoService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;


/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governan&ccedil;a Corporativa - </p>
 *
 * <p><b>Description: </b></p>
 *
 * @since 10/03/2016 - 19:11:25
 * @version 1.0.0
 * @author ciro.junior (<a href="mailto:ciro.junior@centralit.com.br">ciro.junior@centralit.com.br</a>)
 *
 */
@Controller
@RequestMapping("/rest/eventoApostilamento")
public class EventoApostilamentoController extends GenericController<EventoApostilamento> {

	private EventoApostilamentoService eventoApostilamentoService;

	public EventoApostilamentoController() {
		super();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.EventoApostilamentoEditView> getEditView() {

		return ViewsContrato.EventoApostilamentoEditView.class;
	}

	@Autowired
	public EventoApostilamentoController (EventoApostilamentoService eventoApostilamentoService) {

		super(eventoApostilamentoService);
		this.eventoApostilamentoService = (EventoApostilamentoService) eventoApostilamentoService;
	}

	@ResponseBody
	@RequestMapping(method = RequestMethod.GET, value = "/pdfGerarApostilamento")
	public void gerarPdfApostilamento(@RequestParam(value = "idApostilamento") Long idApostilamento,
										@RequestParam(value = "download") boolean download, HttpServletResponse response)
										throws SQLException, JRException, IOException {

		eventoApostilamentoService.gerarPdfApostilamento (idApostilamento, download, response);
	}

}
