package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import br.com.centralit.api.model.EventoAtualizacaoStatus;
import br.com.centralit.api.service.EventoAtualizacaoStatusService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;

@Controller
@RequestMapping("/rest/eventoAtualizacaoStatus")
public class EventoAtualizacaoStatusController extends GenericController<EventoAtualizacaoStatus>{

	/** Atributo materialImagemService. */
	private EventoAtualizacaoStatusService eventoAtualizacaoStatusService;

	public EventoAtualizacaoStatusController() {
		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param eventoAtualizacaoStatusService
	 */
	@Autowired
	private EventoAtualizacaoStatusController( EventoAtualizacaoStatusService eventoAtualizacaoStatusService ) {

		super(eventoAtualizacaoStatusService);

		this.eventoAtualizacaoStatusService = eventoAtualizacaoStatusService;

	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.EventoAtualizacaoStatusEditView> getEditView() {

		return ViewsContrato.EventoAtualizacaoStatusEditView.class;
	}
}
