package br.com.centralit.controller;

import java.math.BigDecimal;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.EventoLiberacaoPagamento;
import br.com.centralit.api.service.EventoLiberacaoPagamentoEmpenhoService;
import br.com.centralit.api.service.EventoLiberacaoPagamentoService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.api.viewHelper.ViewsContrato.EventoLiberacaoPagamentoView;
import br.com.centralit.framework.controller.GenericController;


/**
 *
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 *
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
 *
 * @since 10/03/2016 - 16:19:02
 *
 * @version 1.0.0
 *
 * @author erick.sato
 *
 */
@Controller
@RequestMapping("/rest/eventoLiberacaoPagamentoRepository")
public class EventoLiberacaoPagamentoController extends GenericController<EventoLiberacaoPagamento>{

	private EventoLiberacaoPagamentoService eventoLiberacaoPagamentoService;

	@Autowired
	private EventoLiberacaoPagamentoEmpenhoService eventoLiberacaoPagamentoEmpenhoService;

	public EventoLiberacaoPagamentoController() {
		super();
	}

	@Autowired
	public EventoLiberacaoPagamentoController(EventoLiberacaoPagamentoService eventoLiberacaoPagamentoService) {

		super(eventoLiberacaoPagamentoService);

		this.eventoLiberacaoPagamentoService = eventoLiberacaoPagamentoService;

	}

	@Override
	public Class<EventoLiberacaoPagamentoView> getEditView() {

		return ViewsContrato.EventoLiberacaoPagamentoView.class;
	}

	@RequestMapping(value = "/getValorTotalExecutadoEmpenho", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public BigDecimal getValorTotalExecutadoEmpenho(@RequestParam(value = "empenhoId") Long empenhoId) {
		return this.eventoLiberacaoPagamentoEmpenhoService.getValorTotalExecutadoEmpenho(empenhoId);
	}

	@RequestMapping(value = "/getValorTotalLiberado", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public BigDecimal getValorTotalLiberado(@RequestParam(value = "contratoId") Long contratoId) {
		return this.eventoLiberacaoPagamentoService.getValorTotalLiberado(contratoId);
	}

}
