package br.com.centralit.controller;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.http.HttpServletResponse;

import net.sf.jasperreports.engine.JRException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.EventoRecebimentoObjeto;
import br.com.centralit.api.service.EventoRecebimentoObjetoService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;

@Controller
@RequestMapping("/rest/eventoRecebimentoObjeto")
public class EventoRecebimentoObjetoController extends GenericController<EventoRecebimentoObjeto> {

	private EventoRecebimentoObjetoService eventoRecebimentoObjetoService;

	public EventoRecebimentoObjetoController() {

		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param eventoAtualizacaoStatusService
	 */
	@Autowired
	private EventoRecebimentoObjetoController( EventoRecebimentoObjetoService eventoRecebimentoObjetoService ) {

		super(eventoRecebimentoObjetoService);

		this.eventoRecebimentoObjetoService = eventoRecebimentoObjetoService;

	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.EventoRecebimentoObjetoEditView> getEditView() {

		return ViewsContrato.EventoRecebimentoObjetoEditView.class;
	}

	@ResponseBody
	@RequestMapping(method = RequestMethod.GET, value = "/pdfGerarRecebimentoObjeto")
	public void gerarPdfApostilamento(@RequestParam(value = "idRecebimentoObjeto") Long idRecebimentoObjeto,
										@RequestParam(value = "download") boolean download, HttpServletResponse response)
										throws SQLException, JRException, IOException {

		eventoRecebimentoObjetoService.gerarPdfRecebimento(idRecebimentoObjeto, download, response);
	}
}
