package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.EventoRegistroNaoConformidade;
import br.com.centralit.api.service.EventoRegistroNaoConformidadeService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;

@Controller
@RequestMapping("/rest/eventoRegistroNaoConformidade")
public class EventoRegistroNaoConformidadeController extends GenericController<EventoRegistroNaoConformidade>{

	private EventoRegistroNaoConformidadeService eventoRegistroNaoConformidadeService;

	public EventoRegistroNaoConformidadeController() {
		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param eventoAtualizacaoStatusService
	 */
	@Autowired
	private EventoRegistroNaoConformidadeController( EventoRegistroNaoConformidadeService eventoRegistroNaoConformidadeService ) {

		super(eventoRegistroNaoConformidadeService);

		this.eventoRegistroNaoConformidadeService = eventoRegistroNaoConformidadeService;

	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.EventoRegistroNaoConformidadeView> getEditView() {

		return ViewsContrato.EventoRegistroNaoConformidadeView.class;
	}


	@RequestMapping(value = "/aplicacoesNaoConformidadeContrato", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper aplicacoesNaoConformidadeContrato( @RequestParam(value = "contratoId") Long contratoId) {

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(eventoRegistroNaoConformidadeService.aplicacoesNaoConformidadeContrato(contratoId), getEditView());

		return responseBody;
	}

	@RequestMapping(value = "/existeVinculoSancoesComNaoConformidade", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper existeVinculoSancoesComNaoConformidade(@RequestParam(value = "sancaoId") Long sancaoId) {
		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(eventoRegistroNaoConformidadeService.existeVinculoSancoesComNaoConformidade(sancaoId), ViewsContrato.TermoReferenciaSancaoEditView.class);
		return responseBody;
	}

}
