package br.com.centralit.controller;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.http.HttpServletResponse;

import net.sf.jasperreports.engine.JRException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.EventoRescisaoContrato;
import br.com.centralit.api.service.EventoRescisaoContratoService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;

@Controller
@RequestMapping("/rest/eventoRescisaoContrato")
public class EventoRescisaoContratoController extends GenericController<EventoRescisaoContrato>{

	private EventoRescisaoContratoService eventoRescisaoContratoService;

	public EventoRescisaoContratoController() {
		super();
	}

	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 *
	 * @param eventoAtualizacaoStatusService
	 */
	@Autowired
	private EventoRescisaoContratoController( EventoRescisaoContratoService eventoRescisaoContratoService ) {

		super(eventoRescisaoContratoService);

		this.eventoRescisaoContratoService = eventoRescisaoContratoService;

	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.EventoRescisaoContratoView> getEditView() {

		return ViewsContrato.EventoRescisaoContratoView.class;
	}

	@ResponseBody
	@RequestMapping(method = RequestMethod.GET, value = "/pdfGerarTermoRescisaoContrato")
	public void gerarPdfApostilamento(@RequestParam(value = "idRescisaoContrato") Long idRescisaoContrato,
										@RequestParam(value = "download") boolean download, HttpServletResponse response)
										throws SQLException, JRException, IOException {

		this.eventoRescisaoContratoService.gerarPdfTermo(idRescisaoContrato, download, response);
	}

}
