package br.com.centralit.controller;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.jasperreports.engine.JRException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.NotificacaoContrato;
import br.com.centralit.api.service.NotificacaoContratoService;
import br.com.centralit.api.service.UsuarioService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.api.viewHelper.ViewsContrato.NotificacaoContratoEditView;
import br.com.centralit.framework.controller.GenericController;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b> Notificacao Contrato
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">415</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 24/02/2016 - 08:39:42
 *
 * @version 1.0.0
 *
 * @author erick.sato
 *
 */
@Controller
@RequestMapping("/rest/notificacaoContrato")
public class NotificacaoContratoController extends GenericController<NotificacaoContrato> {

	private NotificacaoContratoService notificacaoContratoService;

	@Autowired
	private UsuarioService usuarioService;

	@Autowired
	public NotificacaoContratoController(NotificacaoContratoService notificacaoContratoService) {

		super(notificacaoContratoService);

		this.notificacaoContratoService = notificacaoContratoService;
	}

	@Override
	public Class<NotificacaoContratoEditView> getEditView() {

		return ViewsContrato.NotificacaoContratoEditView.class;
	}

	@RequestMapping(method = RequestMethod.GET, value = "/gerarTermoNotificacaoContrato")
	@ResponseBody
	public void generatePdfRMB(@RequestParam(value="idEncerramentoContrato") Long idNotificacaoContrato, @RequestParam(value="download") boolean download, HttpServletResponse response,
			HttpServletRequest request) throws SQLException, JRException, IOException {

		notificacaoContratoService.gerarRelatorioNotificacaoContrato(idNotificacaoContrato, download, response);
	}

}
