package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.ObjetivoEstrategicoNecessidade;
import br.com.centralit.api.service.ObjetivoEstrategicoNecessidadeService;
import br.com.centralit.api.service.UsuarioService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;

/**
 * 
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 08/01/2016 - 14:15:18
 *
 * @version 1.0.0
 *
 * @author geovane.filho
 *
 */
@Controller
@RequestMapping("/rest/objetivoEstrategicoNecessidade")
public class ObjetivoEstrategicoNecessidadeController extends GenericController<ObjetivoEstrategicoNecessidade> {

	/** Atributo objetivoEstrategicoNecessidadeService. */
	private ObjetivoEstrategicoNecessidadeService objetivoEstrategicoNecessidadeService;
	
	@Autowired
	private UsuarioService usuarioService;


	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param objetivoEstrategicoNecessidadeService
	 */
	@Autowired
	public ObjetivoEstrategicoNecessidadeController(ObjetivoEstrategicoNecessidadeService objetivoEstrategicoNecessidadeService) {

		super(objetivoEstrategicoNecessidadeService);
		
		this.objetivoEstrategicoNecessidadeService = objetivoEstrategicoNecessidadeService;
	}


	
	
	@RequestMapping(value = "/findAllByObjetivoEstrategico", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findAllByObjetivoEstrategico(@RequestParam(value = "objEstrategicoId") Long objEstrategicoId) {
		
		final Collection<ObjetivoEstrategicoNecessidade> necessidades = this.objetivoEstrategicoNecessidadeService.findAllByObjetivoEstrategico(objEstrategicoId);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(necessidades, ViewsContrato.ObjetivoEstrategicoNecessidadeSelectView.class);

		return responseBody;
	}
	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.ObjetivoEstrategicoListView> getListView() {

		return ViewsContrato.ObjetivoEstrategicoListView.class;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.ObjetivoEstrategicoEditView> getEditView() {

		return ViewsContrato.ObjetivoEstrategicoEditView.class;
	}	
}
