package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.ProgramaAcao;
import br.com.centralit.api.service.ProgramaAcaoService;
import br.com.centralit.api.service.UsuarioService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b> Monitor </p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">415</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 11/01/2015 - 10:34:59
 *
 * @version 1.0.0
 *
 * @author luis.camargo
 *	
 */
@Controller
@RequestMapping("/rest/programaAcao")
public class ProgramaAcaoController extends GenericController<ProgramaAcao> {

	/** Atributo regraEventoService. */
	private ProgramaAcaoService programaAcaoService;
	
	@Autowired
	private UsuarioService usuarioService;


	/**
	 * Responsável pela criação de novas instâncias desta classe.
	 * @param programaAcaoService
	 */
	@Autowired
	public ProgramaAcaoController(ProgramaAcaoService programaAcaoService) {

		super(programaAcaoService);
		
		this.programaAcaoService = programaAcaoService;
	}
	
	@RequestMapping(value = "/findAllByPrograma", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findAllByPrograma(@RequestParam(value = "programaId") Long programaId) {
		
		final Collection<ProgramaAcao> acoes = this.programaAcaoService.findAllByPrograma(programaId);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(acoes, ViewsContrato.ProgramaAcaoAutoCompleteView.class);

		return responseBody;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.ProgramaAcaoListView> getListView() {

		return ViewsContrato.ProgramaAcaoListView.class;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Class<ViewsContrato.ProgramaAcaoEditView> getEditView() {

		return ViewsContrato.ProgramaAcaoEditView.class;
	}	
}
