package br.com.centralit.controller;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.TermoReferenciaPenalidade;
import br.com.centralit.api.service.TermoReferenciaPenalidadeService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.view.ResultResponseVH;

@Controller
@RequestMapping("/rest/termoReferenciaPenalidade")
public class TermoReferenciaPenalidadeController extends GenericController<TermoReferenciaPenalidade> {

	@Autowired
	private TermoReferenciaPenalidadeService termoReferenciaPenalidadeService;
	
	@Autowired
	public TermoReferenciaPenalidadeController(TermoReferenciaPenalidadeService termoReferenciaPenalidadeService) {
		super(termoReferenciaPenalidadeService);
	}

	@RequestMapping(value = "/findAllByContrato", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper findAllDominio(@RequestParam(value = "idContrato") Long idContrato) {

		Collection<TermoReferenciaPenalidade> listaPenalidades = this.termoReferenciaPenalidadeService.findAllByContrato(idContrato);

		ResultResponseVH<Collection<TermoReferenciaPenalidade>> resultResponseVH = new ResultResponseVH<Collection<TermoReferenciaPenalidade>>(listaPenalidades);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, ViewsContrato.TermoReferenciaPenalidadeListView.class);

		return responseBody;
	}

}
