package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.model.TermoReferenciaSancao;
import br.com.centralit.api.service.TermoReferenciaSancaoService;
import br.com.centralit.api.viewHelper.ViewsContrato;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;

@Controller
@RequestMapping("/rest/termoReferenciaSancao")
public class TermoReferenciaSancaoController extends GenericController<TermoReferenciaSancao> {

	@Autowired
	private TermoReferenciaSancaoService termoReferenciaSancaoService;

	@Autowired
	public TermoReferenciaSancaoController(TermoReferenciaSancaoService termoReferenciaSancaoService) {
		super(termoReferenciaSancaoService);
	}

	@RequestMapping(value = "/listarSancoesPorContrato", method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper listarSancoesPorContrato(@RequestParam(value = "contratoId") Long contratoId) {
		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(termoReferenciaSancaoService.buscaSancoesContrato(contratoId), ViewsContrato.TermoReferenciaSancaoEditView.class);
		return responseBody;
	}

}
