'use strict';

citApp.controller('ContratoController', ['$scope', '$filter', 'FileUploader', 'ContratoRepository', '$translate', '$timeout',
                                         'DominioRepository', 'FornecedorRepository', 'ColaboradorRepository', 'ParceiroRepository',
                                         'PessoaRepository', 'ProgramaRepository', 'EstudoTecnicoRepository', 'ProgramaAcaoRepository',
                                         'ContratoEnvolvidoRepository', '$q','TermoReferenciaRepository',
                                         function ContratoController($scope, $filter, FileUploader, ContratoRepository, $translate, $timeout,
                                        		 DominioRepository, FornecedorRepository, ColaboradorRepository, ParceiroRepository,
                                        		 PessoaRepository, ProgramaRepository, EstudoTecnicoRepository, ProgramaAcaoRepository,
                                        		 ContratoEnvolvidoRepository, $q, TermoReferenciaRepository) {


	// ###################### INICIO: INICIALIZACAO DE VARIAVEIS ###########################
	$scope.contrato = {
			ctrtEmpenhos : [],
			ctrtItens : [],
			ctrtEnvolvidos : [],
			ctrtValoresPagamento : [],
			dominioSituacaoAtual : {codigo : 1},
			valorTotalEmpenhado : 0.0,
			fornecedor : null,
			cnpjFornecedor : ""
	};

	$scope.programaTemp = null;
	$scope.contratoEmpenhoTemp = {};
	$scope.contratoEnvolvidoTemp = {};
	$scope.acaoEmMassaEmpenho = false;
	$scope.acaoEmMassaItemContrato= false;
	$scope.acaoEmMassaEnvolvido = false;
	$scope.acaoEmMassaValorPagamento = false;
	$scope.contratoValorPagamentoUnicoTemp = {};
	
	$scope.uploader = new FileUploader({
        autoUpload: false,
        queueLimit: 99,
        url: '/cit-tabelas-corp-web/rest/anexo/uploadAnexo?idDocumento='
    });

	$scope.templates = [{ name: 'contratoPg1.html', url: '/cit-contratos-web/html/contrato/contratoPg1.html', show: true},
	                    { name: 'contratoPg2.html', url: '/cit-contratos-web/html/contrato/contratoPg2.html', show: false},
	                    { name: 'contratoPg3.html', url: '/cit-contratos-web/html/contrato/contratoPg3.html', show: false},
	                    { name: 'contratoPg4.html', url: '/cit-contratos-web/html/contrato/contratoPg4.html', show: false},
	                    { name: 'contratoPg5.html', url: '/cit-contratos-web/html/contrato/contratoPg5.html', show: false},
	                    { name: 'contratoPg6.html', url: '/cit-contratos-web/html/contrato/contratoPg6.html', show: false}];

	DominioRepository.findAllDominio('tipoContrato').then(function(result) {
		$scope.dominioTipoContratoList = result;
	});
	DominioRepository.findAllDominio('tipoAquisicaoContrato').then(function(result) {
		$scope.dominioTipoAquisicaoList = result;
	});
	DominioRepository.findAllDominio('tipoModalidadeLicitacaoContrato').then(function(result) {
		$scope.dominioModalidadeLicitacaoList = result;
	});
	DominioRepository.findAllDominio('tipoLicitacaoContrato').then(function(result) {
		$scope.dominioTipoLicitacaoList = result;
	});
	DominioRepository.findAllDominio('tipoSituacaoContrato').then(function(result) {
		$scope.dominioSituacaoAtualList = result;
	});
	DominioRepository.findAllDominio('tipoGarantia').then(function(result) {
		$scope.dominioTipoGarantiaList = result;
	});
	DominioRepository.findAllDominio('tipoModalidadeGarantia').then(function(result) {
		$scope.dominioTipoModalidadeGarantiaList = result;
	});
	DominioRepository.findAllDominio('tipoFormaPagamentoContrato').then(function(result) {
		$scope.dominioFormaPagamentoList = result;
	});
	DominioRepository.findAllDominio('tipoFinalidadeEmpenhoContrato').then(function(result) {
		$scope.dominioFinalidadeEmpenhoList = result;
	});
	DominioRepository.findAllDominio('tipoCategoriaEconomicaEmpenhoContrato').then(function(result) {
		$scope.dominioCategoriaEconomicaList = result;
	});
	DominioRepository.findAllDominio('tipoModalidadeGarantiaContrato').then(function(result) {
		$scope.dominioModalidadeGarantiaList = result;
	});
	carregarDominioPapelEnvolvido();

	function carregarDominioPapelEnvolvido() {
		DominioRepository.findAllDominio('tipoPapelEnvolvidoContrato').then(function(result) {
			$scope.dominioPapelEnvolvidoList = result;
			$scope.dominioPapelEnvolvidoListFixa = result;
		});
	};
	
	$scope.atualizaPaginaPesquisa = function () {
		$scope.$showPageSearchWorkspace($scope.workspace);
		angular.element('#searchContrato').scope().fetchResult();
	};
	
	// ###################### FIM: INICIALIZACAO DE VARIAVEIS ###########################

	// Limpa formulario para novo cadastro
	$scope.resetForm = function() {

		$scope.contrato = {
				ctrtEmpenhos : [],
				ctrtItens : [],
				ctrtEnvolvidos : [],
				ctrtValoresPagamento : [],
				dominioSituacaoAtual : {codigo : 1},
				valorTotalEmpenhado : 0.0,
				fornecedor : null,
				cnpjFornecedor : ""
		};
		$scope.programaTemp = null;
		$scope.contratoEmpenhoTemp = {};
		$scope.contratoEnvolvidoTemp = {};
		$scope.acaoEmMassaEmpenho = false;
		$scope.acaoEmMassaItemContrato= false;
		$scope.acaoEmMassaEnvolvido = false;
		$scope.acaoEmMassaValorPagamento = false;
		$scope.hasAlteracaoEnvolvido = false;
		$scope.contratoValorPagamentoUnicoTemp = {};

		carregarDominioPapelEnvolvido();
		$scope.atualizarListaSizeSelect();
		$scope.atualizarListaSizeSelectItemContrato();
		$scope.atualizarListaSizeSelectEnvolvido();
		$scope.edit = true;
		$scope.setCurrentStep(0);
		
		$scope.startTimerIntervalSaveDraft($scope.workspace , $scope.contrato, true);
		$timeout(function(){
			$scope.contratoForm.informacoesGeraisContratoForm.$submitted = false;
			$scope.contratoForm.informacoesContratoForm.$submitted = false;
			$scope.contratoForm.informacoesEmpenhoLicitacaoContratoForm.$submitted = false;
			$scope.contratoForm.informacoesItensContratoAndGarantiaForm.$submitted = false;
			$scope.contratoForm.informacoesEnvolvidosContratoForm.$submitted = false;
			$scope.contratoForm.anexosObservacoesContratoForm.$submitted = false;

			$scope.contratoForm.informacoesGeraisContratoForm.$setPristine();
			$scope.contratoForm.informacoesContratoForm.$setPristine();
			$scope.contratoForm.informacoesEmpenhoLicitacaoContratoForm.$setPristine();
			$scope.contratoForm.informacoesItensContratoAndGarantiaForm.$setPristine();
			$scope.contratoForm.informacoesEnvolvidosContratoForm.$setPristine();
			$scope.contratoForm.anexosObservacoesContratoForm.$setPristine();
		});
		
	};

	$scope.gerarRelatorioTermoContrato = function() {
		$scope.url = '/cit-contratos-web/rest/contrato/gerarTermoContrato?idContrato='+ $scope.contrato.id;
		$scope.visualizarRelatorio($scope.url, $translate.instant("LABEL.TITULO_CONTRATO"));
	};

	// Consulta entidade e mostra no formulario
	$scope.getContrato = function(id, edit){

		$scope.resetForm();
		$scope.setLoadingGet(true);
		ContratoRepository.get(id).then(function(result) {

			$scope.contrato = result.originalElement;
			$scope.setCnpjFornecedor($scope.contrato.fornecedor);

			if ($scope.contrato.programaAcao) {
				$scope.programaTemp = angular.copy($scope.contrato.programaAcao.programa);
			}

			$scope.contrato.valorTotalItens = 0.0;
			angular.forEach($scope.contrato.ctrtItens, function(item){
				$scope.contrato.valorTotalItens += item.valorTotalItem;
			});

			var empenhosTemp = [];
			angular.forEach($scope.contrato.ctrtEmpenhos, function(empenho, index){
				if(empenho.numeroEmpenho != undefined){
					empenhosTemp.push(empenho);
				}
			});

			$scope.contrato.ctrtEmpenhos = empenhosTemp;

			$scope.contrato.percentualGarantia = $scope.contrato.percentualGarantia / 100;

			if (edit) {
				$scope.hasAlteracaoEnvolvido = false;
			}
			$scope.atualizarListaSizeSelect();
			$scope.atualizarListaSizeSelectItemContrato();
			$scope.atualizarListaSizeSelectEnvolvido();
			$scope.edit = edit;
			$scope.setCurrentStep(0);
			$scope.stopTimerIntervalDraft($scope.workspace);
			$scope.setLoading(false);
		});
	};
	
	$scope.setRascunho = function(rascunho){

		if (rascunho) {
			$scope.contrato = rascunho;
			if ($scope.contrato.programaAcao) {
				ProgramaRepository.findByProgramaAcao($scope.contrato.programaAcao.id).then(function(result) {
					$scope.programaTemp = result.originalElement;
				});
			}
		}
		$scope.workspace.objetoScope = $scope.contrato;
		$scope.startTimerIntervalSaveDraft($scope.workspace);
		$scope.edit = true;
		$scope.setLoading(false);
	};


	$scope.atualizaPercentualGarantia = function (){
		if ($scope.contrato.valorContrato && $scope.contrato.valorGarantia) {
			$scope.contrato.percentualGarantia = ($scope.contrato.valorGarantia / $scope.contrato.valorContrato);
		} else {
			$scope.contrato.percentualGarantia = null;
		}
	};

	$scope.atualizaVigenciaGarantia = function (){
		$timeout(function(){
			if ($scope.contrato.dominioModalidadeGarantia || $scope.contrato.valorGarantia) {
				var dataVigenciaFinal = clone($scope.contrato.dataVigenciaFinal);
				$scope.contrato.dataVigenciaGarantia = $filter('date')(dataVigenciaFinal, "dd/MM/yyyy");
			} else {
				$scope.contrato.dataVigenciaGarantia = null;
			}
		});
	};

	$scope.findFornecedor = function(value) {
		return ParceiroRepository.findParceiros('tipoParceiro', ['FORNECEDOR'], value).then(function(result) {
			return result;
		});
	};

	$scope.findEnvolvido = function(value) {
		return PessoaRepository.findColaboradorPorNomeAndOrganizacao(value, $scope.usuarioLogado.organizacao.id).then(function(result) {
			return result;
		});
	};

	$scope.findAutoCompleteProgramaByNumeroOrNomeAndOrganizacao = function(value) {
		return ProgramaRepository.findAutoCompleteProgramaByNumeroOrNomeAndOrganizacao(value, $scope.usuarioLogado.organizacao.id).then(function(result) {
			return result;
		});
	};

	$scope.findAutoCompleteEstudoTecnicoPorCodigoAndOrganizacao = function(value){
		return EstudoTecnicoRepository.findAutoCompleteEstudoTecnicoPorCodigoAndOrganizacao(value, $scope.usuarioLogado.organizacao.id).then(function(result) {
			return result;
		});
	};

	$scope.findAutoCompleteTermoReferencia = function(value) {
		return TermoReferenciaRepository.findAutoCompleteTermoReferencia(value, $scope.usuarioLogado.organizacao.id).then(function(result) {
			return result;
		});
	};

	$scope.setCnpjFornecedor = function (fornecedor) {
		$scope.contrato.cnpjFornecedor = fornecedor.pessoa.pessoaJuridica.cnpj;
	};

	// Salva e atualiza o contrato
	$scope.saveOrUpdate = function() {
		// atributo para visualizar os itens obrigatorios na tela
		$scope.contratoForm.informacoesGeraisContratoForm.$submitted = true;
		$scope.contratoForm.informacoesContratoForm.$submitted = true;
		$scope.contratoForm.informacoesEmpenhoLicitacaoContratoForm.$submitted = true;
		$scope.contratoForm.informacoesItensContratoAndGarantiaForm.$submitted = true;
		$scope.contratoForm.informacoesEnvolvidosContratoForm.$submitted = true;
		$scope.contratoForm.anexosObservacoesContratoForm.$submitted = true;

		// verifica formulario valido
		if ($scope.contratoForm.$invalid) {
			$scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'));
			return;
		}

		if(!$scope.informacoesValidas()){
			return;
		};

		if ($scope.contrato.id && $scope.contrato.ctrtEnvolvidos){
			angular.forEach($scope.contrato.ctrtEnvolvidos, function(envolvido){
				if (envolvido.justificativas){
					angular.forEach(envolvido.justificativas, function(justificativa){
						delete justificativa.autor.permissoes;
						delete justificativa.dataCriacao;
					});
				}
			});
		}

		if ($scope.contrato.ctrtValoresPagamento && $scope.contrato.ctrtValoresPagamento.length > 0){
			if (!validarContratoValoresPagamento()){
				return;
			}
			angular.forEach($scope.contrato.ctrtValoresPagamento, function(parcelaValorPagamento){
				if (parcelaValorPagamento.seguencia){
					delete parcelaValorPagamento.seguencia;
				}
			});
		}

		$scope.contratoTemp = {
				documentos: []
		};

		// preencher lista de documentos temporarios para verificacao dos anexos. verificar qual anexo e de qual documento pelo numero do documento
		angular.forEach($scope.contrato.documentos, function(documento, key) {
			if (documento.uploadsDocumento) {
				documento.uuid = getUuid();
				$scope.contratoTemp.documentos.push({
					file: documento.uploadsDocumento[0],
					uuid: clone(documento.uuid)
				});
				// deleta esse atributo por causa de um erro de ciclo no json
				delete documento.uploadsDocumento;
			}
		});

		if ($scope.contrato.programaAcao && $scope.contrato.programaAcao.originalElement) {
			$scope.contrato.programaAcao = $scope.contrato.programaAcao.originalElement;
		}
		verificarValorTotalEmpenhado();
	};

	$scope.informacoesValidas = function () {

		// data da celebracao nao pode ser maior que a data de vigencia inicial do contrato
		if(!isPeriodoValido($scope.contrato.dataCelebracao, $scope.contrato.dataVigenciaInicial)){
			$scope.showAlert('error', $translate.instant('VALIDACAO.DATA_CELEBRACAO_MAIOR_DATA_VIGENCIA_INICIAL'));
			return false;
		}

		// data de vigencia inicial nao pode ser maior que a data de vigencia final do contrato
		if(!isPeriodoValido($scope.contrato.dataVigenciaInicial, $scope.contrato.dataVigenciaFinal)){
			$scope.showAlert('error', $translate.instant('VALIDACAO.DATA_VIGENCIA_INICIAL_MAIOR_DATA_VIGENCIA_FINAL_CONTRATO'));
			return false;
		}

		// data de vigencia inicial nao pode ser maior que a data de vigencia final do contrato
		if($scope.contrato.ctrtEnvolvidos && $scope.contrato.ctrtEnvolvidos.length > 0 && $scope.contrato.ctrtEnvolvidos.length < 3){
			$scope.showAlert('error', $translate.instant('VALIDACAO.CONTRATO_EXIGE_MINIMO_TRES_ENVOLVIDOS'));
			return false;
		}
		return true;
	};

	function save() {
		$scope.setLoadingSalva(true);

		$scope.contrato.exercicio = new Date($scope.contrato.exercicio);
		$scope.contrato.rascunho = $scope.workspace.rascunho ? $scope.workspace.rascunho.id : null; 
		ContratoRepository.save($scope.contrato).then(function(result) {

			$scope.contrato = result.originalElement;
			$scope.setCnpjFornecedor($scope.contrato.fornecedor);

			var empenhosTemp = [];
			angular.forEach($scope.contrato.ctrtEmpenhos, function(empenho, index){
				if(empenho.numeroEmpenho != undefined){
					empenhosTemp.push(empenho);
				}
			});

			$scope.contrato.ctrtEmpenhos = empenhosTemp;
			salvarListaDocumentos($scope.contratoTemp);
			$scope.atualizaPaginaPesquisa();
			$scope.setLoading(false);
			$scope.showAlert("success", $translate.instant("MSG.SUCESSO_CONTRATO"));

		});
	}

	function verificarValorTotalEmpenhado() {
		if ($scope.contrato.valorTotalEmpenhado < $scope.contrato.valorContrato) {

			$scope.$openModalConfirm({
				message: $translate.instant('CONTRATOS.MSG.VALOR_TOTAL_EMPENHADO_MENOR_VALOR_CONTRATO'),
				callback: function () {

					$scope.$modalConfirmInstance.close();
					verificarValorTotalItens();
				}
			});
		} else {
			verificarValorTotalItens();
		}
	}

	function verificarValorTotalItens() {
		var valorTotalItens = 0;
		$scope.contrato.ctrtItens.forEach(function (itemContrato) {

			valorTotalItens += itemContrato.valorTotalItem;
		});

		if (valorTotalItens < $scope.contrato.valorContrato) {

			$scope.$openModalConfirm({
				message: $translate.instant('CONTRATOS.MSG.VALOR_TOTAL_ITENS_MENOR_VALOR_CONTRATO'),
				callback: function () {

					$scope.$modalConfirmInstance.close();
					save();
				}
			});
		} else {
			save();
		}
	}

	// valida se todos os pagamentos do contrato estao validados de acordo com as regras de dada e valores
	function validarContratoValoresPagamento(){

		var contratoValoresPagamentosComVencimentoSuperiorVigenciaInicial = true;
		var contratoValoresPagamentosComVencimentoInferiorVigenciaFinal = true;
		var textSeguenciaParcelasComVencimentoForaVigencia = "";

		angular.forEach($scope.contrato.ctrtValoresPagamento, function(parcelaValorPagamento){

			// data da dataVigenciaInicial nao pode ser maior que a dataVencimento da parcela
			if(!isPeriodoValido($scope.contrato.dataVigenciaInicial, parcelaValorPagamento.dataVencimento)){

				// se contratoValoresPagamentosComVencimentoSuperiorVigenciaInicial est� valido � a primeira vez que a dataVencimento est� incorreta
				if (contratoValoresPagamentosComVencimentoSuperiorVigenciaInicial){

					textSeguenciaParcelasComVencimentoForaVigencia += parcelaValorPagamento.seguencia.toString();
					contratoValoresPagamentosComVencimentoSuperiorVigenciaInicial = false;

				} else {

					textSeguenciaParcelasComVencimentoForaVigencia += ", " + parcelaValorPagamento.seguencia.toString();
				}
			}

			// data da dataVencimento nao pode ser maior que a data de vigencia final do contrato
			if(!isPeriodoValido(parcelaValorPagamento.dataVencimento, $scope.contrato.dataVigenciaFinal)){

				// se contratoValoresPagamentosComVencimentoInferiorVigenciaInicial est� valido � a primeira vez que a dataVencimento est� incorreta
				if (contratoValoresPagamentosComVencimentoInferiorVigenciaFinal && contratoValoresPagamentosComVencimentoSuperiorVigenciaInicial){

					textSeguenciaParcelasComVencimentoForaVigencia += parcelaValorPagamento.seguencia.toString();
					contratoValoresPagamentosComVencimentoInferiorVigenciaFinal = false;

				} else {

					textSeguenciaParcelasComVencimentoForaVigencia += ", " + parcelaValorPagamento.seguencia.toString();
				}
			}
		});

		// se existe alguma parcela com data de vencimento fora da vigencia, apresenta os itens
		if (!contratoValoresPagamentosComVencimentoSuperiorVigenciaInicial || !contratoValoresPagamentosComVencimentoInferiorVigenciaFinal) {

			$scope.showAlert('warning', $translate.instant('VALIDACAO.DATA_VENCIMENTO_PARCELA_FORA_VIGENCIA_CONTRATO') + textSeguenciaParcelasComVencimentoForaVigencia + ".");
		}

		return contratoValoresPagamentosComVencimentoSuperiorVigenciaInicial && contratoValoresPagamentosComVencimentoInferiorVigenciaFinal;
	}

	// metodo utilizado para percorrer a lista de documentos persistidos e verificar com a lista de documentos temporarios para verificacao de qual anexo pertence a qual documento
    var salvarListaDocumentos = function(contratoTemp) {
    	$scope.uploader.queue = [];
    	
        angular.forEach($scope.contrato.documentos, function(documentoSalvo, key) {
            // verifica se a entidade documento foi salva
            if (documentoSalvo !== undefined && documentoSalvo.id !== undefined) {
                // percorre todos os documentos temporarios para verificacao do numero do documento
                angular.forEach(contratoTemp.documentos, function(documentoTransient, key) {
                    // verifica se o numero do documento salvo e igual ao numero do documento transient que o anexo ainda esta vinculado
                    if (documentoTransient.file && documentoSalvo.uuid === documentoTransient.uuid) {
                        //salva o anexo ao documento que tiver o mesmo numero do documento transient
                    	
                    	documentoTransient.file.url = documentoTransient.file.url + documentoSalvo.id;
                    	$scope.uploader.queue.push(documentoTransient.file);
                    }
                });
            }
        });
        
        if($scope.uploader.queue.length > 0){
        	$scope.uploader.uploadAll();
        }
        delete $scope.contratoTemp;
    };
    
	// watch para calcular valor total empenhado
	$scope.$watchCollection('contrato.ctrtEmpenhos', function() {
		if (!$scope.contrato.id && $scope.edit){
			$scope.contrato.valorTotalEmpenhado = 0.0;
			angular.forEach($scope.contrato.ctrtEmpenhos, function(empenho){
				$scope.contrato.valorTotalEmpenhado = $scope.contrato.valorTotalEmpenhado + empenho.valorEmpenhado;
			});
		}
	});

	// watch para sempre que mudar o codigo da forma de pagamento inicializar os pagamentos e numero de parcela
	$scope.$watch('contrato.dominioFormaPagamentoContrato.codigo', function() {
		if (!$scope.contrato.id && $scope.edit){
			$scope.contrato.ctrtValoresPagamento = [];
			$scope.contrato.numeroParcela = null;
		}
	});

	// watch para sempre que mudar o codigo da forma de pagamento inicializar os pagamentos e numero de parcela
	$scope.$watch('contrato.dominioModalidadeLicitacao.codigo', function() {
		if (!$scope.contrato.id && $scope.edit){
			if($scope.contrato.dominioModalidadeLicitacao && ($scope.contrato.dominioModalidadeLicitacao.codigo === 1 || $scope.contrato.dominioModalidadeLicitacao.codigo === 2)){
				$scope.contrato.dominioTipoLicitacao = null;
			}
		}
	});

	// watch para calcular as parcelas e as datas de vencimento
	$scope.$watch('contrato.numeroParcela', function() {

		if (!$scope.contrato.id && $scope.edit){

			$scope.setLoading(true, $translate.instant('MSG.CARREGANDO_PARCELAS'));

			$timeout(function() {

				if ($scope.contrato.numeroParcela > 0 && $scope.contrato.numeroParcela !== $scope.contrato.ctrtValoresPagamento.length){

					$scope.contrato.ctrtValoresPagamento = [];
					var valorUnitarioParcela = $scope.contrato.valorContrato / $scope.contrato.numeroParcela;
					var resto = ($scope.contrato.valorContrato % $scope.contrato.numeroParcela) / 100;
					var primeiraDataVencimento = new Date();
					var contratoValorPagamentoTemp = null;

					for (var i=0; i < $scope.contrato.numeroParcela; i++){

						var dataParcelaValorPagamento = $filter('date')(primeiraDataVencimento.setMonth(i+1), "dd/MM/yyyy");

						if (i===0 && resto){

							var valorUnitarioParcelaComResto = valorUnitarioParcela + resto;
							contratoValorPagamentoTemp = {
									seguencia : i+1,
									valorParcela : valorUnitarioParcelaComResto,
									dataVencimento : dataParcelaValorPagamento
							};

							$scope.contrato.ctrtValoresPagamento.push(contratoValorPagamentoTemp);
						} else {
							contratoValorPagamentoTemp = {
									seguencia : i+1,
									valorParcela : valorUnitarioParcela,
									dataVencimento : dataParcelaValorPagamento
							};

							$scope.contrato.ctrtValoresPagamento.push(contratoValorPagamentoTemp);
						}
					}
				}
				if ($scope.contrato.numeroParcela === "0" || !$scope.contrato.numeroParcela){

					$scope.contrato.ctrtValoresPagamento = [];
					$scope.contrato.numeroParcela = null;
				}

				$scope.setLoading(false);
			});
		}
	});

	// watch carregar as acoes do contrato
	$scope.$watch('programaTemp.id', function() {
		$timeout(function() {
			if ($scope.programaTemp && ($scope.programaTemp.id)) {
				ProgramaAcaoRepository.findAllByPrograma($scope.programaTemp).then(function(result) {
					$scope.programaTemp.acoes = result;
				});
			}
		});
	});

	// watch para calcular valor total dos itens do contrato
	$scope.$watchCollection('contrato.ctrtItens', function() {
		if (!$scope.contrato.id && $scope.edit){
			$scope.contrato.valorTotalItens = 0.0;
			angular.forEach($scope.contrato.ctrtItens, function(item){
				$scope.contrato.valorTotalItens += item.valorTotalItem;
			});
		}
	});

	// watch para calcular valor da porecentagem da garantia
	$scope.$watchCollection('contrato.valorGarantia', function() {
		$scope.atualizaPercentualGarantia();
	});

	// watch para calcular valor da porecentagem da garantia
	$scope.$watchCollection('contrato.valorContrato', function() {
		if ($scope.contrato.valorGarantia) {
			$scope.atualizaPercentualGarantia();
		}
	});

	// Sempre que a forma de pagamento for parcelada distribui o valor do contrato em parcelas
	$scope.atualizaPagamento = function (){

		if ($scope.contrato.numeroParcela > 0 && $scope.contrato.numeroParcela !== $scope.contrato.ctrtValoresPagamento.length){

			$scope.contrato.ctrtValoresPagamento = [];
			var valorUnitarioParcela = $scope.contrato.valorContrato / $scope.contrato.numeroParcela;
			var resto = ($scope.contrato.valorContrato % $scope.contrato.numeroParcela) / 100;
			var primeiraDataVencimento = new Date();
			var contratoValorPagamentoTemp = null;

			for (var i=0; i < $scope.contrato.numeroParcela; i++){

				var dataParcelaValorPagamento = $filter('date')(primeiraDataVencimento.setMonth(i+1), "dd/MM/yyyy");

				if (i===0 && resto){

					var valorUnitarioParcelaComResto = valorUnitarioParcela + resto;
					contratoValorPagamentoTemp = {
							valorParcela : valorUnitarioParcelaComResto,
							dataVencimento : dataParcelaValorPagamento
					};

					$scope.contrato.ctrtValoresPagamento.push(contratoValorPagamentoTemp);
				} else {
					contratoValorPagamentoTemp = {
							valorParcela : valorUnitarioParcela,
							dataVencimento : dataParcelaValorPagamento
					};

					$scope.contrato.ctrtValoresPagamento.push(contratoValorPagamentoTemp);
				}
			}
		}
		if ($scope.contrato.numeroParcela === "0"){

			$scope.contrato.ctrtValoresPagamento = [];
			$scope.contrato.numeroParcela = null;
		}
	};

	// responsavel por fazer o calculo da quantidade do item do contrato com seu valor
	$scope.atualizaValorTotalItemContrato = function (){

		if ($scope.itemContratoTemp.quantidade && $scope.itemContratoTemp.quantidade > 0 && $scope.itemContratoTemp.valorUnitarioItem){

			var qtd = Number($scope.itemContratoTemp.quantidade);
			$scope.itemContratoTemp.valorTotalItem = qtd * $scope.itemContratoTemp.valorUnitarioItem;
		}
	};

	// ###################### INICIO: CONTROLE DO WIZARD ###########################

	// Inicializacao de variaveis de controle.
	$scope.steps = ['one', 'two', 'three', 'four', 'five', 'six'];
	$scope.step = 0;
	$scope.permitidoAvancar = true;
	$scope.stepValid = true;

	// Verifica se � o primeiro passo do wizard
	$scope.isFirstStep = function () {
		return $scope.step === 0;
	};

	// Verifica � o ultimo passo do wizard
	$scope.isLastStep = function () {
		return $scope.step === ($scope.steps.length - 1);
	};

	// Verifica se o passo � o passo atual do wizard
	$scope.isCurrentStep = function (step) {
		return $scope.step === step;
	};

	// Verifica se o passo atual � igual a pelo menos um passado
	$scope.isSomeTheseSteps = function (steps) {

		return steps.some(function(step) {
			return step === $scope.step;
		});
	};

	// Utilizado pelo wizard para mudar para o passo desejado
	$scope.setCurrentStep = function (step) {

		$scope.setLoading(true);

		if (step <= ($scope.step - 1)){

			$scope.templates[$scope.step].show = false;
			$scope.step = step;
			$scope.templates[step].show = true;

		} else {

			if(!$scope.edit){

				$scope.permitidoAvancar = true;

			} else {

				permiteAvancoFluxo();
			}

			if($scope.permitidoAvancar){

				$scope.templates[$scope.step].show = false;
				$scope.step = step;
				$scope.templates[step].show = true;
			}
		}

		$scope.setLoading(false);
	};

	// Controla se o usuario pode avancar o fluxo no wizard, validando os itens obrigat�rios
	function permiteAvancoFluxo(){

		$scope.permitidoAvancar = true;

		if ($scope.step === 0){

			if (!validStepInformacoesGeraisContrato() && $scope.permitidoAvancar) {
				$scope.contratoForm.informacoesGeraisContratoForm.$submitted = true;
			}

		} else if ($scope.step === 1){

			if (!validStepInformacoesContrato() && $scope.permitidoAvancar) {
				$scope.contratoForm.informacoesContratoForm.$submitted = true;
			}

		} else if ($scope.step === 2){

			if (!validStepInformacoesEmpenhoLicitacaoContrato() && $scope.permitidoAvancar) {
				$scope.contratoForm.informacoesEmpenhoLicitacaoContratoForm.$submitted = true;
			}

		} else if ($scope.step === 3){

			if (!validStepInformacoesItensContrato() && $scope.permitidoAvancar) {
				$scope.contratoForm.informacoesItensContratoAndGarantiaForm.$submitted = true;
			}

		} else if ($scope.step === 4){

			if (!validStepInformacoesEnvolvidosContrato() && $scope.permitidoAvancar) {
				$scope.contratoForm.informacoesEnvolvidosContratoForm.$submitted = true;
			}

		} else if ($scope.step === 5){

			if (!validStepAnexosObservacoesContrato() && $scope.permitidoAvancar) {
				$scope.contratoForm.anexosObservacoesContratoForm.$submitted = true;
			}
		}

		if (!$scope.permitidoAvancar && !$scope.stepValid){

			//Mensagem de erro de campos obrigatorios nao preenchidos
			$scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
		}
	};

	// Funcao especifica que retorna se o formulario de informacoes gerais do contrato esta valido
	function validStepInformacoesGeraisContrato(){

		$scope.stepValid = true;

		if ($scope.contratoForm.informacoesGeraisContratoForm.$invalid){

			$scope.stepValid = false;
		}

		return $scope.stepValid;
	};

	// Funcao especifica que retorna se o formulario de informacoes do contrato esta valido
	function validStepInformacoesContrato(){

		$scope.stepValid = true;

		if ($scope.contratoForm.informacoesContratoForm.$invalid){

			$scope.stepValid = false;
		}

		return $scope.stepValid;
	};

	// Funcao especifica que retorna se o formulario de informacoes de empenho e licitacao do contrato esta valido
	function validStepInformacoesEmpenhoLicitacaoContrato(){

		$scope.stepValid = true;

		if ($scope.contratoForm.informacoesEmpenhoLicitacaoContratoForm.$invalid){

			$scope.stepValid = false;
		}

		return $scope.stepValid;
	};

	// Funcao especifica que retorna se o formulario de informacoes dos itens do contrato esta valido
	function validStepInformacoesItensContrato(){

		$scope.stepValid = true;

		if ($scope.contratoForm.informacoesItensContratoAndGarantiaForm.$invalid){

			$scope.stepValid = false;
		}

		return $scope.stepValid;
	};

	// Funcao especifica que retorna se o formulario de informacoes dos envolvidos do contrato esta valido
	function validStepInformacoesEnvolvidosContrato(){

		$scope.stepValid = true;

		if ($scope.contratoForm.informacoesEnvolvidosContratoForm.$invalid || (!$scope.contrato.ctrtEnvolvidos || $scope.contrato.ctrtEnvolvidos.length < 3)){

			$scope.stepValid = false;
		}

		return $scope.stepValid;
	};

	// Funcao especifica que retorna se o formulario de anexos e documentos do contrato esta valido
	function validStepAnexosObservacoesContrato(){

		$scope.stepValid = true;

		if ($scope.contratoForm.anexosObservacoesContratoForm.$invalid){

			$scope.stepValid = false;
		}

		return $scope.stepValid;
	};

	// Recupera o label do botao de comando
	$scope.getNextLabel = function () {
		return ($scope.isLastStep()) ? $translate.instant("LABEL.SALVAR") : $translate.instant("LABEL.PROXIMO");
	};

	// Faz com o que o wizard retroceda um passo
	$scope.handlePrevious = function () {

		$scope.setLoading(true);
		$scope.templates[$scope.step].show = false;
		$scope.step -= ($scope.isFirstStep()) ? 0 : 1;
		$scope.templates[$scope.step].show = true;
		$scope.setLoading(false);
	};

	// Faz com o que o wizard avance um passo
	$scope.handleNext = function () {

		if ($scope.isLastStep()) {

			$scope.saveOrUpdate();

		} else {

			$scope.setLoading(true);

			if(!$scope.edit){

				$scope.permitidoAvancar = true;

			} else {

				permiteAvancoFluxo();

			}

			if ($scope.permitidoAvancar){

				$scope.templates[$scope.step].show = false;
				$scope.step += 1;
				$scope.templates[$scope.step].show = true;
			}
		}

		$scope.setLoading(false);
	};
	// ###################### FIM: CONTROLE DO WIZARD ###########################


	// 	###################### INICIO STEP: INFORMACOES DO CONTRATO ###########################

	//--------------- INFORMACOES DE VALORES DE PAGAMENTO ---------------------
	// responsavel por definir se as acoes em massa estaram disponiveis
	$scope.checkValorPagamento = function (){
		var valoresPagamentoChecked = $scope.contrato.ctrtValoresPagamento.filter(function(valorPagamento) {
			return valorPagamento.$checked === true;
		});

		if (valoresPagamentoChecked.length > 1){

			$scope.acaoEmMassaValorPagamento = true;
		} else {

			$scope.acaoEmMassaValorPagamento = false;
		}
	};

	//responsavel por remover um/ou mais parcelas do pagamento do contrato e recalcular o numero de parcelas
	$scope.removerValorPagamentoContrato = function (){

		var valoresPagamentoChecked = $scope.contrato.ctrtValoresPagamento.filter(function(valorPagamento) {
			return valorPagamento.$checked === true;
		});

		if (valoresPagamentoChecked.length > 0){

			$scope.contrato.ctrtValoresPagamento = $scope.contrato.ctrtValoresPagamento.filter(function(valorPagamento) {
				return valorPagamento.$checked !== true;
			});

			if ($scope.contrato.ctrtValoresPagamento.length > 0){

				$scope.contrato.numeroParcela = $scope.contrato.ctrtValoresPagamento.length;

			} else {

				$scope.contrato.numeroParcela = null;
			}

			$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));

		} else {

			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'));
			return;
		}
	};

	// Responsavel por checar todos os valores de pagamento do contrato
	$scope.selectedAllCtrtValoresPagamento = false;
	$scope.acaoEmMassaValorPagamento = false;
	$scope.selectAllCtrtValoresPagamento = function (){

		if($scope.selectedAllCtrtValoresPagamento === false) {

			if($scope.contrato.ctrtValoresPagamento.length > 1) {

				$scope.acaoEmMassaValorPagamento = true;
			}

			$scope.contrato.ctrtValoresPagamento.forEach(function (valorPagamento) {

				valorPagamento.$checked = !$scope.selectedAllCtrtValoresPagamento;
			});

			$scope.selectedAllCtrtValoresPagamento = true;
		} else {

			$scope.contrato.ctrtValoresPagamento.forEach(function (valorPagamento) {

				valorPagamento.$checked = !$scope.selectedAllCtrtValoresPagamento;
			});

			$scope.acaoEmMassaValorPagamento = false;
			$scope.selectedAllCtrtValoresPagamento = false;
		}
	};
	// ########################### FIM: STEP: INFORMACOES DO CONTRATO #######################


	// ###################### INICIO STEP: INFORMACOES DE EMPENHO E LICITACAO ###########################

	//--------------- INFORMACOES DE EMPENHO---------------------
	// responsavel por definir se as acoes em massa estaram disponiveis
	$scope.checkEmpenho = function (){
		var empenhosChecked = $scope.contrato.ctrtEmpenhos.filter(function(empenho) {
			return empenho.$checked === true;
		});

		if (empenhosChecked.length > 1){

			$scope.acaoEmMassaEmpenho = true;
		} else {

			$scope.acaoEmMassaEmpenho = false;
		}
	};

	// responsavel por abrir modal de adicao de um empenho
	$scope.openModalEmpenho = function() {
		if ($scope.contrato.valorContrato) {

			$scope.contratoEmpenhoTemp = {};
			$scope.editEmpenho = true;
			$scope.showButtonSalvarEmpenho = false;
			$scope.$openModal('modal-empenho.html', 'lg');
		} else {
			$scope.showAlert('error', $translate.instant('CONTRATOS.VALIDACAO.NECESSARIO_VALOR_CONTRATO_INFO_EMPENHO'));
		}
	};

	// responsavel por adicionar um empenho ao contrato
	$scope.adicionarEmpenho = function (formDialogEmpenho, continuarEditando){

		formDialogEmpenho.$submitted = true;

		if (formDialogEmpenho.$invalid) {
			//Mensagem de erro de campos obrigatorios n�o preenchidos
			$scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
			return;
		}

		// a finalidade do empenho "Anulação" e "Reforço" só poderão ser informadas caso haja a finalidade "Despesa do contrato" cadastrada
		if ($scope.contratoEmpenhoTemp.dominioFinalidadeEmpenho.codigo != 1) {
			var hasDespesaContrato = false;
			for (var i = 0; i < $scope.contrato.ctrtEmpenhos.length; i++) {
				var empenho = $scope.contrato.ctrtEmpenhos[i];
				if (empenho.dominioFinalidadeEmpenho.codigo === 1 && !empenho.$checked) {
					hasDespesaContrato = true;
					break;
				}
			}

			if (hasDespesaContrato) {
				// Caso a finalidade seja "Anulação", o sistema deverá diminuir o valor deste empenho do
				// "valor total empenhado" e não somá-lo com os empenhos de finalidade "reforço e despesa do contrato".
				if ($scope.contratoEmpenhoTemp.dominioFinalidadeEmpenho.codigo === 3) {
					$scope.contratoEmpenhoTemp.valorEmpenhado = ($scope.contratoEmpenhoTemp.valorEmpenhado * (-1));
				}
			} else {
				$scope.showAlert('error', $translate.instant('CONTRATOS.VALIDACAO.FINALIDADE_EMPENHO_FALTANDO'));
				return;
			}
		}

		// data de empenho nao pode ser maior que a data de vigencia final do contrato
		if(!isPeriodoValido($scope.contratoEmpenhoTemp.data, $scope.contrato.dataVigenciaFinal)){

			$scope.showAlert('warning', $translate.instant('VALIDACAO.DATA_EMPENHO_MAIOR_DATA_VIGENCIA_FINAL_CONTRATO'));
			return;
		}

		// o valor total de empenhado n�o pode ser superior ao valor do contrato
		var somaEmpenhos = $scope.contrato.valorTotalEmpenhado + $scope.contratoEmpenhoTemp.valorEmpenhado;
		if (somaEmpenhos > $scope.contrato.valorContrato) {

			$scope.showAlert('error', $translate.instant('CONTRATOS.VALIDACAO.VALOR_TOTAL_EMPENHADO_SUPERIOR_VALOR_CONTRATADO'));
			return;
		}

		// o valor total do empenho não pode ser negativo
		if (somaEmpenhos < 0) {

			$scope.showAlert('error', $translate.instant('CONTRATOS.VALIDACAO.VALOR_TOTAL_ANULACAO_SUPERIOR_VALOR_TOTAL'));
			return;
		}

		if ($scope.contrato.ctrtEmpenhos){

			if ($scope.contratoEmpenhoTemp.$checked){

				for (var i = 0; i < $scope.contrato.ctrtEmpenhos.length; i++) {

					if ($scope.contrato.ctrtEmpenhos[i].$checked) {

						$scope.contrato.ctrtEmpenhos[i] = $scope.contratoEmpenhoTemp;
					}
				}
			} else {

				$scope.contrato.ctrtEmpenhos.push($scope.contratoEmpenhoTemp);
			}
		}
		$scope.contratoEmpenhoTemp = {};
		
		if(continuarEditando){
			formDialogEmpenho.$submitted = false;
			formDialogEmpenho.$setPristine();
		}else{
			$scope.atualizarListaSizeSelect();
			$scope.$modalInstance.dismiss('cancel');
		}
	};

	//responsavel por remover um/ou mais empenh(o)s do contrato
	$scope.removerEmpenho = function (){

		var empenhosChecked = $scope.contrato.ctrtEmpenhos.filter(function(empenho) {
			return empenho.$checked === true;
		});

		if (empenhosChecked.length > 0){

			var listIdsRemocao = [];
			angular.forEach(empenhosChecked, function(empenhoRemocao){
				if (empenhoRemocao.id){
					listIdsRemocao.push({id:empenhoRemocao.id});
				}
			});

		} else {

			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'));
			return;
		}

		$scope.$openModalConfirm({
			message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
			callback: function() {

				$scope.$modalConfirmInstance.dismiss('cancel');
				if (listIdsRemocao && listIdsRemocao.length > 0) {
					ContratoEmpenhoRepository.removeAll(listIdsRemocao).then(function(result) {
						$scope.contrato.ctrtEmpenhos = $scope.contrato.ctrtEmpenhos.filter(function(empenho) {
							return empenho.$checked !== true;
						});
						$scope.atualizarListaSizeSelect();
						$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
					});
				} else {
					$scope.contrato.ctrtEmpenhos = $scope.contrato.ctrtEmpenhos.filter(function(empenho) {
						return empenho.$checked !== true;
					});
					$scope.atualizarListaSizeSelect();
					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
				}
			}
		});
	};

	// Responsavel por checar todos os empenhos do contrato
	$scope.selectedAllCtrtEmpenhos = false;
	$scope.acaoEmMassaEmpenho = false;
	$scope.selectAllCtrtEmpenhos = function (){

		if($scope.selectedAllCtrtEmpenhos === false) {

			if($scope.contrato.ctrtEmpenhos.length > 1) {

				$scope.acaoEmMassaEmpenho = true;
			}

			$scope.contrato.ctrtEmpenhos.forEach(function (empenho) {

				empenho.$checked = !$scope.selectedAllCtrtEmpenhos;
			});

			$scope.selectedAllCtrtEmpenhos = true;
		} else {

			$scope.contrato.ctrtEmpenhos.forEach(function (empenho) {

				empenho.$checked = !$scope.selectedAllCtrtEmpenhos;
			});

			$scope.acaoEmMassaEmpenho = false;
			$scope.selectedAllCtrtEmpenhos = false;
		}

		$scope.atualizarListaSizeSelect();
	};

	// Responsavel por abrir modal de empenho para edicao ou visualizacao do item selecionado
	$scope.abrirEmpenho = function(edit) {

		$scope.editEmpenho = edit;
		$scope.showButtonSalvarEmpenho = edit;

		$scope.contratoEmpenhoTemp = null;

		// recupera o empenho selecionado
		$scope.contratoEmpenhoTemp = $scope.getCheckedEmpenho();

		if(!$scope.contratoEmpenhoTemp) {

			$scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
			return;
		}

		$timeout(function() {
			$scope.$openModal('modal-empenho.html', 'lg');
		});
	};

	// Responsavel por retornar o empenho selecionado
	$scope.getCheckedEmpenho = function() {

		var empenhoChecked = null;

		if ($scope.contrato.ctrtEmpenhos) {
			for (var i = 0; i < $scope.contrato.ctrtEmpenhos.length; i++) {
				if ($scope.contrato.ctrtEmpenhos[i].$checked) {
					empenhoChecked = angular.copy($scope.contrato.ctrtEmpenhos[i]);
				}
			}
		}
		return empenhoChecked;
	};

	// ########################### FIM: STEP: INFORMACOES DE EMPENHO E LICITACAO #######################


	// ###################### INICIO STEP: INFORMACOES DE GARANTIA E DE ITEM DO CONTRATO ###########################

	// responsavel por definir se as acoes em massa estaram disponiveis
	$scope.checkItemContrato = function (){
		var itensContratoChecked = $scope.contrato.ctrtItens.filter(function(itemContrato) {
			return itemContrato.$checked === true;
		});

		if (itensContratoChecked.length > 1){

			$scope.acaoEmMassaItemContrato = true;
		} else {

			$scope.acaoEmMassaItemContrato = false;
		}
	};

	// responsavel por abrir modal de adicao de um item de contrato
	$scope.openModalItemContrato = function() {
		if ($scope.contrato.valorContrato) {

			$scope.itemContratoTemp = {};
			$scope.editItemContrato = true;
			$scope.showButtonSalvarItem = false;
			$scope.$openModal('modal-item-contrato.html', 'lg');
		} else {
			$scope.showAlert('error', $translate.instant('CONTRATOS.VALIDACAO.NECESSARIO_VALOR_CONTRATO_INFO_ITENS_CONTRATO'));
		}
	};

	// responsavel por adicionar um item de contrato ao contrato
	$scope.adicionarItemContrato = function (formDialogItemContrato, continuarEditando){

		formDialogItemContrato.$submitted = true;

		if (formDialogItemContrato.$invalid) {
			//Mensagem de erro de campos obrigatorios n�o preenchidos
			$scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
			return;
		}

		// o valor total de empenhado n�o pode ser superior ao valor do contrato
		var valorTotalItens = 0;
		$scope.contrato.ctrtItens.forEach(function (itemContrato) {
			valorTotalItens += itemContrato.valorTotalItem;
		});

		valorTotalItens += $scope.contrato.ctrtItens.length > 0 ? $scope.itemContratoTemp.valorTotalItem : 0;
		if (valorTotalItens > $scope.contrato.valorContrato) {
			$scope.showAlert('error', $translate.instant('CONTRATOS.VALIDACAO.VALOR_TOTAL_ITENS_SUPERIOR_VALOR_CONTRATADO'));
			return;
		}

		if ($scope.contrato.ctrtItens){

			if ($scope.itemContratoTemp.$checked){

				for (var i = 0; i < $scope.contrato.ctrtItens.length; i++) {

					if ($scope.contrato.ctrtItens[i].$checked) {

						$scope.contrato.ctrtItens[i] = $scope.itemContratoTemp;
					}
				}
			} else {

				$scope.contrato.ctrtItens.push($scope.itemContratoTemp);
			}
		}

		$scope.itemContratoTemp = {};
		
		if(continuarEditando){
			formDialogItemContrato.$submitted = false;
			formDialogItemContrato.$setPristine();
		} else {
			$scope.atualizarListaSizeSelectItemContrato();
			$scope.$modalInstance.dismiss('cancel');
		}
	};

	//responsavel por remover um/ou mais item(ns) de contrato
	$scope.removerItemContrato = function (){

		var itensContratoChecked = $scope.contrato.ctrtItens.filter(function(itemContrato) {
			return itemContrato.$checked === true;
		});

		if (itensContratoChecked.length > 0){

			var listIdsRemocao = [];
			angular.forEach(itensContratoChecked, function(itemContratoRemocao){
				if (itemContratoRemocao.id){
					listIdsRemocao.push({id:itemContratoRemocao.id});
				}
			});

		} else {

			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'));
			return;
		}

		$scope.$openModalConfirm({
			message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
			callback: function() {

				$scope.$modalConfirmInstance.dismiss('cancel');
				if (listIdsRemocao && listIdsRemocao.length > 0) {
					ContratoItemRepository.removeAll(listIdsRemocao).then(function(result) {
						$scope.contrato.ctrtItens = $scope.contrato.ctrtItens.filter(function(itemContrato) {
							return itemContrato.$checked !== true;
						});
						$scope.atualizarListaSizeSelectItemContrato();
						$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
					});
				} else {
					$scope.contrato.ctrtItens = $scope.contrato.ctrtItens.filter(function(itemContrato) {
						return itemContrato.$checked !== true;
					});
					$scope.atualizarListaSizeSelectItemContrato();
					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
				}
			}
		});
	};

	// Responsavel por checar todos os itens de contrato
	$scope.selectedAllCtrtItens = false;
	$scope.acaoEmMassaItemContrato = false;
	$scope.selectAllCtrtItens = function (){

		if($scope.selectedAllCtrtItens === false) {

			if($scope.contrato.ctrtItens.length > 1) {

				$scope.acaoEmMassaItemContrato = true;
			}

			$scope.contrato.ctrtItens.forEach(function (itemContrato) {

				itemContrato.$checked = !$scope.selectedAllCtrtItens;
			});

			$scope.selectedAllCtrtItens = true;
		} else {

			$scope.contrato.ctrtItens.forEach(function (itemContrato) {

				itemContrato.$checked = !$scope.selectedAllCtrtItens;
			});

			$scope.acaoEmMassaItemContrato = false;
			$scope.selectedAllCtrtItens = false;
		}

		$scope.atualizarListaSizeSelectItemContrato();
	};

	// Responsavel por abrir modal de item de contrato para edicao ou visualizacao do item selecionado
	$scope.abrirItemContrato = function(edit) {

		$scope.editItemContrato = edit;
		$scope.showButtonSalvarItem = edit;

		$scope.itemContratoTemp = null;

		// recupera o item de contrato selecionado
		$scope.itemContratoTemp = $scope.getCheckedItemContrato();

		if(!$scope.itemContratoTemp) {

			$scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
			return;
		}

		$timeout(function() {
			$scope.$openModal('modal-item-contrato.html', 'lg');
		});
	};

	// Responsavel por retornar o item de contrato selecionado
	$scope.getCheckedItemContrato = function() {

		var itemContratoChecked = null;

		if ($scope.contrato.ctrtItens) {
			for (var i = 0; i < $scope.contrato.ctrtItens.length; i++) {
				if ($scope.contrato.ctrtItens[i].$checked) {
					itemContratoChecked = angular.copy($scope.contrato.ctrtItens[i]);
				}
			}
		}
		return itemContratoChecked;
	};
	// ########################### FIM: STEP: INFORMACOES DE GARANTIA E DE ITEM DO CONTRATO #######################


	// ###################### INICIO STEP: INFORMACOES DE ENVOLVIDOS ###########################

	// responsavel por definir se as acoes em massa estaram disponiveis
	$scope.checkContratoEnvolvido = function (){
		var contratoEnvolvidosChecked = $scope.contrato.ctrtEnvolvidos.filter(function(contratoEnvolvido) {
			return contratoEnvolvido.$checked === true;
		});

		if (contratoEnvolvidosChecked.length > 1){
			$scope.acaoEmMassaEnvolvido = true;
		} else {
			$scope.acaoEmMassaEnvolvido = false;
		}
	};

	// responsavel por abrir modal de adicao de um contratoEnvolvido
	$scope.openModalContratoEnvolvido = function() {

		$scope.editEnvolvido = true;
		$scope.showButtonSalvarEnvolvido = false;
		$scope.contratoEnvolvidoTemp = {justificativas : []};
		$scope.contrato.ctrtEnvolvidos.forEach(function(item){
			if(item.$checked){
				item.$checked = false;
			}
		});
		filtrarPapeisSelecionados();
		$scope.$openModal('dialog_envolvido.html', 'lg');
	};

	$scope.closeModalContratoEvolvido = function(formDialogEnvolvido) {
		$scope.hasAlteracaoEnvolvido = false;
		formDialogEnvolvido.$submitted = false;
		$scope.$modalInstance.dismiss('cancel');
	};

	$scope.adicionarContratoEnvolvido = function (formDialogEnvolvido, continuarEditando) {

		formDialogEnvolvido.$submitted = true;
		if($scope.contrato.id && $scope.hasAlteracaoEnvolvido){
			if($scope.contratoEnvolvidoTemp.justificativas.length === 0 ||
					$scope.contratoEnvolvidoTemp.justificativas.length === $scope.contratoEnvolvidoTemp.justificativasAnterioresLength){
				$scope.showAlert('error', $translate.instant('CONTRATOS.VALIDACAO.ALTERACAO_ENVOLVIDOS_EXIGE_JUSTIFICATIVA'));
				return;
			}
		}

		if (formDialogEnvolvido.$invalid) {
			//Mensagem de erro de campos obrigatorios nao preenchidos
			$scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
			return;
		}
		if ($scope.contrato.ctrtEnvolvidos){
			if ($scope.contratoEnvolvidoTemp.$checked) {
				for (var i = 0; i < $scope.contrato.ctrtEnvolvidos.length; i++) {
					if ($scope.contrato.ctrtEnvolvidos[i].$checked) {
						$scope.contrato.ctrtEnvolvidos[i] = $scope.contratoEnvolvidoTemp;
					}
				}
			} else {
				$scope.contrato.ctrtEnvolvidos.push($scope.contratoEnvolvidoTemp);
			}
		}

		$scope.contratoEnvolvidoTemp = {justificativas : []};
		$scope.justificativaTemp = {};
		$scope.hasAlteracaoEnvolvido = false;
		$scope.atualizarListaSizeSelectEnvolvido();
		if (continuarEditando) {
			formDialogEnvolvido.$submitted = false;
			formDialogEnvolvido.$setPristine();
			filtrarPapeisSelecionados();
			return;
		}
		$scope.$modalInstance.dismiss('cancel');
	};

	$scope.adicionarJustificativa = function (form) {

		form.$submitted = true;

		if ($scope.justificativaTemp.descricao === '' || $scope.justificativaTemp.descricao == undefined) {
			$scope.showAlert('error', $translate.instant('CONTRATOS.VALIDACAO.ALTERACAO_ENVOLVIDOS_EXIGE_JUSTIFICATIVA'));
			return;
		}
		if ($scope.contratoEnvolvidoTemp.justificativas){
			$scope.justificativaTemp.autor = $scope.usuarioLogado;
			$scope.justificativaTemp.dataCriacao = new Date();
			$scope.contratoEnvolvidoTemp.justificativas.push($scope.justificativaTemp);
		}
		$scope.justificativaTemp = {};
	};

	function filtrarPapeisSelecionados() {
		if ($scope.contrato.ctrtEnvolvidos && $scope.contrato.ctrtEnvolvidos.length > 0){

			var dominiosPapelEnvolvidoContrato = [];
			$scope.contrato.ctrtEnvolvidos.forEach(function(item){
				if(!item.$checked){
					dominiosPapelEnvolvidoContrato.push(item.dominioPapelEnvolvidoContrato);
				}
			});

			$scope.dominioPapelEnvolvidoList = $filter('idNotEqualDominio')($scope.dominioPapelEnvolvidoListFixa, dominiosPapelEnvolvidoContrato);

			if($scope.editEnvolvido){
				if ($scope.dominioPapelEnvolvidoList && $scope.dominioPapelEnvolvidoList.length === 0){
					$scope.showAlert('warning', $translate.instant('CONTRATOS.MSG.TODOS_PAPEIS_ENVOLVIDOS_ADICIONADOS'));
					return;
				}
			}
		}
	};

	//responsavel por remover um/ou mais item(ns) de contrato
	$scope.removerContratoEnvolvido = function (){

		var envolvidosChecked = $scope.contrato.ctrtEnvolvidos.filter(function(itemContrato) {
			return itemContrato.$checked === true;
		});

		if (envolvidosChecked.length > 0){

			var listIdsRemocao = [];
			angular.forEach(envolvidosChecked, function(itemContratoRemocao){
				if (itemContratoRemocao.id){
					listIdsRemocao.push(itemContratoRemocao.id);
				}
			});

		} else {

			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'));
			return;
		}

		$scope.$openModalConfirm({
			message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
			callback: function() {

				var papelExcluido = {};
				$scope.$modalConfirmInstance.dismiss('cancel');
				if (listIdsRemocao && listIdsRemocao.length > 0) {
					ContratoEnvolvidoRepository.removeAll(listIdsRemocao).then(function(result) {
						$scope.contrato.ctrtEnvolvidos = $scope.contrato.ctrtEnvolvidos.filter(function(contratoEnvolvido) {
							papelExcluido = contratoEnvolvido.dominioPapelEnvolvidoContrato;
							return contratoEnvolvido.$checked !== true;
						});
						$scope.atualizarListaSizeSelectEnvolvido();
						$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
					});
				} else {
					$scope.contrato.ctrtEnvolvidos = $scope.contrato.ctrtEnvolvidos.filter(function(contratoEnvolvido) {
						papelExcluido = contratoEnvolvido.dominioPapelEnvolvidoContrato;
						return contratoEnvolvido.$checked !== true;
					});
					$scope.atualizarListaSizeSelectEnvolvido();
					$scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
				}

				$scope.dominioPapelEnvolvidoList.push(papelExcluido);
			}
		});
	};

	// Responsavel por checar todos os envolvidos
	$scope.selectedAllCtrtEnvolvidos = false;
	$scope.acaoEmMassaEnvolvido = false;
	$scope.selectAllCtrtEnvolvidos = function (){

		if($scope.selectedAllCtrtEnvolvidos === false) {

			if($scope.contrato.ctrtEnvolvidos.length > 1) {

				$scope.acaoEmMassaEnvolvido = true;
			}

			$scope.contrato.ctrtEnvolvidos.forEach(function (contratoEnvolvido) {

				contratoEnvolvido.$checked = !$scope.selectedAllCtrtEnvolvidos;
			});

			$scope.selectedAllCtrtEnvolvidos = true;
		} else {

			$scope.contrato.ctrtEnvolvidos.forEach(function (contratoEnvolvido) {

				contratoEnvolvido.$checked = !$scope.selectedAllCtrtEnvolvidos;
			});

			$scope.acaoEmMassaEnvolvido = false;
			$scope.selectedAllCtrtEnvolvidos = false;
		}
		$scope.atualizarListaSizeSelectEnvolvido();
	};

	// Responsavel por abrir modal de envolvido para edicao ou visualizacao do item selecionado
	$scope.visualizarEditarContratoEnvolvido = function(edit) {

		$scope.editEnvolvido = edit;
		$scope.showButtonSalvarEnvolvido = edit;
		$scope.contratoEnvolvidoTemp = null;
		// recupera o item de contrato selecionado
		$scope.contratoEnvolvidoTemp = $scope.getCheckedContratoEnvolvido();
		if(!$scope.contratoEnvolvidoTemp) {
			$scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
			return;
		}
		$scope.justificativaTemp = {};
		if($scope.contratoEnvolvidoTemp.justificativas){
			$scope.contratoEnvolvidoTemp.justificativasAnterioresLength = $scope.contratoEnvolvidoTemp.justificativas.length;
		} else {
			$scope.contratoEnvolvidoTemp.justificativasAnterioresLength = 0;
			$scope.contratoEnvolvidoTemp.justificativas = [];
		}
		if($scope.contrato.id){
			$scope.hasAlteracaoEnvolvido = edit;
		}
		filtrarPapeisSelecionados();
		$timeout(function() {
			$scope.$openModal('dialog_envolvido.html', 'lg');
		});
	};

	// Responsavel por retornar o contratoEnvolvido selecionado
	$scope.getCheckedContratoEnvolvido = function() {

		var contratoEnvolvidoChecked = null;

		if ($scope.contrato.ctrtEnvolvidos) {
			for (var i = 0; i < $scope.contrato.ctrtEnvolvidos.length; i++) {
				if ($scope.contrato.ctrtEnvolvidos[i].$checked) {
					contratoEnvolvidoChecked = angular.copy($scope.contrato.ctrtEnvolvidos[i]);
				}
			}
		}
		return contratoEnvolvidoChecked;
	};

	$scope.radioValueList = [{descricao : $translate.instant('LABEL.SIM'), valor : true},
	                         {descricao : $translate.instant('LABEL.NAO'), valor : false}];

	$scope.atualizarListaSizeSelect = function() {
		if(!$scope.listaSize){
			$scope.listaSize = 0;
		};
		var lista = $scope.contrato.ctrtEmpenhos.filter(function(empenho) {
			return empenho.$checked === true;
		});
		$scope.listaSize = lista.length;
	};

	$scope.atualizarListaSizeSelectItemContrato = function() {
		if(!$scope.listaSizeItemContrato){
			$scope.listaSizeItemContrato = 0;
		};

		var lista = $scope.contrato.ctrtItens.filter(function(itemContrato) {
			return itemContrato.$checked === true;
		});

		$scope.listaSizeItemContrato = lista.length;
	};

	$scope.atualizarListaSizeSelectEnvolvido = function() {
		if(!$scope.listaSizeEnvolvido){
			$scope.listaSizeEnvolvido = 0;
		};

		var lista = $scope.contrato.ctrtEnvolvidos.filter(function(envolvido) {
			return envolvido.$checked === true;
		});

		$scope.listaSizeEnvolvido = lista.length;
	};
	
	// ########################### FIM: STEP: INFORMACOES DE ENVOLVIDOS #######################
}]);
