'use strict';

citApp.controller('ContratoEquipeGestoraController', ['$scope', 'ContratoEquipeGestoraRepository', '$translate', '$timeout', 'DominioRepository', 'PessoaRepository',
                                                      function ContratoEquipeGestoraController($scope, ContratoEquipeGestoraRepository, $translate, $timeout, DominioRepository, PessoaRepository) {

    $scope.contratoEquipeGestora = {};
    
    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
        $scope.limparContratoEquipeGestora();
        $scope.edit = true;
        $timeout(function(){
            $scope.contratoEquipeGestoraForm.$submitted = false;
            $scope.contratoEquipeGestoraForm.$setPristine();
        });
    };

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchContratoEquipeGestora').scope().fetchResult();
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(contratoEquipeGestora){
        $scope.contratoEquipeGestora = contratoEquipeGestora;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUIR'),
            callback: function () {
                ContratoEquipeGestoraRepository.remove($scope.contratoEquipeGestora).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.SUCESSO_EXCLUIR'));
                    angular.element('#searchContratoEquipeGestora').scope().fetchResult();

                    $scope.resetForm();
                });
            }
        });
    };

    // SALVA O ContratoEquipeGestora
    $scope.saveOrUpdate = function(){
        $scope.contratoEquipeGestoraForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.contratoEquipeGestoraForm.$valid){

            $scope.setLoadingSalva(true);

            ContratoEquipeGestoraRepository.save($scope.contratoEquipeGestora).then(function(result) {
                $scope.contratoEquipeGestora = result.originalElement;
                $scope.showAlert("success", $translate.instant('MSG.SUCESSO_SALVAR'));
                $scope.contratoEquipeGestoraForm.$submitted = false;
            });
            $scope.setLoading(false);
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
            $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
        }
    };

    // Limpa o formulario preenchido
    $scope.limparContratoEquipeGestora = function(){
        $scope.contratoEquipeGestora = {};
    };

    // Consulta entidade e mostra no formulario
    $scope.getContratoEquipeGestora = function(contratoEquipeGestora, edit){
        $scope.setLoadingGet(true);

        ContratoEquipeGestoraRepository.get(contratoEquipeGestora.id).then(function(result) {
            $scope.contratoEquipeGestora = result.originalElement;

            if($scope.contratoEquipeGestora.dataBloqueio === null || $scope.contratoEquipeGestora.dataBloqueio === undefined){
                $scope.edit = edit;
            }else{
                $scope.edit = false;
            }

            $scope.setLoading(false);
        });
    };

    
    $scope.findPessoa = function(value){
        return PessoaRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };           

    
    DominioRepository.findAllDominio('tipoPapelEquipeContratos').then(function(result) {
        $scope.dominioPapelEquipeContratosList = result;
    }); 

    

}]);
