'use strict';

citApp.controller('ContratoInfracaoListController', ['$scope', 'ContratoInfracaoRepository', '$translate', '$timeout', 'DominioRepository',
                                                     function ContratoInfracaoListController($scope, ContratoInfracaoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editContratoInfracao").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.DATA'), value : 'data' , filter : 'dateBR'} , {title : $translate.instant('LABEL.CONTRATO'), value : 'contrato.id' } , {title : $translate.instant('LABEL.RESPOSTA'), value : 'resposta' } , {title : $translate.instant('LABEL.MOTIVO'), value : 'motivo' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'data', 'contrato.id', 'resposta', 'motivo'],
        filters : [ {type : 'date', field : 'data' } , {type : 'string', field : 'contrato.id' } , {type : 'string', field : 'resposta' } , {type : 'string', field : 'motivo' }]
    };
    
    // ABRI ContratoInfracao SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var contratoInfracao = $scope.contratoInfracaoChecked;

        if(!contratoInfracao) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editContratoInfracao').scope().getContratoInfracao(contratoInfracao, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
