'use strict';

citApp.controller('ContratoOcorrenciaController', ['$scope', '$filter', 'ContratoOcorrenciaRepository', 'PenalidadeRepository', '$translate', '$timeout',
                                                   function ContratoOcorrenciaController($scope, $filter, ContratoOcorrenciaRepository, PenalidadeRepository, $translate, $timeout) {

    $scope.contratosOcorrencias = [];

    $scope.isBloquear = false;
    $scope.isDesbloquear = false;   

    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
        $scope.limparContrato();
        $scope.edit = true;
        $scope.isBloquear = false;
        $scope.isDesbloquear = $scope.isBloquear;
		uploader.clearQueue();
        $timeout(function(){
            $scope.contratoForm.$submitted = false;
            $scope.contratoForm.$setPristine();
        });
    };
       

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchContrato').scope().fetchResult();
    };  
    
    // Limpa o formulario preenchido
    $scope.limparContrato = function(){
        $scope.contrato = {
        		equipe: [],
        		termosAditivos: [],
        		garantias: [],
        		apostilamentos: [],
        		anexos: []
        };    
        
        uploader.clearQueue();
  
    };

    // Consulta entidade e mostra no formulario
    $scope.getContratos = function(){
        $scope.setLoadingGet(true);

        ContratoOcorrenciaRepository.buscaMeusContratosOcorrencias().then(function(result) {
            $scope.contratosOcorrencias = result;
            
            $scope.setLoading(false);
        });
    };
    
    //################################################## Cadastro de Infração
    $scope.infracao = {
    		penalidades : []
    };
    
    $scope.penalidadesInfracao = [];
    
    $scope.inicializaModalCadastroInfracao = function(){
		$scope.$openModal('modal-cadastroInfracao.html', 'lg');
	};
    
    PenalidadeRepository.findAllPenalidade().then(function(result) {//Retorno os possíveis objetivos da Saida Temporaria
		$scope.penalidadesInfracao = result;
	});
    
    $scope.atualizarPenalidades = function(penalidade) {
		if (penalidade.$selected) {
			$scope.infracao.penalidades.push({penalidade : penalidade.originalElement});
		} else {
			angular.forEach($scope.infracao.penalidades, function (item, idx) {
				if (item.penalidade.id == penalidade.id) {
					$scope.infracao.penalidades.splice(idx, 1);
				}
	        });
		}
	};
	
}]);
