'use strict';

citApp.controller('EventoAtualizacaoStatusController', ['$scope', '$timeout', '$translate', 'EventoAtualizacaoStatusRepository', 'ContratoRepository', 'DominioRepository', 'FileUploader',
                                              function EventoAtualizacaoStatusController($scope, $timeout, $translate, EventoAtualizacaoStatusRepository, ContratoRepository, DominioRepository,
                                            		  FileUploader) {


	$scope.uploader = new FileUploader({
        autoUpload: false,
        queueLimit: 1,
        url : '/cit-tabelas-corp-web/rest/anexo/uploadAnexo?idDocumento='
    });

	$scope.resetForm = function(form) {
		if($scope.contratoTemp == undefined){
			$scope.contratoTemp= angular.copy($scope.contrato);
		}
		if(!$scope.edit){
			$scope.getAtualizacaoStatus();
		}else{
			$scope.atualizacaoStatus = {};
			$scope.atualizacaoStatus = {contrato: $scope.contratoTemp};
		}
		if(form != undefined){
			$timeout(function(){
				form.$submitted = true;
				form.$setPristine();
			});
		}
	};

	$scope.getAtualizacaoStatus = function(){
		var idAtualizacaoStatus = $scope.evento.id;
		$scope.setLoadingGet(true);
		EventoAtualizacaoStatusRepository.get(idAtualizacaoStatus).then(function(result) {
			$scope.atualizacaoStatus = result.originalElement;
			$scope.contratoTemp.dominioSituacaoAtual = $scope.atualizacaoStatus.tipoSituacaoAntiga;
			$scope.setLoading(false);
		});
	};

	$scope.salvarAtualizacaoStatus = function(form){
		form.$submitted = true;
		if(form.$valid){

	        if(!isDataDentroPeriodo($scope.atualizacaoStatus.contrato.dataVigenciaInicial,
	                $scope.atualizacaoStatus.contrato.dataUltimaVigenciaFinal, $scope.atualizacaoStatus.dataAtualizacao)
	                && !($scope.contratoTemp.dominioSituacaoAtual.codigo == 3 && $scope.atualizacaoStatus.tipoSituacaoNova.codigo == 2
	            			  || $scope.contratoTemp.dominioSituacaoAtual.codigo == 3 && $scope.atualizacaoStatus.tipoSituacaoNova.codigo == 4 )) {
	        	$scope.showAlert('warning', $translate.instant('CONTRATOS.MSG.DATA_ATUALIZACAO_STATUS_INVALIDA'));
	        	return;
	        }

      	  if($scope.contratoTemp.dominioSituacaoAtual.codigo == $scope.atualizacaoStatus.tipoSituacaoNova.codigo){
    		  $scope.showAlert('warning', $translate.instant('CONTRATOS.MSG.ALTERACAO_STATUS_IGUAL'));
          	return;
    	  }

        	$scope.setLoadingSalva(true);

			if($scope.atualizacaoStatusTemp == null){
				$scope.atualizacaoStatusTemp = {
						documentos : []
				};

				angular.forEach($scope.atualizacaoStatus.documentos, function(documento, key) {

					$scope.atualizacaoStatusTemp.documentos.push({
						uploadsDocumento : clone(documento.uploadsDocumento),
						numero : clone(documento.numero)
					});
					delete documento.uploadsDocumento;
				});
			}
				EventoAtualizacaoStatusRepository.save($scope.atualizacaoStatus).then(function(result) {
					$scope.atualizacaoStatus = result.originalElement;

					angular.forEach($scope.atualizacaoStatus.documentos, function(documentoSalvo, key) {
						if(documentoSalvo !== undefined && documentoSalvo.id !== undefined){
							angular.forEach($scope.atualizacaoStatusTemp.documentos, function(documentoTransient, key) {
								if(documentoSalvo.numero === documentoTransient.numero){
									salvarUpload(documentoSalvo, documentoTransient.uploadsDocumento);
								}
							});
						}
					});

					$scope.setLoading(false);
					$scope.$modalInstance.dismiss('cancel');
					$scope.showAlert("success", $translate.instant("MSG.MG001"));
					$scope.buscaOcorrencias($scope.contratoTemp);
				});

		}else{
			$scope.showAlert('error', $translate.instant('MSG.MN001'));
		}
	};

	  var salvarUpload = function(documento, uploadsDocumento){
		  if (uploadsDocumento != undefined && uploadsDocumento != null) {
			  $scope.uploader.queue = uploadsDocumento;
			  angular.forEach($scope.uploader.queue, function(item, key) {
				  item.url =  item.url + documento.id;
			  });
			  $scope.uploader.uploadAll();
			  $scope.uploader.isUploading = false;
		  }
	  };

	DominioRepository.findAllDominio('tipoSituacaoContrato').then(function(result) {
		$scope.situacoesContrato = result;
	});

	$scope.resetForm();

}]);
