'use strict';

citApp.controller('EventoRecebimentoObjetoController', ['$scope',
                                                        '$timeout',
                                                        '$translate',
                                                        '$filter',
                                                        'EventoRecebimentoObjetoRepository',
                                                        'ContratoEventoRepository',
                                                        'ContratoRepository',
                                                        'DominioRepository',
                                                        'FileUploader',
                                                        function EventoRecebimentoObjetoController($scope,
                                                                                                   $timeout,
                                                                                                   $translate,
                                                                                                   $filter,
                                                                                                   EventoRecebimentoObjetoRepository,
                                                                                                   ContratoEventoRepository,
                                                                                                   ContratoRepository,
                                                                                                   DominioRepository,
                                                                                                   FileUploader) {


	$scope.getRecebimentoObjeto = function(){
		var idRecebimentoObjeto = $scope.evento.id;
		$scope.setLoadingGet(true);
		EventoRecebimentoObjetoRepository.get(idRecebimentoObjeto).then(function(result) {
			$scope.recebimentoObjeto = result.originalElement;
			if($scope.contratoTemp == undefined){
				$scope.contratoTemp= angular.copy($scope.recebimentoObjeto.contrato);
			}
			$scope.setLoading(false);
		});
	};

	$scope.resetForm = function(form) {

		if($scope.contratoTemp == undefined){
			$scope.contratoTemp= angular.copy($scope.contrato);
		}
		if($scope.evento){
			$scope.recebimentoObjeto.dataRecebimento = null;
			$scope.recebimentoObjeto.justificativa = "";
		} else {
			$scope.recebimentoObjeto = {
					contrato: $scope.contratoTemp,
					dataRecebimento : $filter('date')(new Date(), "dd/MM/yyyy"),
					tipoStatus : null,
					tipoRecebimento : null,
					tipoAvaliacaoPrazo : null,
					tipoAvaliacaoAdesao : null,
					justificativa : ""
			};
		}
		if(form != undefined){
			$timeout(function(){
				form.$submitted = true;
				form.$setPristine();
			});
		};
	};

	$scope.carregarDominios = function(){
		DominioRepository.findAllDominio('tipoEventoContratoRecebimentoObjeto').then(function(result) {
			angular.forEach(result, function(item, key){
				switch (item.codigo){
				case 1 :
					$scope.dominiosRecebimentoObjeto.tiposRecebimentos.push(item.originalElement);
					break;
				case 2 :
					$scope.dominiosRecebimentoObjeto.tiposRecebimentos.push(item.originalElement);
					break;
				case 3 :
					$scope.dominiosRecebimentoObjeto.tiposStatus.push(item.originalElement);
					break;
				case 4 :
					$scope.dominiosRecebimentoObjeto.tiposStatus.push(item.originalElement);
					break;
				}
			});
		});

		DominioRepository.findAllDominio('tipoEventoContratoRecebimentoObjetoAvaliacaoPrazo').then(function(result) {
			angular.forEach(result, function(item, key){
				$scope.dominiosRecebimentoObjeto.tiposAvaliacaoPrazo.push(item.originalElement);
			});
		});
		DominioRepository.findAllDominio('tipoEventoContratoRecebimentoObjetoAvaliacaoAdesao').then(function(result) {
			angular.forEach(result, function(item, key){
				$scope.dominiosRecebimentoObjeto.tiposAvaliacaoAdesao.push(item.originalElement);
			});
		});
	};

	$scope.uploader = new FileUploader({
		autoUpload: false,
		queueLimit: 1,
		url : '/cit-tabelas-corp-web/rest/anexo/uploadAnexo?idDocumento='
	});

	$scope.salvarEvento = function(form){

		form.$submitted = true;
		if(form && !form.$invalid) {
			if ($scope.isInformacoesValidas()){
				$scope.setLoadingSalva(true);

				if($scope.recebimentoObjetoTemp == null){
					$scope.recebimentoObjetoTemp = {
							documentos : []
					};
					angular.forEach($scope.recebimentoObjeto.documentos, function(documento, key) {
						$scope.recebimentoObjetoTemp.documentos.push({
							uploadsDocumento : clone(documento.uploadsDocumento),
							numero : clone(documento.numero)
						});
						delete documento.uploadsDocumento;
					});
				};

				EventoRecebimentoObjetoRepository.save($scope.recebimentoObjeto).then(function(result) {
					$scope.recebimentoObjeto = result.originalElement;

					angular.forEach($scope.recebimentoObjeto.documentos, function(documentoSalvo, key) {
						if(documentoSalvo !== undefined && documentoSalvo.id !== undefined){
							angular.forEach($scope.recebimentoObjetoTemp.documentos, function(documentoTransient, key) {
								if(documentoSalvo.numero === documentoTransient.numero){
									salvarUpload(documentoSalvo, documentoTransient.uploadsDocumento);
								}
							});
						};
					});
					$scope.setLoading(false);
					$scope.$modalInstance.dismiss('cancel');
					$scope.showAlert("success", $translate.instant("MSG.MG001"));
					$scope.buscaOcorrencias($scope.contratoTemp);
				});
			};
		} else {
			$scope.showAlert('error', $translate.instant('MSG.MN001'));
		}
	};

	$scope.isInformacoesValidas = function () {

		var valido = true;

		if(!isDataDentroPeriodo($scope.contratoTemp.dataVigenciaInicial, $scope.contratoTemp.dataUltimaVigenciaFinal,
				$scope.recebimentoObjeto.dataRecebimento)){
			$scope.showAlert('warning', $translate.instant('MSG.DATA_RECEBIMENTO_INVALIDA'));
			valido = false;
		}
		return valido;
	};

	var salvarUpload = function(documento, uploadsDocumento){
		if (uploadsDocumento != undefined && uploadsDocumento != null) {
			$scope.uploader.queue = uploadsDocumento;
			angular.forEach($scope.uploader.queue, function(item, key) {
				item.url = item.url + documento.id;
			});
			$scope.uploader.uploadAll();
			$scope.uploader.isUploading = false;
		};
	};

	$scope.gerarRelatorioRecebimentoObjeto = function(){
		$scope.url = '/cit-contratos-web/rest/eventoRecebimentoObjeto/pdfGerarRecebimentoObjeto?idRecebimentoObjeto=' + $scope.recebimentoObjeto.id;
		$scope.visualizarRelatorio($scope.url, $translate.instant('LABEL.TITULO_DOCUMENTO_RECEBIMENTO'));
		$scope.$modalInstance.dismiss('cancel');

	};

	(function init(){
		$scope.dominiosRecebimentoObjeto = {
				tiposStatus: [],
				tiposRecebimentos : [],
				tiposAvaliacaoPrazo : [],
				tiposAvaliacaoAdesao : [],
		};
		$scope.carregarDominios();
		if($scope.evento){
			$scope.getRecebimentoObjeto();
		} else {
			$scope.resetForm();
		}
	})();

}]);
