'use strict';

citApp.controller('EventoRepactuacaoController', ['$scope', '$timeout', '$translate', 'EventoRepactuacaoRepository', 'FileUploader', '$filter',
                                                  'RegistroOcorrenciaRepository',
                                              function EventoRepactuacaoController($scope, $timeout, $translate, EventoRepactuacaoRepository,
                                            		  FileUploader, $filter, RegistroOcorrenciaRepository) {


	$scope.uploader = new FileUploader({
        autoUpload: false,
        queueLimit: 1,
        url : '/cit-tabelas-corp-web/rest/anexo/uploadAnexo?idDocumento='
    });

	$scope.resetForm = function(form) {
		if(!$scope.evento){
			$scope.repactuacao = {
					contrato : $scope.contratoTemp
			};
		}
		
		if($scope.contratoTemp == undefined){
			$scope.contratoTemp = angular.copy($scope.contrato);
		}
		$scope.contrato = angular.copy($scope.contrato);
		
		if(form){
			$scope.contrato = angular.copy($scope.contratoTemp);
			$timeout(function(){
				form.$submitted = true;
				form.$setPristine();
			});
		}
	};
	
	RegistroOcorrenciaRepository.findAllOcorrenciasPorContrato($scope.contrato.id).then(function(result) {
		$scope.listaOcorrencias = result;
		$scope.listaOcorrenciasFixa = result;
	});

	$scope.salvarRepactuacao = function(form){
		form.$submitted = true;
		if(form.$valid){
        	$scope.setLoadingSalva(true);
        	
			if($scope.repactuacaoTemp == null){
				$scope.repactuacaoTemp = {
						documentos : []
				};

				angular.forEach($scope.repactuacao.documentos, function(documento, key) {

					$scope.repactuacaoTemp.documentos.push({
						uploadsDocumento : clone(documento.uploadsDocumento),
						numero : clone(documento.numero)
					});
					delete documento.uploadsDocumento;
				});
			}
			
			if (!$scope.repactuacao.contrato) {
				$scope.repactuacao.contrato = $scope.contratoTemp;
			}
			
			EventoRepactuacaoRepository.save($scope.repactuacao).then(function(result) {
				$scope.repactuacao = result.originalElement;

				angular.forEach($scope.repactuacao.documentos, function(documentoSalvo, key) {
					if(documentoSalvo !== undefined && documentoSalvo.id !== undefined){
						angular.forEach($scope.repactuacaoTemp.documentos, function(documentoTransient, key) {
							if(documentoSalvo.numero === documentoTransient.numero){
								salvarUpload(documentoSalvo, documentoTransient.uploadsDocumento);
							}
						});
					}
				});

				$scope.setLoading(false);
				$scope.$modalInstance.dismiss('cancel');
				$scope.showAlert("success", $translate.instant("MSG.MG001"));
				$scope.resetForm();
				$scope.buscaOcorrencias($scope.contrato);
			});

		}else{
			$scope.showAlert('error', $translate.instant('MSG.MN001'));
		}
	};

	  var salvarUpload = function(documento, uploadsDocumento){
		  if (uploadsDocumento != undefined && uploadsDocumento != null) {
			  $scope.uploader.queue = uploadsDocumento;
			  angular.forEach($scope.uploader.queue, function(item, key) {
				  item.url =  item.url + documento.id;
			  });
			  $scope.uploader.uploadAll();
			  $scope.uploader.isUploading = false;
		  }
	  };
	  
  $scope.gerarRelatorioRepactuacao = function () {
	    $scope.url = '/cit-contratos-web/rest/eventoRepactuacao/gerarRepactuacao?idRepactuacao=' + $scope.repactuacao.id;
	    $scope.visualizarRelatorio($scope.url, $translate.instant('CONTRATOS.LABEL.TITULO_RELATORIO_REPACTUACAO'));
	    $scope.$modalInstance.dismiss('cancel');
	  };

    $scope.resetForm();

}]);
