'use strict';
citApp.controller('ObjetivoEstrategicoListController', ['$scope', '$translate', '$timeout', 'ObjetivoEstrategicoRepository', 
          function ObjetivoEstrategicoListController($scope, $translate, $timeout, ObjetivoEstrategicoRepository) {

    $scope.resetForm = function() {
        angular.element("#editObjetivoEstrategico").scope().resetForm();
    };

	$scope.headers = [
	{
		value : 'nome',
		title : $translate.instant('LABEL.OBJETIVO_ESTRATEGICO'),
		align : 'text-justify',
		tamanho : 45
	},{
		value : 'necessidadeElecandasDesricao',
		title : $translate.instant('CONTRATOS.LABEL.NECESSIDADE_ELENCADA'),
		tamanho : 50,
		scapeHtml : true,
		align : 'text-left'
	}];

	// default criteria that will be sent to the server
	$scope.filterCriteria = {
			start : 1,
			dir : 'asc',
			sort : 'id',
			limit : 10,
			fields: ['id', 'nome', 'necessidadeElecandasDesricao'],
			filters : [{type: 'string', field: 'descricao'},
			           {type: 'string', field: 'necessidade'}]
	};


	// abrir um objetivo estratégico para visualizar ou editar dependendo do parametro edit
	$scope.abrirObjetivoEstrategico = function(edit){
		var objetivoEstrategico = $scope.objetivoEstrategicoChecked["id"];

		if(!edit && !objetivoEstrategico) {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO'));
			return;
		}

		if(edit && !objetivoEstrategico) {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
			return;
		}

		angular.element('#editObjetivoEstrategico').scope().getObjetivoEstrategico(objetivoEstrategico, edit);
		$scope.$showPageEditWorkspace($scope.workspace);
	};

	$scope.remover = function() {
		var objetivoEstrategico = {
				id : $scope.objetivoEstrategicoChecked['id']
		};

		if(objetivoEstrategico) {

			$scope.$openModalConfirm({
				message: $translate.instant("MSG.DESEJA_EXCLUIR_ITEM"),
				callback: function () {
					$scope.setLoadingRemove(true);

					ObjetivoEstrategicoRepository.remove(objetivoEstrategico).then(function() {
						$scope.showAlert('success', $translate.instant('MSG.EXCLUSAO_SUCESSO'), " ", false);
						$scope.fetchResult();
					});

					$scope.$modalConfirmInstance.dismiss('cancel');
					$scope.setLoading(false);
				}
			});

		} else {

			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_SER_REMOVIDO'));
		}
	};

}]);