'use strict';

citApp.controller('QuestionarioListController', ['$scope', 'QuestionarioRepository', 'DominioRepository', '$translate',
                                                 function QuestionarioListController($scope, QuestionarioRepository, DominioRepository, $translate) {
	
	$scope.headers = [
	  	{
	  		value : 'nome',
	  		title : $translate.instant('LABEL.NOME'),
	  		tamanho: 60,
	  		align : 'text-justify'
	  	},{
	  		value : 'dominioTipoQuestionario.descricao',
	  		title : $translate.instant('LABEL.TIPO_QUESTIONARIO'),
	  		tamanho : 35
	  	}];
	
	// default criteria that will be sent to the server
	$scope.filterCriteria = {
			start : 1,
			dir : 'asc',
			sort : 'id',
			limit : 10,
			fields: ['id', 'nome', 'dominioTipoQuestionario.descricao'],
			filters : [{type: 'string', field: 'nome'},
			           {type: 'string', field: 'dominioTipoQuestionario.descricao'}]
	};

	DominioRepository.findAllDominio('tipoImplementacao').then(function(result) {
		$scope.dominiosTipoImplementacao = result;
	});

	$scope.resetForm = function() {
		angular.element("#editQuestionario").scope().resetForm();
	};
	
	// abrir uma EstudoTecnico para visualizar ou editar dependendo do parametro edit
	$scope.abrirQuestionario = function(edit){
		// recupera a EstudoTecnico selecionada
		var questionario = $scope.questionarioChecked;

		if(!edit && !questionario) {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO'));
			return;
		}

		if(edit && !questionario) {
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
			return;
		}

		angular.element('#editQuestionario').scope().resetForm();
		angular.element('#editQuestionario').scope().getQuestionario(questionario, edit);
		$scope.$showPageEditWorkspace($scope.workspace);
	};

	$scope.cadastrarNovoQuestionario = function(){
		angular.element("#editQuestionario").scope().resetForm();
	};

	// prepara a exclusão da EstudoTecnico abrindo o modal de confirmação
	$scope.removerQuestionario = function(){
		if($scope.questionarioChecked && $scope.questionarioChecked.id){
			angular.element('#editQuestionario').scope().remove($scope.questionarioChecked);
		}else{
			$scope.showAlert('warning', $translate.instant('MSG.SELECIONE_ITEM_EXCLUIR'));
		}
	};
}]);


