'use strict';

citApp.controller('TermoEventoContratoController', ['$scope',
                                                    '$translate',
                                                    '$timeout',
                                                    'ContratoEventoRepository',
                                                    'ContratoRepository',
                                                    'DominioRepository',
                                                    function TermoEventoContratoController($scope,
                                                    		$translate,
                                                    		$timeout,
                                                    		ContratoEventoRepository,
                                                    		ContratoRepository,
                                                    		DominioRepository) {

	$scope.evento = null;
	$scope.contrato = null;
	$scope.listaEvento = [];
	$scope.termos = [];
	$scope.termosTemp = [];
	$scope.selectedAllTermos = false;

	DominioRepository.findAllDominio('tipoEventoContrato').then(function (result) {
		angular.forEach(result, function(dominio, key) {
			if(dominio.codigo != 2 &&  dominio.codigo != 4 && dominio.codigo != 5 && dominio.codigo != 6 && dominio.codigo != 7 && dominio.codigo != 9){
				$scope.termosTemp.push({tipoEvento : { descricao : dominio.descricao, codigo : dominio.codigo}});
				$scope.termos.push({tipoEvento : { descricao : dominio.descricao, codigo : dominio.codigo}});
			}
		});
	});

	$scope.findContrato = function (value) {
		return ContratoRepository.findContrato(value, $scope.usuarioLogado.organizacao.id).then(function (result) {
			return result;
		});
	};

	$scope.buscarEventos = function (contrato) {
		$scope.contratoEventos = [];
		if(contrato.id){
			$scope.setLoadingGet(true);
			ContratoEventoRepository.buscaTermosContrato(contrato.id, $scope.dataInicio, $scope.dataFim).then(function (result) {
				$scope.setLoading(false);
				$scope.termos = result;
				$scope.setLoadingGet(false);
			});
		}
	};

	$scope.resetForm = function () {
		$scope.contrato = null;
		$scope.selectedAllTermos = false;
		$scope.termos = angular.copy($scope.termosTemp);
		$timeout(function(){
			$scope.consultaTermoForm.$submitted = true;
			$scope.consultaTermoForm.$setPristine();
		});
	};

	$scope.cleanData = function () {
		$scope.dataInicio = null;
		$scope.dataFim = null;
	};

	$scope.buscaEventosData = function(){
		if($scope.contrato){
			$scope.buscarEventos($scope.contrato);
		}
	};

	$scope.gerarTermo = function() {
		$scope.consultaTermoForm.$submitted = true;
		if($scope.consultaTermoForm.$valid){
			$scope.setLoading(true);
			var codigoTermoChecked = [];
			angular.forEach($scope.termos, function(termo) {
				if(termo.$checked){
					codigoTermoChecked.push(termo.tipoEvento.codigo);
				}
			});

			if(codigoTermoChecked.length == 0){
				if($scope.contrato){
					angular.forEach($scope.termos, function(termo) {
						codigoTermoChecked.push(termo.tipoEvento.codigo);
					});
				}else{
					angular.forEach($scope.termosTemp, function(termo) {
						codigoTermoChecked.push(termo.tipoEvento.codigo);
					});
				}
			}

			if(!$scope.dataInicio){
				$scope.dataInicio = '';
			}
			if(!$scope.dataFim){
				$scope.dataFim = '';
			}

			if($scope.contrato){
				$scope.url = '/cit-contratos-web/rest/contratoEvento/pdfGerarTermos?tiposTermo='+ codigoTermoChecked + '&idContrato=' + $scope.contrato.id + '&dataInicial=' + $scope.dataInicio + '&dataFinal=' + $scope.dataFim ;
			}else{
				$scope.url = '/cit-contratos-web/rest/contratoEvento/pdfGerarTermos?tiposTermo='+ codigoTermoChecked + '&dataInicial=' + $scope.dataInicio + '&dataFinal=' + $scope.dataFim ;
			}
			$scope.visualizarRelatorio($scope.url,$translate.instant('CONTRATOS.LABEL.TERMOS'));

		}else{
			$scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'));
		}
	};

}]);
