'use strict';

citApp.controller('VisaoContratoController', ['$scope',
                                              '$filter',
                                              '$timeout',
                                              '$translate',
                                              'ContratoEventoRepository',
                                              'ContratoRepository',
                                              'DominioRepository',
                                              'EventoAtualizacaoStatusRepository',
                                              'EventoLiberacaoPagamentoRepository',
                                              'EventoAditivoRepository',
                                              'EventoRegistroNaoConformidadeRepository',
                                              'EventoRecebimentoObjetoRepository',
                                              'EventoRescisaoContratoRepository',
                                              'EventoRepactuacaoRepository',
                                              'EventoLiberacaoPagamentoEmpenhoRepository',
                                              function VisaoContratoController($scope,
                                                                               $filter,
                                                                               $timeout,
                                                                               $translate,
                                                                               ContratoEventoRepository,
                                                                               ContratoRepository,
                                                                               DominioRepository,
                                                                               EventoAtualizacaoStatusRepository,
                                                                               EventoLiberacaoPagamentoRepository,
                                                                               EventoAditivoRepository,
                                                                               EventoRegistroNaoConformidadeRepository,
                                                                               EventoRecebimentoObjetoRepository,
                                                                               EventoRescisaoContratoRepository,
                                                                               EventoRepactuacaoRepository,
                                                                               EventoLiberacaoPagamentoEmpenhoRepository) {

      $scope._START_ITEMS = 0;
      $scope._LIMIT_ITEMS = 15;

      $scope.classCssSituacaoContrato = {
        VIGENTE : "contrato-evento-green",
        SUSPENSO : "contrato-evento-yellow",
        RESCINDIDO : "contrato-evento-orange",
        ENCERRADO : "contrato-evento-red"
      };

      $scope.evento = null;

      $scope.contrato = null;

      $scope.findContrato = function (value) {
        return ContratoRepository.findContrato(value, $scope.usuarioLogado.organizacao.id).then(function (result) {
          return result;
        });
      };

      $scope.abreModal = function (acaoCodigo) {

          var acao = {};

          switch (acaoCodigo) {
          case 'ADITIVO':
            if ($scope.evento) {
              var idAditivo = $scope.evento.id;
              $scope.setLoadingGet(true);
              EventoAditivoRepository.get(idAditivo).then(function(result) {
                $scope.aditivo = result.originalElement;

                $scope.$openModalController('modal-cnt_ev_aditivo.html', 'lg', 'EventoAditivoController');
                $scope.setLoading(false);
              });
            } else {
              $scope.$openModalController('modal-cnt_ev_aditivo.html', 'lg', 'EventoAditivoController');
            }
            break;
          case 'PENALIDADE':
            $scope.$openModalController('cnt_ev_aplicar_penalidade.html', 'lg', 'EventoPenalidadeController');
            break;
          case 'APOSTILAMENTO':
            $scope.$openModalController('cnt_ev_apostilamentoModal.html', 'lg', 'EventoApostilamentoController');
            break;
          case 'ATUALIZA_STATUS':

            if($scope.contrato.dominioSituacaoAtual.codigo == 2 || $scope.contrato.dominioSituacaoAtual.codigo == 4 && $scope.edit){
              $scope.showAlert('warning', $translate.instant('CONTRATOS.MSG.ALTERACAO_STATUS_NEGADA').concat($scope.contrato.dominioSituacaoAtual.descricao));
                return;
            }else{
              $scope.$openModalController('modal-cnt_ev_atualizacao_status.html', 'lg', 'EventoAtualizacaoStatusController');
            }
            break;
          case 'LIBERA_PAGAMENTO':
            EventoLiberacaoPagamentoRepository.getValorTotalLiberado($scope.contrato.id).then(function(result) {
            if(result == undefined){
              $scope.contrato.valorTotalLiberado = 0;
            } else{
              $scope.contrato.valorTotalLiberado = result;
            }

            if(!$scope.edit){
              $scope.$openModalController('modal-cnt_ev_liberacao_pagamento.html', 'lg', 'EventoLiberacaoPagamentoController');
            }else{
              if($scope.contrato.valorTotalLiberado < $scope.contrato.valorContrato){
                $scope.$openModalController('modal-cnt_ev_liberacao_pagamento.html', 'lg', 'EventoLiberacaoPagamentoController');
              }else{
                $scope.showAlert('warning', $translate.instant('CONTRATOS.VALIDACAO.VALOR_TOTAL_CONTRATO_JA_LIBERADO'));
              }
            }

            });
            break;
          case 'EMPENHO':
        	$scope.valorResidual = $scope.valorTotalContratoAditivado - $scope.contratoEventos[0].contrato.totalEmpenhado;
            $scope.$openModalController('cnt_ev_empenho.html', 'lg', 'EventoEmpenhoController');
            break;
          case 'NAO_CONFORMIDADE':

            $scope.$openModalController('modal-cnt_ev_registro_nc.html', 'lg', 'EventoRegistroNaoConformidadeController');
            break;
          case 'RECEBIMENTO_OBJETO':
        	  $scope.setLoadingGet(true);
        	  if ($scope.evento) {
        		  var recebimentoObjetoid = $scope.evento.id;
        			EventoRecebimentoObjetoRepository.get(recebimentoObjetoid).then(function(result) {
        				$scope.recebimentoObjeto = result.originalElement;
        			});
        	  }
    		  $scope.$openModalController('modal-cnt_ev_recebimentoobjeto.html', 'lg', 'EventoRecebimentoObjetoController');
    		  $scope.setLoadingGet(false);
        	  break;
          case 'REPACTUACAO':
            if ($scope.evento) {
              var idRepactuacao = $scope.evento.id;
              $scope.setLoadingGet(true);
              EventoRepactuacaoRepository.get(idRepactuacao).then(function(result) {
                $scope.repactuacao = result.originalElement;

                $scope.$openModalController('modal-cnt_ev_repactuacao.html', 'lg', 'EventoRepactuacaoController');
                $scope.setLoading(false);
              });
            } else {
              $scope.$openModalController('modal-cnt_ev_repactuacao.html', 'lg', 'EventoRepactuacaoController');
            }
            break;
          case 'RESCISAO':
            if ($scope.evento) {
              $scope.setLoadingGet(true);
              EventoRescisaoContratoRepository.get($scope.evento.id).then(function(result) {
                $scope.rescisaoContrato = result.originalElement;

                $scope.$openModalController('modal-cnt_ev_rescisao_contrato.html', 'lg', 'EventoRescisaoContratoController');
                $scope.setLoading(false);
              });
            } else {
              $scope.$openModalController('modal-cnt_ev_rescisao_contrato.html', 'lg', 'EventoRescisaoContratoController');
            }
            break;
          }
      };

      $scope.visualizarModal = function (evento) {
        $scope.edit = false;
        $scope.abreModal(evento.tipoEvento.nome);
      };

      $scope.editarModal = function (evento) {
    	$scope.edit = true;

		if($scope.evento.aditivoDePrazo){
			EventoAditivoRepository.existeAditivoPrazoPosterior($scope.evento.id).then(function (result) {
			  $scope.naoPermiteAlterarDataFim = result;
			  $scope.abreModal(evento.tipoEvento.nome);
			 });
		}else{
			$scope.abreModal(evento.tipoEvento.nome);
		}

      };

      $scope.criarEvento = function () {
    	  $scope.naoPermiteAlterarDataFim = false;
    	  $scope.evento = null;
	      $timeout(function () {
	          $scope.edit = true;
	          $scope.abreModal($scope.contrato.contratoEvento.tipoEventoId);
	          delete $scope.contrato.contratoEvento;
	      });
      };

      var eventoClasses = {
        ADITIVO : {
          icon : 'files-o',
          color : 'green'
        },
        PENALIDADE : {
          icon : 'gavel',
          color : 'red'
        },
        APOSTILAMENTO : {
          icon : 'folder-open',
          color : 'blue'
        },
        ATUALIZA_STATUS_VIGENTE : {
          icon : 'check-circle',
          color : 'green'
        },
        ATUALIZA_STATUS_ENCERRADO : {
          icon : 'times-circle',
          color : 'red'
        },
        ATUALIZA_STATUS_SUSPENSO : {
          icon : 'exclamation-circle',
          color : 'yellow'
        },
        ATUALIZA_STATUS_RESCINDIDO : {
          icon : 'minus-circle',
          color : 'orange'
        },
        LIBERA_PAGAMENTO : {
          icon : 'money',
          color : 'green'
        },
        EMPENHO : {
          icon : 'money',
          color : 'blue'
        },
        NAO_CONFORMIDADE_TIPO_NOTIFICACAO_ADVERTENCIA : {
          icon : 'exclamation-triangle',
          color : 'yellow'
        },
        NAO_CONFORMIDADE_TIPO_NOTIFICACAO_MULTA : {
            icon : 'exclamation-triangle',
            color : 'orange'
       },
       NAO_CONFORMIDADE_TIPO_NOTIFICACAO_SUSPENSAO_TEMPORARIA : {
          icon : 'exclamation-triangle',
          color : 'red'
        },
        NAO_CONFORMIDADE_TIPO_NOTIFICACAO_DECLARACAO_INIDONEIDADE : {
            icon : 'exclamation-triangle',
            color : 'black'
        },
        RECEBIMENTO_OBJETO : {
          icon : 'archive',
          color : 'pink'
        },
        REPACTUACAO : {
          icon : 'file-text',
          color : 'brown'
        },
        RESCISAO : {
          icon : 'minus-square',
          color : 'orange'
        },
        DATA_INICIAL : {
          icon : 'play-circle'
        },
        DATA_FINAL : {
          icon : "stop"
        }
      };

      // ############################## INICIO da função que traz os contratos e eventos ###################

      // Carrega os contratoEventos
      $scope.buscaOcorrencias = function (contrato) {
      $scope.vigenciaFinal = $translate.instant('CONTRATOS.LABEL.DATA_VIGENCIA_FINAL_CONTRATO');
      delete $scope.contrato.ultimaDataVigenciaFinal;
      $scope.endPointColor = "";
        $scope.contratoEventos = [];
        $scope.valorTotalLiberado = 0;
        $scope.valorTotalContratoAditivado = $scope.contrato.valorContrato;
        $scope.porcentagemEmpenho = 0;
        $scope.valorResidualCalculado = 0;
        $scope.setLoadingGet(true);
        $timeout(function () {


          ContratoEventoRepository.buscaEventosContrato(contrato.id).then(function (result) {
            $scope.setLoading(false);
            var contratoEventos = result;

            for (var i = 0; i < result.contrato.aditivos.length; i++) {
              var aditivo = result.contrato.aditivos[i];
              if (aditivo.aditivoDePrazo) {
                var colorIcon = "green";
              $scope.vigenciaFinal = $translate.instant('CONTRATOS.LABEL.DATA_VIGENCIA_FINAL_ADITIVO');
              var ultimaDataFinal = $scope.contrato.ultimaDataVigenciaFinal ? $scope.contrato.ultimaDataVigenciaFinal : $scope.contrato.dataVigenciaFinal;
              var eventoDataInicial = {
                dataVigencia : true,
                dataEvento : aditivo.dataInicio,
                tipoEvento : {descricao : $translate.instant('CONTRATOS.LABEL.DATA_VIGENCIA_INICIAL_ADITIVO')},
                iconClass : eventoClasses["DATA_INICIAL"].icon,
                colorClass : colorIcon
              };

              contratoEventos.eventos.push(eventoDataInicial);
              var finalContratoValid = false;
              if (isPeriodoValido(ultimaDataFinal, aditivo.dataFim)) {
                var tipoEvento = {descricao : $translate.instant('CONTRATOS.LABEL.DATA_VIGENCIA_FINAL_ADITIVO')};
                if (ultimaDataFinal == $scope.contrato.dataVigenciaFinal) {
                	finalContratoValid = true;
                  tipoEvento = {descricao : $translate.instant('CONTRATOS.LABEL.DATA_VIGENCIA_FINAL_CONTRATO')};
                  colorIcon = "";
                  }
                var eventoDataFinalAnterior = {
                		dataVigencia : true,
                        dataEvento : ultimaDataFinal,
                        tipoEvento : tipoEvento,
                        iconClass : eventoClasses["DATA_FINAL"].icon,
                        colorClass : colorIcon,
                        finalContrato : finalContratoValid
                };
                contratoEventos.eventos.push(eventoDataFinalAnterior);
                $scope.contrato.ultimaDataVigenciaFinal = aditivo.dataFim;
                $scope.endPointColor = "green";

                $scope.eventoFinal = eventoDataFinalAnterior;

              }
              }
            }
            var eventoInicialContrato = {
            		dataInicial : true,
            		dataEvento : $scope.contrato.dataVigenciaInicial,
            		tipoEvento : {descricao : $translate.instant('CONTRATOS.LABEL.DATA_VIGENCIA_INICIAL_CONTRATO')},
            		iconClass : eventoClasses["DATA_INICIAL"].icon,
            };
            contratoEventos.eventos.push(eventoInicialContrato);

            contratoEventos.eventos = $filter('orderListByDataEmissao')(contratoEventos.eventos);

            var ultimaDataOcorrencia = null;
            contratoEventos.contratoEventosForScreen = [];

            if (contratoEventos.eventos.length > 0) {
              for (var j = 0; j < contratoEventos.eventos.length; j++) {
                var evento = contratoEventos.eventos[j];

                // Apenas para eviar a aplicação de para caso ocorra algum erro
                try {
                  var dataOcorrenciaDate = converterStringEmDate(evento.dataEvento);

                  if (!ultimaDataOcorrencia || ultimaDataOcorrencia.getMonth() !== dataOcorrenciaDate.getMonth() || ultimaDataOcorrencia.getFullYear() !== dataOcorrenciaDate.getFullYear()) {
                    ultimaDataOcorrencia = dataOcorrenciaDate;
                    contratoEventos.contratoEventosForScreen.push({
                      monthStart : true,
                      dataEvento : $filter('date')(ultimaDataOcorrencia, "MMM / yy")
                    });
                  }
                } catch (e) {}

                evento.monthStart = false;

                if (evento.tipoEvento && evento.tipoEvento.nome == "ADITIVO") {
                    EventoAditivoRepository.get(evento.id).then(function (result) {
                  	  if(result.aditivoDeValor){
                  		  if(result.tipoAlteracaoValor.nome == 'ACRESCIMO'){
                  			  $scope.valorTotalContratoAditivado += result.valorAditivo;
                  		  }else{
                  			  $scope.valorTotalContratoAditivado -= result.valorAditivo;
                  		  }
                  	  }
                  	  $scope.porcentagemEmpenho = ($scope.valorTotalEmpenhado * 100) / $scope.valorTotalContratoAditivado;
                  	  if($scope.porcentagemEmpenho > 100){
                  		$scope.porcentagemEmpenho = 100;
                  	  }

                  	$scope.valorResidualCalculado = Math.abs($scope.valorTotalContratoAditivado - $scope.valorTotalEmpenhado);
                    });
                }

                if (evento.tipoEvento && evento.tipoEvento.nome == "ATUALIZA_STATUS") {
                  EventoAtualizacaoStatusRepository.get(evento.id).then(function (result) {
                    for (var k = 0; k < contratoEventos.contratoEventosForScreen.length; k++) {
                      if (contratoEventos.contratoEventosForScreen[k].id == result.id) {
                        contratoEventos.contratoEventosForScreen[k].iconClass = eventoClasses[contratoEventos.contratoEventosForScreen[k].tipoEvento.nome + "_" + result.tipoSituacaoNova.nome].icon;
                        contratoEventos.contratoEventosForScreen[k].colorClass = eventoClasses[contratoEventos.contratoEventosForScreen[k].tipoEvento.nome + "_" + result.tipoSituacaoNova.nome].color;
                      }
                    }
                  });
                } else if (evento.tipoEvento && evento.tipoEvento.nome == "NAO_CONFORMIDADE") {
                  EventoRegistroNaoConformidadeRepository.get(evento.id).then(function (result) {
                        for (var k = 0; k < contratoEventos.contratoEventosForScreen.length; k++) {
                          if (contratoEventos.contratoEventosForScreen[k].id == result.id) {
                            contratoEventos.contratoEventosForScreen[k].iconClass = eventoClasses[contratoEventos.contratoEventosForScreen[k].tipoEvento.nome + "_" + result.tipoNaoConformidade.dominioTipoSancao.nome].icon;
                            contratoEventos.contratoEventosForScreen[k].colorClass = eventoClasses[contratoEventos.contratoEventosForScreen[k].tipoEvento.nome + "_" + result.tipoNaoConformidade.dominioTipoSancao.nome].color;
                          }
                        }
                      });
                    }else if (evento.tipoEvento && evento.tipoEvento.nome) {
                  evento.iconClass = eventoClasses[evento.tipoEvento.nome].icon;
                  evento.colorClass = eventoClasses[evento.tipoEvento.nome].color;
                }
                contratoEventos.contratoEventosForScreen.push(evento);
              }
            }

            var totalEmpenho = 0;
            if (contratoEventos.empenhos && contratoEventos.empenhos.length > 0) {
              for (var k = 0; k < contratoEventos.empenhos.length; k++) {
                totalEmpenho += contratoEventos.empenhos[k].valorEmpenhado;
              }
            }

            var porcentagem = (totalEmpenho * 100) / contratoEventos.contrato.valorContrato;
            $scope.porcentagemEmpenho = porcentagem;
        	  if($scope.porcentagemEmpenho > 100){
            		$scope.porcentagemEmpenho = 100;
            	  }
            contratoEventos.contrato.totalEmpenhado = totalEmpenho;
            contratoEventos.contrato.porcentagemEmpenhado = porcentagem;
            $scope.contratoEventos.push(contratoEventos);
            $scope.contrato.dominioSituacaoAtual = contratoEventos.contrato.dominioSituacaoAtual;
            $scope.valorTotalEmpenhado = totalEmpenho;

            $scope.valorResidualCalculado = Math.abs(contratoEventos.contrato.valorContrato - totalEmpenho);

            $scope.dataTerminoContrato = $scope.contrato.ultimaDataVigenciaFinal != undefined ? $scope.contrato.ultimaDataVigenciaFinal : $scope.contrato.dataVigenciaFinal;

            $scope.eventoFinal = {
                    dataEvento : $scope.dataTerminoContrato,
                    tipoEvento : {descricao : $scope.vigenciaFinal},
                  };

            $scope.setLoadingGet(false);
          });
        }, 1000);
      };

      $scope.mostrarEventoContrato = function(evento){
    	  if(!evento){
    		  evento = $scope.eventoFinal;
    	  }
    	  $scope.evento = evento;
          $scope.editEvento = false;
          $scope.removeEvento = false;
          $scope.visualizarEvento = false;
      };

      $scope.mostrarEvento = function (evento) {
        $scope.evento = evento;
        $timeout(function () {
          var acaoCodigo = evento.tipoEvento.nome;
          switch (acaoCodigo) {
          case 'ADITIVO':
        	$scope.visualizarEvento = true;
            $scope.editEvento = true;
            $scope.removeEvento = true;
              break;
          case 'PENALIDADE':
        	  $scope.visualizarEvento = true;
        	  $scope.editEvento = true;
              $scope.removeEvento = false;
              break;
          case 'APOSTILAMENTO':
        	  $scope.visualizarEvento = true;
              $scope.editEvento = true;
              $scope.removeEvento = true;
             break;
          case 'ATUALIZA_STATUS':
        	  $scope.visualizarEvento = true;
              $scope.editEvento = false;
              $scope.removeEvento = false;
             break;
          case 'LIBERA_PAGAMENTO':
        	  $scope.visualizarEvento = true;
              $scope.editEvento = true;
              $scope.removeEvento = true;
             break;
          case 'EMPENHO':
        	  $scope.visualizarEvento = true;
        	  $scope.editEvento = true;

        	  EventoLiberacaoPagamentoEmpenhoRepository.existeVinculoEmpenhoComLiberacaoPagamento($scope.evento.id).then(function(result) {
        		  $scope.removeEvento = !result;
    		  });
              break;
          case 'NAO_CONFORMIDADE':
        	  $scope.visualizarEvento = true;
              $scope.editEvento = true;
              $scope.removeEvento = false;
             break;
          case 'RECEBIMENTO_OBJETO':
        	  $scope.visualizarEvento = true;
        	  $scope.editEvento = true;
              $scope.removeEvento = false;
              break;
          case 'REPACTUACAO':
        	  $scope.visualizarEvento = true;
        	  $scope.editEvento = true;
              $scope.removeEvento = true;
              break;
          case 'RESCISAO':
        	  $scope.visualizarEvento = true;
        	  $scope.editEvento = false;
              $scope.removeEvento = false;
              break;
          default:
        	  $scope.visualizarEvento = true;
            	$scope.editEvento = false;
              $scope.removeEvento = false;
          }
        });
      };

      $scope.limparEvento = function () {
        $scope.evento = null;
      };

      // ############################## FIM da função que traz os contratos e eventos ###################

      // ###################### INICIO DOMINIOS ###########################

      // Carrega dominio de situacao do contrato
      DominioRepository.findAllDominio('tipoSituacaoContrato').then(function (result) {
        $scope.dominioSituacaoNovaList = result;
      });

      DominioRepository.findAllDominio('tipoEventoContrato').then(function (result) {
        $scope.acoesContrato = result;
      });

      // ###################### FIM DOMINIOS ######################

      $scope.resetForm = function () {
        $scope.contratoEventos = [];
        $scope.limparEvento();
        $timeout(function () {
          $scope.VisaoContratoForm.$submitted = false;
          $scope.VisaoContratoForm.$setPristine();
        });
      };

  $scope.removerEvento = function(){
	if($scope.evento.aditivoDePrazo){
		EventoAditivoRepository.permiteExclusaoAditivo($scope.evento.id).then(function (result) {
	        if(result){
	            $scope.evento.justificativaExclusao = '';
	            $scope.$openModal('modal-justificativa-exclusao.html', 'lg');
	        }else{
	        	$scope.showAlert('warning', $translate.instant('CONTRATOS.MSG.EXCLUSAO_ADITIVO_NEGADA'));
	        }
	      });
	}else{
		$scope.evento.justificativaExclusao = '';
		$scope.$openModal('modal-justificativa-exclusao.html', 'lg');
	}
  };

  $scope.salvarJustificativaExclusao = function(form){

    form.$submitted = true;

    if (form && form.$invalid){
      $scope.showAlert('error', $translate.instant('MSG.MN001'));
    } else {
      $scope.$modalInstance.dismiss('cancel');
      $scope.$openModalConfirm({
        message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
        callback: function () {
          $scope.$modalConfirmInstance.dismiss('cancel');
          $scope.setLoadingSalva(true);
          ContratoEventoRepository.removeEventoContrato($scope.evento.justificativaExclusao, $scope.evento.id).then(function(result) {
            form.$submitted = false;
            form.$setPristine();
            $scope.$modalInstance.dismiss('cancel');
            $scope.showAlert("success", $translate.instant("MSG.MG001"));
            $scope.evento = null;
            $scope.buscaOcorrencias($scope.contrato);
            $scope.setLoading(false);
          });
        }
      });
    }
  };

  //Watch para calcular valor da porcentagem do aditivo
    $scope.$watch('contrato.id', function() {
        if ($scope.contrato) {
          $scope.buscaOcorrencias($scope.contrato);
        }
    });

}]);

citApp.filter('orderListByDataEmissao', [ function(){ //Ordena a lista pela data de emissão
  return function(input) {
      if (!angular.isObject(input)) return input;

      var array = [];
      for(var objectKey in input) {
        if (objectKey != "fill") {
          array.push(input[objectKey]);
        }
      }

      array.sort(function(a, b){
    	  if(b.dataInicial && a.dataEvento == b.dataEvento){
    		  return 1;
    	  }

        var alc = converterStringEmDate(a.dataEvento),
            blc = converterStringEmDate(b.dataEvento);
        return alc > blc ? 1 : alc < blc ? -1 : 0;
      });
      return array;
   };
}]);
