'use strict';

citApp.factory('ContratoEventoRepository', ['RestangularContratos', 'AbstractRepository', function (restangularContratos, AbstractRepository) {

    function ContratoEventoRepository() {
    	AbstractRepository.call(this, restangularContratos, 'rest/contratoEvento');

    	this.buscaEventosContrato = function(contratoId) {
    		return restangularContratos.all(this.route+'/buscaEventosContrato').post(contratoId);
    	};

       	this.removeEventoContrato = function(justificativaRemocao, idEvento){
    		return 	restangularContratos.one(this.route + "/removeEventoContrato").get({"justificativaRemocao" : justificativaRemocao, "idEvento" : idEvento}).then();
    	};

    	this.buscaEventosContratoPorTipo = function(contratoId, tipoEvento) {
    		return restangularContratos.one(this.route).getList("buscaEventosContratoPorTipo", {contratoId : contratoId, tipoEvento : tipoEvento}).then();
    	};

    	this.buscaTermosContrato = function(contratoId, dataInicial, dataFinal) {
    		return restangularContratos.one(this.route+"/buscaTermosContrato").get({"contratoId" : contratoId, "dataInicial": dataInicial, "dataFinal" : dataFinal}).then();
    	};

    	this.listaIdEventosTermo = function(termos, dataInicial, dataFinal) {
    		return restangularContratos.one(this.route+"/listaIdEventosTermo").get({"termos" : termos, "dataInicial": dataInicial, "dataFinal" : dataFinal}).then();
    	};
    }

    AbstractRepository.extend(ContratoEventoRepository);

    return new ContratoEventoRepository();
}]);
