'use strict';

citApp.factory('ContratoRepository', ['RestangularContratos', 'AbstractRepository', function (restangularContratos, AbstractRepository) {

    function ContratoRepository() {
    	AbstractRepository.call(this, restangularContratos, 'rest/contrato');
    	
    	this.gerarRelatorio = function(params) {
    		return restangularContratos.all(this.route + '/pageRelatorio').post(params);
    	};

    	this.getRelatorio = function(params) {
    		return restangularContratos.all(this.route + '/imprimirRelatorio').post(params);
    	};
    	
    	this.obterPercentualGarantia = function(valorContrato){
    		return restangularContratos.one(this.route + "/obterPercentualGarantia").get({"valorContrato": valorContrato}).then();
    	};

    	this.findContrato = function(numeroAnoContrato, idOrganizacao) {
    		return restangularContratos.one(this.route).getList("findContrato", {"numeroAnoContrato": numeroAnoContrato, "idOrganizacao" : idOrganizacao}).then();
    	};

    	this.getGestor = function(idContrato) {
    		return restangularContratos.one(this.route + "/getGestor").get({"idContrato": idContrato}).then();
    	};

		this.findAutoCompleteContratoByNumeroAndOrganizacao = function(value, idOrganizacao) {
			return restangularContratos.one('rest/contrato').getList("findAutoCompleteContratoByNumeroAndOrganizacao", {"numeroAnoContrato" : value, "idOrganizacao" : idOrganizacao}).then();
		};

    }

    AbstractRepository.extend(ContratoRepository);

    return new ContratoRepository();
}]);
