'use strict';

citApp.factory('EventoAditivoRepository', ['RestangularContratos', 'AbstractRepository', function(restangularContratos, AbstractRepository) {

	function EventoAditivoRepository() {
		AbstractRepository.call(this, restangularContratos, 'rest/eventoAditivo');

		this.findAllByContrato = function(contratoId) {
    		return restangularContratos.all(this.route+'/findAllByContrato').post(contratoId);
    	};

		this.permiteExclusaoAditivo = function(aditivoId) {
			return restangularContratos.one(this.route + "/permiteExclusaoAditivo").get({"aditivoId": aditivoId}).then();
    	};
		this.existeAditivoPrazoPosterior = function(aditivoId) {
			return restangularContratos.one(this.route + "/existeAditivoPrazoPosterior").get({"aditivoId": aditivoId}).then();
    	};

	}

	AbstractRepository.extend(EventoAditivoRepository);

	return new EventoAditivoRepository();
}]);