'use strict';

citApp.factory('QuestionarioRepository', ['RestangularContratos', 'AbstractRepository', function (restangularContratos, AbstractRepository) {

    function QuestionarioRepository() {
    	AbstractRepository.call(this, restangularContratos, 'rest/questionario');
    	
    	this.listarQuestionarios = function(nome) {
    		return restangularContratos.one('rest/questionario').getList("listarQuestionarios", {"nome": nome}).then();
    	};
    	
    	this.findAllByOrganizacao = function() {
    		return restangularContratos.one('rest/questionario').getList("findAllByOrganizacao").then();
    	};
    	
    	this.findAllByDominioTipoQuestionario = function(tipoQuest) {
    		return restangularContratos.one('rest/questionario').getList("findAllByDominioTipoQuestionario", {"tipoQuestCodigo": tipoQuest.codigo}).then();
    	};
    	
    	this.createQuestionarioPadrao = function() {
    		return restangularContratos.one(this.route + "/createQuestionarioPadrao").get();
    	};
    }
    
    AbstractRepository.extend(QuestionarioRepository);
    
    return new QuestionarioRepository();
}]);