package br.com.centralit.controller.test.utils;

import java.io.IOException;
import java.nio.charset.Charset;

import org.apache.commons.io.IOUtils;
import org.apache.log4j.Logger;
import org.springframework.http.MediaType;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governan&ccedil;a Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de neg&oacute;cio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 27/04/2015 - 11:38:00
 *
 * @version 1.0.0
 *
 * @author iago.almeida (<a href="mailto:iago.almeida@centralit.com.br">iago.almeida@centralit.com.br</a>)
 *
 */
public class TestUtil {

	public static final Logger LOG = Logger.getLogger(TestUtil.class);

	public static final MediaType APPLICATION_JSON_UTF8 = new MediaType(MediaType.APPLICATION_JSON.getType(),
			MediaType.APPLICATION_JSON.getSubtype(), Charset.forName("utf8"));

	public static byte[] convertObjectToJsonBytes(Object object) throws IOException {

		ObjectMapper mapper = new ObjectMapper();
		mapper.configure(SerializationFeature.FAIL_ON_EMPTY_BEANS, false);
		return mapper.writeValueAsBytes(object);
	}

	public static String convertObjectToJsonString(Object object) throws IOException {

		ObjectMapper mapper = new ObjectMapper();
		mapper.configure(SerializationFeature.FAIL_ON_EMPTY_BEANS, false);
		return mapper.writeValueAsString(object);
	}

	public static String getJsonFromFile(String fileName) {

		String json = "";
		try {
			json = IOUtils.toString(Thread.currentThread().getContextClassLoader().getResource("entitiesJson/" + fileName + ".json"),"UTF-8");
		} catch (IOException e) {
			LOG.error("Falha ao obter o arquivo json de templates" + e.getMessage());
		}
		return json;
	}

}
