CREATE TABLE ACCESSROLE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	roles VARCHAR(255),
	url VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE ADICAOBEMPRINCIPAL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	bempatrimonial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ADICAOBEMPRINCIPALITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datareferencia TIMESTAMP NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	adicaobemprincipal_id INTEGER,
	adicaobemprincipalinativado_id INTEGER,
	bempatrimonial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ANEXO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	anexo VARBINARY (1024),
	descricao VARCHAR(300),
	inativador_id INTEGER,
	documento_id INTEGER,
	documentoinativo_id INTEGER,
	dominiotipoanexo_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ANEXOIMAGEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	anexo VARBINARY (1024),
	descricao VARCHAR(300),
	idorgao INTEGER,
	inativador_id INTEGER,
	configuracaosistema_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE BAIRRO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	nome VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	cidade_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE BAIXA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo INTEGER,
	dataconclusao TIMESTAMP,
	datacontabilizacao TIMESTAMP,
	datainicio TIMESTAMP NOT NULL,
	verificarexistenciabemprincipal BOOLEAN,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	destino_id INTEGER,
	dominiosituacaobaixa_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipobaixa_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipobem_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	portador_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE BAIXADOCUMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	baixa_id INTEGER,
	baixainativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE BAIXAITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	dataestorno TIMESTAMP,
	sequencia INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	baixa_id INTEGER,
	baixainativo_id INTEGER,
	bempatrimonial_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE BAIXAOBSERVACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	baixa_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE BEMPATRIMONIAL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	bemprincipal BOOLEAN,
	codigo VARCHAR(30),
	datafinaldepreciacao TIMESTAMP,
	datafinalgarantia TIMESTAMP NOT NULL,
	datainicialgarantia TIMESTAMP NOT NULL,
	datainiciodepreciacao TIMESTAMP,
	numeropatrimonial VARCHAR(50),
	numeropatrimonialnumerico INTEGER,
	valoraquisicao DECIMAL(20,4) NOT NULL,
	valorliquido DECIMAL(20,4) NOT NULL,
	vidautiloriginal INTEGER,
	vidautilrestante INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	bempatrimonialprincipal_id INTEGER,
	detentor_id INTEGER,
	dominiosituacaofisica_id INTEGER,
	dominiostatus_id INTEGER,
	dominiostatusdepreciacao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipooperacao_id INTEGER,
	entradaitem_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	estruturaorganizacionalatual_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	estruturaorganizacionalcompra_id INTEGER,
	fornecedor_id INTEGER,
	material_id INTEGER,
	responsavel_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE BEMPATRIMONIALCARACTERISTICA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	arquivo VARBINARY (1024),
	valormaterialcaracteristica VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	bempatrimonial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	materialcaracteristica_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE BEMPATRIMONIALCARACTERISTICADOCUMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	bempatrimonialcaracteristica_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE CARACTERISTICA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	chavedominio VARCHAR(50),
	codigo VARCHAR(30),
	descricao VARCHAR(80),
	expressaoregular VARCHAR(50),
	tamanho INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipodado_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotiporestricao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CIDADE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	codigoibge VARCHAR(255),
	nome VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	estado_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE CLASSEPARCEIRO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	inativador_id INTEGER,
	dominiotipoparceiro_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE CLASSIFICACAOMATERIAL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	descricao VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	classificacaomaterialparent_id INTEGER,
	dominiotipoclassificacaomaterial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipomaterial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE CONFIGURACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	contacontabilalmoxarifado_id INTEGER,
	contacontabilextraviado_id INTEGER,
	dominiostatusbemextraviado_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONFIGURACAOALMOXARIFADO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	configuracao_id INTEGER,
	estruturaorganizacional_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONFIGURACAOCONTACONTABILALMOXARIFADO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	configuracao_id INTEGER,
	contacontabil_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONFIGURACAOCONTACONTABILEXTRAVIADO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	configuracao_id INTEGER,
	contacontabil_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONFIGURACAOSISTEMA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	anexoimagem_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONTACONTABIL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(15),
	codigosistemaorigem VARCHAR(15),
	descricao VARCHAR(100),
	percentualnaodepreciavel DECIMAL(20,4) NOT NULL,
	taxadepreciacaomensal DECIMAL(20,4) NOT NULL,
	vidautil INTEGER NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	contacontabilsaldoanterior_id INTEGER,
	dominiotipocontacontabil_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE CONTACONTABILCONFIGURACAOREFERENCIA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	apresentarelatoriomovimentacaobem BOOLEAN,
	mesreferencia DATE NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	contacontabil_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE CONTACONTABILMOVIMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datareferencia TIMESTAMP NOT NULL,
	valor DECIMAL(20,4),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	baixa_id INTEGER,
	bempatrimonial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	contacontabil_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipomovimentocontacontabil_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	entrada_id INTEGER,
	transferencia_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONTACONTABILSALDO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datareferencia TIMESTAMP NOT NULL,
	valor DECIMAL(20,2),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	contacontabil_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE CONTATO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	cargo VARCHAR(255),
	cpf VARCHAR(255),
	email VARCHAR(255),
	nome VARCHAR(255),
	ordem INTEGER,
	representantelegal BOOLEAN,
	telefone VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	pessoa_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE CONTRATO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	altacomplexidade BOOLEAN,
	datacelebracao TIMESTAMP,
	datavigenciafinal TIMESTAMP,
	datavigenciainicial TIMESTAMP,
	fundamentolegal VARCHAR(30),
	inciso VARCHAR(30),
	numero INTEGER,
	numerolicitacao VARCHAR(30),
	objetocontratacao VARCHAR(1024),
	publicacao VARCHAR(30),
	valor DECIMAL(20,4),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiomodalidade_id INTEGER,
	dominiosituacaoatual_id INTEGER,
	dominiotipoaquisicao_id INTEGER,
	dominiotipocontrato_id INTEGER,
	fornecedor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONTRATOANEXO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	anexo VARBINARY (1024),
	descricao VARCHAR(200),
	tamanho INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	contrato_id INTEGER,
	contratoinativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONTRATOAPOSTILAMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	compensacaosancaofinanceira DECIMAL(20,2),
	dataexecucao TIMESTAMP,
	datavigenciafinal TIMESTAMP,
	motivo VARCHAR(600),
	valorcontratual DECIMAL(20,2),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	contrato_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONTRATOEQUIPEGESTORA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datafinal TIMESTAMP,
	datainicial TIMESTAMP,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	colaborador_id INTEGER,
	contrato_id INTEGER,
	dominiopapelequipecontratos_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE CONTRATOTERMOADITIVO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datavigenciafinal TIMESTAMP,
	datavigenciainicial TIMESTAMP,
	objetocontratual VARCHAR(1024),
	valor DECIMAL(20,4),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	contrato_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	fornecedor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE DEFAULTFILE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	ativo VARCHAR(255),
	caminho VARCHAR(255),
	ordem INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	dominiodefaultfile_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE DEFINICAODETENTOR (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	dataatribuicao TIMESTAMP NOT NULL,
	datafimatribuicao TIMESTAMP,
	detentorresponsavel BOOLEAN,
	numerotermo INTEGER,
	referenciavigente TIMESTAMP NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	colaborador_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE DEFINICAODETENTORITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	dataatribuicao TIMESTAMP NOT NULL,
	datafimatribuicao TIMESTAMP,
	sequencia INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	bempatrimonial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	definicaodetentor_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE DEPRECIACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datadepreciacao TIMESTAMP NOT NULL,
	mesreferencia DATE NOT NULL,
	qntitensnaodepreciadovalorminimo INTEGER,
	qntitensnaodepreciadovidautil INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE DEPRECIACAOITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	taxadepreciacao DECIMAL(19,2),
	valoranterior DECIMAL(19,2),
	valoratual DECIMAL(19,2),
	vidautilrestante INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	bempatrimonial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	contacontabil_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	depreciacao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE DOCUMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	dataemissao DATE,
	numero VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipodocumento_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	emitente_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE DOMINIO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	chave VARCHAR(50),
	codigo INTEGER,
	descricao VARCHAR(255),
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE ENDERECO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	cep VARCHAR(15),
	codigo VARCHAR(30),
	complemento VARCHAR(100),
	latitude DECIMAL(19,2),
	logradouro VARCHAR(100),
	longitude DECIMAL(19,2),
	nome VARCHAR(300),
	numero VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	bairro_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	cidade_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipoendereco_id INTEGER,
	pessoa_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE ENTRADA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo INTEGER,
	datacontabil TIMESTAMP,
	datarecebimento TIMESTAMP,
	datareferencia TIMESTAMP NOT NULL,
	valortotalnota DECIMAL(20,2),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipobem_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipoentrada_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotiporecebimento_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	estruturaorganizacional_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	fornecedor_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ENTRADADOCUMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	entrada_id INTEGER,
	entradainativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE ENTRADAITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	emplaquetado BOOLEAN,
	quantidade INTEGER,
	sequencia INTEGER,
	valor DECIMAL(20,2),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	entrada_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	material_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ENTRADAOBSERVACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	entrada_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ESTADO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	nome VARCHAR(255),
	sigla VARCHAR(10),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	regiao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ESTRUTURAORGANIZACIONAL (
	almoxarifado BOOLEAN,
	classificacao VARCHAR(100),
	codigo VARCHAR(20),
	datafim TIMESTAMP,
	datainicio TIMESTAMP NOT NULL,
	possuibempatrimonial BOOLEAN,
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	configuracao_id INTEGER,
	dominiotipoestruturaorganizacional_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	estruturaorganizacionalparent_id INTEGER,
	estruturaorganizacionalresponsavel_id INTEGER,
	localizacao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	mapaorganizacional_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE ESTRUTURAORGANIZACIONALRESPONSAVEL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	ordem INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	estruturaorganizacional_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	funcao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	responsavel_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ESTRUTURAORGAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datareferenciavigente TIMESTAMP,
	isorgao BOOLEAN,
	nome VARCHAR(255),
	sigla VARCHAR(30),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE FAVORITO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE FERIADO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datafinal TIMESTAMP NOT NULL,
	datainicial TIMESTAMP NOT NULL,
	descricao VARCHAR(100) NOT NULL,
	recorrente BOOLEAN NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	cidade_id INTEGER,
	dominioabrangenciaferiado_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipoferiado_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	estado_id INTEGER,
	pais_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE "FILTER" (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	comparison VARCHAR(255),
	field VARCHAR(255),
	type VARCHAR(255),
	"value" VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	searchparams_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE FLUXOTRABALHO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	idcitsmart INTEGER,
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE FORNECEDOR (
	compraseletronicas BOOLEAN,
	estrangeiro BOOLEAN,
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE FORNECEDOR_OBSERVACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	fornecedor_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE FORNECEDORRAMOATIVIDADE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	fornecedor_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	grupofederalsupply_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	subgrupofederalsupply_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE FUNCAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	nome VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE GARANTIA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	percentual DECIMAL(20,4),
	valor DECIMAL(20,4),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	contrato_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	contratotermoaditivo_id INTEGER,
	dominiomodalidadegarantia_id INTEGER,
	dominiotipogarantia_id INTEGER,
	seguradora_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE GRUPO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	email VARCHAR(255),
	nome VARCHAR(255),
	sigla VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE GRUPOPRIVILEGIO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	grupo_id INTEGER,
	privilegio_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE GRUPOUSUARIO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	grupo_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	usuario_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE HISTORICOBEMPATRIMONIAL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	dataoperacao TIMESTAMP,
	descricao VARCHAR(250),
	numeroprocesso VARCHAR(100),
	valoranterior VARCHAR(100),
	valornovo VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	bempatrimonial_id INTEGER,
	bempatrimonialinativo_id INTEGER,
	dominiotipohistorico_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipomotivoalteracao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE INTERNACIONALIZACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	chave VARCHAR(255),
	valor VARCHAR(3000),
	inativador_id INTEGER,
	modulo_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	tipodominioidioma_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE INVENTARIOCOMISSAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	dataextincao DATE,
	dataformacao DATE,
	nome VARCHAR(100),
	numprocesso VARCHAR(30),
	portaria VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	estruturaorganizacional_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	presidente_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE INVENTARIOCOMISSAOINTEGRANTE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	sequencia INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	integrante_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	inventariocomissao_id INTEGER,
	inventariocomissaoinativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE LOCALIZACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	endereco_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE MAPAORGANIZACIONAL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	datafim DATE,
	datainicio DATE NOT NULL,
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE MAPAORGANIZACIONALOBSERVACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	mapaorganizacional_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE MATERIAL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigosiasg VARCHAR(255),
	descricao VARCHAR(255),
	emplaquetavel BOOLEAN,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	classificacaomaterial_id INTEGER,
	contacontabil_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipomaterial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiounidademedida_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE MATERIALCARACTERISTICA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	generico BOOLEAN,
	imprimeconteudo BOOLEAN,
	obrigatorio BOOLEAN,
	sequencia INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	caracteristica_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	material_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE MATERIALCONSUMO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	material_id INTEGER,
	materialconsumo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE MATERIALIMAGEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	anexo VARBINARY (1024),
	descricao VARCHAR(200),
	tamanho INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	material_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE MENU (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	ativo VARCHAR(255),
	classepagina VARCHAR(255),
	cor VARCHAR(255),
	nome VARCHAR(255),
	ordem INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	pagina_id INTEGER,
	parent_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE MENUFILE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	ativo VARCHAR(255),
	caminho VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	dominiomenufile_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	menu_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE MODELOEMAIL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	idcitsmart INTEGER,
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE MODULO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	baseurl VARCHAR(100) NOT NULL,
	caminho VARCHAR(100),
	habilitado BOOLEAN NOT NULL,
	nome VARCHAR(100) NOT NULL,
	restangular VARCHAR(100) NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE MONITOR (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	exigeanexo BOOLEAN,
	nome VARCHAR(80),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipoanalise_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipocoleta_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipoperspectiva_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	questionario_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	regraevento_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE MONITORACAODECORRENTE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	quantidadediasintercorrencia INTEGER,
	quantidadediasplanoacao INTEGER,
	quantidadeintercorrencias INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipointercorrencia_id INTEGER,
	monitor_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE MONITORAGENDAMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datafim TIMESTAMP,
	datainicio TIMESTAMP,
	expressaocron VARCHAR(100),
	quantidadeocorrencias INTEGER,
	quantidadetentativas INTEGER,
	semdatatermino BOOLEAN,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipocondicao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotiporeiteracao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	monitor_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE MONITORNOTIFICACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	quantidadediasdisparo INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipodestino_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipodisparo_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotiporepeticao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	modeloemail_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	monitor_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	nivelautoridade_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE MONITORPREDECESSORA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	monitor_id INTEGER,
	predecessora_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE MONITORRESPONSAVEL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipoatribuicao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	fluxotrabalho_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	monitor_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	nivelautoridade_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	alcada_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE NIVELAUTORIDADE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	hierarquia INTEGER,
	idcitsmart INTEGER,
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE NOTIFICACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	datavisualizacao TIMESTAMP,
	mensagem VARCHAR(255) NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	tiponotificacao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	tipoprioridade_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	usuario_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE OBSERVACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	descricao VARCHAR(500),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE ORGAOEXTERNO (
	sigla VARCHAR(255),
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE ORGAOITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	usuario_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PAGINA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	ajuda VARCHAR,
	nome VARCHAR(255),
	pagina VARCHAR(255),
	inativador_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PAGINAUSUARIO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	favorito_id INTEGER,
	pagina_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	usuario_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE PAINEL (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	ativo BOOLEAN,
	identificacao VARCHAR(255),
	nome VARCHAR(255),
	recebeatualizacao BOOLEAN,
	uuid VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	usuario_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PAINELITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	location VARCHAR(255),
	nome VARCHAR(255),
	posicaocolumn INTEGER,
	posicaolinha INTEGER,
	posicaosupercolumn INTEGER,
	styleclass VARCHAR(255),
	type VARCHAR(255),
	urlservico VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	painel_id INTEGER,
	widget_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PAINELITEMPARAMETRO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	chavedominiodefault VARCHAR(50),
	datadefault TIMESTAMP,
	nome VARCHAR(255),
	numerodefault INTEGER,
	textodefault VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	dominiodefault_id INTEGER,
	painelitem_id INTEGER,
	tipowidgetparametrodominio_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PAINELITEMUSUARIOCONFIGURACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	ativo BOOLEAN,
	ordem INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	usuario_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PAIS (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	nome VARCHAR(250),
	sigla VARCHAR(5),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PARAMETROSISTEMA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	chave VARCHAR(255) NOT NULL,
	valor VARCHAR(255) NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	configuracaosistema_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PARCEIRO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	classeparceiro_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	pessoa_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE PARCEIRO_COLABORADOR (
	cargo VARCHAR(255),
	matricula VARCHAR(255),
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	estruturaorganizacional_id INTEGER,
	funcao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PARCEIRO_PORTADOR (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE PARCEIRO_SEGURADORA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE PENALIDADE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	descricao VARCHAR(1024),
	nome VARCHAR(100),
	inativador_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PESSOA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	email VARCHAR(255),
	nome VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominio_pessoa INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE PESSOAFISICA (
	databloqueio DATE,
	datainativo DATE,
	cpf VARCHAR(255),
	datanascimento DATE,
	nomemae VARCHAR(255),
	nomepai VARCHAR(255),
	numeropassaporte VARCHAR(255),
	rg VARCHAR(255),
	tituloeleitor VARCHAR(255),
	pessoa_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	inativador_id INTEGER,
	dominio_estado_civil INTEGER,
	dominio_sexo INTEGER,
	PRIMARY KEY (pessoa_id)
);
CREATE TABLE PESSOAJURIDICA (
	databloqueio DATE,
	datainativo DATE,
	cnpj VARCHAR(255),
	filantropico BOOLEAN,
	filial BOOLEAN,
	impostosimples BOOLEAN,
	inscricaoestadual VARCHAR(255),
	inscricaomunicipal VARCHAR(255),
	nomefantasia VARCHAR(255),
	razaosocial VARCHAR(255),
	site VARCHAR(255),
	pessoa_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	inativador_id INTEGER,
	dominio_abrangencia INTEGER,
	dominio_porte INTEGER,
	PRIMARY KEY (pessoa_id)
);
CREATE TABLE POSSIVELRESPOSTAQUESTIONARIOPERGUNTA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	resposta VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	questionariopergunta_id INTEGER,
	questionarioperguntainativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE ALCADA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	idcitsmart INTEGER,
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE QUESTIONARIO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE QUESTIONARIOPERGUNTA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	questao VARCHAR(500),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotiporesposta_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	questionario_id INTEGER,
	questionarioinativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE REGIAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	nome VARCHAR(100),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	pais_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE REGRAEVENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	conteudo VARCHAR,
	descricao VARCHAR,
	nome VARCHAR(50),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipoimplementacao_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE SAIDATEMPORARIA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	datasaida TIMESTAMP NOT NULL,
	previsaoretorno TIMESTAMP,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	destino_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipoobjetivo_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiotipoprojeto_id INTEGER,
	estruturaorganizacional_id INTEGER,
	portador_id INTEGER,
	responsavel_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE SAIDATEMPORARIADOCUMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	saidatemporaria_id INTEGER,
	saidatemporariainativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE SAIDATEMPORARIAITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	dataretorno TIMESTAMP,
	garantiafinal TIMESTAMP,
	garantiainicial TIMESTAMP,
	sequencia INTEGER,
	solucaoconserto VARCHAR(500),
	valorconserto DECIMAL(20,2),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	bempatrimonial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	dominiostatusanterior_id INTEGER,
	dominiostatusretorno_id INTEGER,
	recebedor_id INTEGER,
	saidatemporaria_id INTEGER,
	saidatemporariainativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE SAIDATEMPORARIAOBSERVACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	saidatemporaria_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE SEARCHPARAMS (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	blninnerjoin BOOLEAN,
	conditionwhere VARCHAR(255),
	dir VARCHAR(255),
	coluna_join VARCHAR(255),
	keywordvalue VARCHAR(255),
	coluna_limit INTEGER,
	nome VARCHAR(255),
	sort VARCHAR(255),
	"start" INTEGER,
	wherecustomize VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	paginausuario_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE SEARHPARAMS_FIELDS (
	searchparams_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	field VARCHAR(255)
);
CREATE TABLE SEGURANCA_PRIVILEGIO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	descricao VARCHAR(64),
	nome VARCHAR(20),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE SEGURANCA_USUARIO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	contabloqueada BOOLEAN NOT NULL,
	contaexpirada BOOLEAN NOT NULL,
	contahabilitada BOOLEAN NOT NULL,
	credencialexpirada BOOLEAN NOT NULL,
	email VARCHAR(255) NOT NULL,
	password VARCHAR(255) NOT NULL,
	passwordhint VARCHAR(255),
	semprenovaaba BOOLEAN NOT NULL,
	tokenpasswordrecovery VARCHAR(255),
	username VARCHAR(50) NOT NULL,
	website VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE SEGURANCA_USUARIO_PRIVILEGIO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	privilegio_id INTEGER,
	usuario_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE TELEFONE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	numero VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	dominio_telefone INTEGER,
	pessoa_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE TERMORESPONSABILIDADE (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	dataemissao TIMESTAMP,
	numerotermo INTEGER,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	definicaodetentor_id INTEGER,
	dominiotipomovimentacao_id INTEGER,
	estruturaorganizacionalorigem_id INTEGER,
	transferencia_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE TRANSFERENCIA (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	codigo VARCHAR(30),
	datatransferencia TIMESTAMP NOT NULL,
	previsaoretorno TIMESTAMP,
	referenciavigente TIMESTAMP NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	orgao_id INTEGER,
	dominiotipomodalidadetransferencia_id INTEGER,
	dominiotipoobjetivo_id INTEGER,
	estruturaorganizacionaldestino_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	responsavel_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE TRANSFERENCIADOCUMENTO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	transferencia_id INTEGER,
	transferenciainativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE TRANSFERENCIAITEM (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	consertado BOOLEAN,
	datafinalgarantia TIMESTAMP,
	datainicialgarantia TIMESTAMP,
	dataretorno TIMESTAMP,
	manterdetentoratual BOOLEAN,
	sequencia INTEGER,
	solucao VARCHAR(300),
	valorconserto DECIMAL(20,2),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	bempatrimonial_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	detentordestino_id INTEGER,
	detentororigem_id INTEGER,
	estruturaorganizacionalorigem_id INTEGER,
	recebedor_id INTEGER,
	transferencia_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE TRANSFERENCIAOBSERVACAO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	transferencia_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
CREATE TABLE WIDGET (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	apresentarurlservico BOOLEAN,
	descricao VARCHAR(255),
	nome VARCHAR(255),
	urlservico VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	tipocomponente_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE WIDGETPARAMETRO (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	booleandefault BOOLEAN,
	chavedominiodefault VARCHAR(50),
	datadefault TIMESTAMP,
	nome VARCHAR(255),
	numerodefault INTEGER,
	textodefault VARCHAR(255),
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	dominiodefault_id INTEGER,
	tipowidgetparametrodominio_id INTEGER,
	widget_id INTEGER,
	widgetinativo_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE WORKCALENDAR (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	considerholiday BOOLEAN NOT NULL,
	description VARCHAR(100) NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	workdayfri_id INTEGER,
	workdaymon_id INTEGER,
	workdaysat_id INTEGER,
	workdaysun_id INTEGER,
	workdaythu_id INTEGER,
	workdaytue_id INTEGER,
	workdaywed_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE WORKDAY (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	description VARCHAR(100) NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE WORKDAYEXCEPTION (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	datacriacao TIMESTAMP NOT NULL,
	dataedicao TIMESTAMP NOT NULL,
	version INTEGER,
	description VARCHAR(100) NOT NULL,
	haswork BOOLEAN,
	startend TIMESTAMP NOT NULL,
	starttime TIMESTAMP NOT NULL,
	inativador_id INTEGER,
	autor_id INTEGER,
	editor_id INTEGER,
	workcalendar_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	workday_id INTEGER,
	PRIMARY KEY (id)
);
CREATE TABLE WORKTIME (
	id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	databloqueio DATE,
	datainativo DATE,
	endtime TIMESTAMP NOT NULL,
	starttime TIMESTAMP NOT NULL,
	inativador_id INTEGER,
	workday_id INTEGER GENERATED BY DEFAULT AS IDENTITY (START WITH 1) NOT NULL,
	PRIMARY KEY (id)
);
ALTER TABLE ACCESSROLE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ACCESSROLE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ACCESSROLE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ADICAOBEMPRINCIPAL
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE ADICAOBEMPRINCIPAL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE ADICAOBEMPRINCIPAL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ADICAOBEMPRINCIPAL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ADICAOBEMPRINCIPAL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ADICAOBEMPRINCIPALITEM
	ADD FOREIGN KEY (adicaobemprincipalinativado_id)
	REFERENCES adicaobemprincipal (id);

ALTER TABLE ADICAOBEMPRINCIPALITEM
	ADD FOREIGN KEY (adicaobemprincipal_id)
	REFERENCES adicaobemprincipal (id);

ALTER TABLE ADICAOBEMPRINCIPALITEM
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE ADICAOBEMPRINCIPALITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ADICAOBEMPRINCIPALITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ADICAOBEMPRINCIPALITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ANEXO
	ADD FOREIGN KEY (documentoinativo_id)
	REFERENCES documento (id);

ALTER TABLE ANEXO
	ADD FOREIGN KEY (documento_id)
	REFERENCES documento (id);

ALTER TABLE ANEXO
	ADD FOREIGN KEY (dominiotipoanexo_id)
	REFERENCES dominio (id);

ALTER TABLE ANEXO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ANEXOIMAGEM
	ADD FOREIGN KEY (configuracaosistema_id)
	REFERENCES configuracaosistema (id);

ALTER TABLE ANEXOIMAGEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE BAIRRO
	ADD FOREIGN KEY (cidade_id)
	REFERENCES cidade (id);

ALTER TABLE BAIRRO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BAIRRO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BAIRRO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE BAIXA
	ADD FOREIGN KEY (dominiotipobem_id)
	REFERENCES dominio (id);

ALTER TABLE BAIXA
	ADD FOREIGN KEY (dominiotipobaixa_id)
	REFERENCES dominio (id);

ALTER TABLE BAIXA
	ADD FOREIGN KEY (dominiosituacaobaixa_id)
	REFERENCES dominio (id);

ALTER TABLE BAIXA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE BAIXA
	ADD FOREIGN KEY (portador_id)
	REFERENCES parceiro (id);

ALTER TABLE BAIXA
	ADD FOREIGN KEY (destino_id)
	REFERENCES parceiro (id);

ALTER TABLE BAIXA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BAIXA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BAIXA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE BAIXADOCUMENTO
	ADD FOREIGN KEY (baixainativo_id)
	REFERENCES baixa (id);

ALTER TABLE BAIXADOCUMENTO
	ADD FOREIGN KEY (baixa_id)
	REFERENCES baixa (id);

ALTER TABLE BAIXADOCUMENTO
	ADD FOREIGN KEY (id)
	REFERENCES documento (id);


ALTER TABLE BAIXAITEM
	ADD FOREIGN KEY (baixainativo_id)
	REFERENCES baixa (id);

ALTER TABLE BAIXAITEM
	ADD FOREIGN KEY (baixa_id)
	REFERENCES baixa (id);

ALTER TABLE BAIXAITEM
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE BAIXAITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BAIXAITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BAIXAITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE BAIXAOBSERVACAO
	ADD FOREIGN KEY (baixa_id)
	REFERENCES baixa (id);

ALTER TABLE BAIXAOBSERVACAO
	ADD FOREIGN KEY (id)
	REFERENCES observacao (id);


ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (bempatrimonialprincipal_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (dominiosituacaofisica_id)
	REFERENCES dominio (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (dominiostatus_id)
	REFERENCES dominio (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (dominiostatusdepreciacao_id)
	REFERENCES dominio (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (dominiotipooperacao_id)
	REFERENCES dominio (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (entradaitem_id)
	REFERENCES entradaitem (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (estruturaorganizacionalatual_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (estruturaorganizacionalcompra_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (fornecedor_id)
	REFERENCES fornecedor (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (material_id)
	REFERENCES material (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (responsavel_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (detentor_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BEMPATRIMONIAL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE BEMPATRIMONIALCARACTERISTICA
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE BEMPATRIMONIALCARACTERISTICA
	ADD FOREIGN KEY (materialcaracteristica_id)
	REFERENCES materialcaracteristica (id);

ALTER TABLE BEMPATRIMONIALCARACTERISTICA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BEMPATRIMONIALCARACTERISTICA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE BEMPATRIMONIALCARACTERISTICA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE BEMPATRIMONIALCARACTERISTICADOCUMENTO
	ADD FOREIGN KEY (bempatrimonialcaracteristica_id)
	REFERENCES bempatrimonialcaracteristica (id);

ALTER TABLE BEMPATRIMONIALCARACTERISTICADOCUMENTO
	ADD FOREIGN KEY (id)
	REFERENCES documento (id);


ALTER TABLE CARACTERISTICA
	ADD FOREIGN KEY (dominiotiporestricao_id)
	REFERENCES dominio (id);

ALTER TABLE CARACTERISTICA
	ADD FOREIGN KEY (dominiotipodado_id)
	REFERENCES dominio (id);

ALTER TABLE CARACTERISTICA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CARACTERISTICA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CARACTERISTICA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CARACTERISTICA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CIDADE
	ADD FOREIGN KEY (estado_id)
	REFERENCES estado (id);

ALTER TABLE CIDADE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CIDADE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CIDADE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CLASSEPARCEIRO
	ADD FOREIGN KEY (dominiotipoparceiro_id)
	REFERENCES dominio (id);

ALTER TABLE CLASSEPARCEIRO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CLASSIFICACAOMATERIAL
	ADD FOREIGN KEY (classificacaomaterialparent_id)
	REFERENCES classificacaomaterial (id);

ALTER TABLE CLASSIFICACAOMATERIAL
	ADD FOREIGN KEY (dominiotipomaterial_id)
	REFERENCES dominio (id);

ALTER TABLE CLASSIFICACAOMATERIAL
	ADD FOREIGN KEY (dominiotipoclassificacaomaterial_id)
	REFERENCES dominio (id);

ALTER TABLE CLASSIFICACAOMATERIAL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CLASSIFICACAOMATERIAL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CLASSIFICACAOMATERIAL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CLASSIFICACAOMATERIAL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONFIGURACAO
	ADD FOREIGN KEY (contacontabilextraviado_id)
	REFERENCES contacontabil (id);

ALTER TABLE CONFIGURACAO
	ADD FOREIGN KEY (contacontabilalmoxarifado_id)
	REFERENCES contacontabil (id);

ALTER TABLE CONFIGURACAO
	ADD FOREIGN KEY (dominiostatusbemextraviado_id)
	REFERENCES dominio (id);

ALTER TABLE CONFIGURACAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONFIGURACAOALMOXARIFADO
	ADD FOREIGN KEY (configuracao_id)
	REFERENCES configuracao (id);

ALTER TABLE CONFIGURACAOALMOXARIFADO
	ADD FOREIGN KEY (estruturaorganizacional_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE CONFIGURACAOALMOXARIFADO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAOALMOXARIFADO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAOALMOXARIFADO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONFIGURACAOCONTACONTABILALMOXARIFADO
	ADD FOREIGN KEY (configuracao_id)
	REFERENCES configuracao (id);

ALTER TABLE CONFIGURACAOCONTACONTABILALMOXARIFADO
	ADD FOREIGN KEY (contacontabil_id)
	REFERENCES contacontabil (id);

ALTER TABLE CONFIGURACAOCONTACONTABILALMOXARIFADO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAOCONTACONTABILALMOXARIFADO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAOCONTACONTABILALMOXARIFADO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONFIGURACAOCONTACONTABILEXTRAVIADO
	ADD FOREIGN KEY (configuracao_id)
	REFERENCES configuracao (id);

ALTER TABLE CONFIGURACAOCONTACONTABILEXTRAVIADO
	ADD FOREIGN KEY (contacontabil_id)
	REFERENCES contacontabil (id);

ALTER TABLE CONFIGURACAOCONTACONTABILEXTRAVIADO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAOCONTACONTABILEXTRAVIADO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAOCONTACONTABILEXTRAVIADO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONFIGURACAOSISTEMA
	ADD FOREIGN KEY (anexoimagem_id)
	REFERENCES anexoimagem (id);

ALTER TABLE CONFIGURACAOSISTEMA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CONFIGURACAOSISTEMA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAOSISTEMA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONFIGURACAOSISTEMA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTACONTABIL
	ADD FOREIGN KEY (contacontabilsaldoanterior_id)
	REFERENCES contacontabilsaldo (id);

ALTER TABLE CONTACONTABIL
	ADD FOREIGN KEY (dominiotipocontacontabil_id)
	REFERENCES dominio (id);

ALTER TABLE CONTACONTABIL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CONTACONTABIL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABIL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABIL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTACONTABILCONFIGURACAOREFERENCIA
	ADD FOREIGN KEY (contacontabil_id)
	REFERENCES contacontabil (id);

ALTER TABLE CONTACONTABILCONFIGURACAOREFERENCIA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABILCONFIGURACAOREFERENCIA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABILCONFIGURACAOREFERENCIA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (baixa_id)
	REFERENCES baixa (id);

ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (contacontabil_id)
	REFERENCES contacontabil (id);

ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (dominiotipomovimentocontacontabil_id)
	REFERENCES dominio (id);

ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (entrada_id)
	REFERENCES entrada (id);

ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABILMOVIMENTO
	ADD FOREIGN KEY (transferencia_id)
	REFERENCES transferencia (id);


ALTER TABLE CONTACONTABILSALDO
	ADD FOREIGN KEY (contacontabil_id)
	REFERENCES contacontabil (id);

ALTER TABLE CONTACONTABILSALDO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABILSALDO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTACONTABILSALDO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTATO
	ADD FOREIGN KEY (pessoa_id)
	REFERENCES pessoa (id);

ALTER TABLE CONTATO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTATO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTATO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTRATO
	ADD FOREIGN KEY (dominiotipocontrato_id)
	REFERENCES dominio (id);

ALTER TABLE CONTRATO
	ADD FOREIGN KEY (dominiotipoaquisicao_id)
	REFERENCES dominio (id);

ALTER TABLE CONTRATO
	ADD FOREIGN KEY (dominiosituacaoatual_id)
	REFERENCES dominio (id);

ALTER TABLE CONTRATO
	ADD FOREIGN KEY (dominiomodalidade_id)
	REFERENCES dominio (id);

ALTER TABLE CONTRATO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CONTRATO
	ADD FOREIGN KEY (fornecedor_id)
	REFERENCES fornecedor (id);

ALTER TABLE CONTRATO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTRATOANEXO
	ADD FOREIGN KEY (contratoinativo_id)
	REFERENCES contrato (id);

ALTER TABLE CONTRATOANEXO
	ADD FOREIGN KEY (contrato_id)
	REFERENCES contrato (id);

ALTER TABLE CONTRATOANEXO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CONTRATOANEXO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATOANEXO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATOANEXO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTRATOAPOSTILAMENTO
	ADD FOREIGN KEY (contrato_id)
	REFERENCES contrato (id);

ALTER TABLE CONTRATOAPOSTILAMENTO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CONTRATOAPOSTILAMENTO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATOAPOSTILAMENTO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATOAPOSTILAMENTO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTRATOEQUIPEGESTORA
	ADD FOREIGN KEY (contrato_id)
	REFERENCES contrato (id);

ALTER TABLE CONTRATOEQUIPEGESTORA
	ADD FOREIGN KEY (dominiopapelequipecontratos_id)
	REFERENCES dominio (id);

ALTER TABLE CONTRATOEQUIPEGESTORA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CONTRATOEQUIPEGESTORA
	ADD FOREIGN KEY (colaborador_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE CONTRATOEQUIPEGESTORA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATOEQUIPEGESTORA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATOEQUIPEGESTORA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE CONTRATOTERMOADITIVO
	ADD FOREIGN KEY (contrato_id)
	REFERENCES contrato (id);

ALTER TABLE CONTRATOTERMOADITIVO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE CONTRATOTERMOADITIVO
	ADD FOREIGN KEY (fornecedor_id)
	REFERENCES fornecedor (id);

ALTER TABLE CONTRATOTERMOADITIVO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATOTERMOADITIVO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE CONTRATOTERMOADITIVO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE DEFAULTFILE
	ADD FOREIGN KEY (dominiodefaultfile_id)
	REFERENCES dominio (id);

ALTER TABLE DEFAULTFILE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEFAULTFILE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEFAULTFILE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE DEFINICAODETENTOR
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE DEFINICAODETENTOR
	ADD FOREIGN KEY (colaborador_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE DEFINICAODETENTOR
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEFINICAODETENTOR
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEFINICAODETENTOR
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE DEFINICAODETENTORITEM
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE DEFINICAODETENTORITEM
	ADD FOREIGN KEY (definicaodetentor_id)
	REFERENCES definicaodetentor (id);

ALTER TABLE DEFINICAODETENTORITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEFINICAODETENTORITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEFINICAODETENTORITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE DEPRECIACAO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE DEPRECIACAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEPRECIACAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEPRECIACAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE DEPRECIACAOITEM
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE DEPRECIACAOITEM
	ADD FOREIGN KEY (contacontabil_id)
	REFERENCES contacontabil (id);

ALTER TABLE DEPRECIACAOITEM
	ADD FOREIGN KEY (depreciacao_id)
	REFERENCES depreciacao (id);

ALTER TABLE DEPRECIACAOITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEPRECIACAOITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DEPRECIACAOITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE DOCUMENTO
	ADD FOREIGN KEY (dominiotipodocumento_id)
	REFERENCES dominio (id);

ALTER TABLE DOCUMENTO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE DOCUMENTO
	ADD FOREIGN KEY (emitente_id)
	REFERENCES parceiro (id);

ALTER TABLE DOCUMENTO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DOCUMENTO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DOCUMENTO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE DOMINIO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DOMINIO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE DOMINIO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ENDERECO
	ADD FOREIGN KEY (bairro_id)
	REFERENCES bairro (id);

ALTER TABLE ENDERECO
	ADD FOREIGN KEY (cidade_id)
	REFERENCES cidade (id);

ALTER TABLE ENDERECO
	ADD FOREIGN KEY (dominiotipoendereco_id)
	REFERENCES dominio (id);

ALTER TABLE ENDERECO
	ADD FOREIGN KEY (pessoa_id)
	REFERENCES pessoa (id);

ALTER TABLE ENDERECO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ENDERECO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ENDERECO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ENTRADA
	ADD FOREIGN KEY (dominiotiporecebimento_id)
	REFERENCES dominio (id);

ALTER TABLE ENTRADA
	ADD FOREIGN KEY (dominiotipoentrada_id)
	REFERENCES dominio (id);

ALTER TABLE ENTRADA
	ADD FOREIGN KEY (dominiotipobem_id)
	REFERENCES dominio (id);

ALTER TABLE ENTRADA
	ADD FOREIGN KEY (estruturaorganizacional_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE ENTRADA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE ENTRADA
	ADD FOREIGN KEY (fornecedor_id)
	REFERENCES fornecedor (id);

ALTER TABLE ENTRADA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ENTRADA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ENTRADA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ENTRADADOCUMENTO
	ADD FOREIGN KEY (id)
	REFERENCES documento (id);

ALTER TABLE ENTRADADOCUMENTO
	ADD FOREIGN KEY (entradainativo_id)
	REFERENCES entrada (id);

ALTER TABLE ENTRADADOCUMENTO
	ADD FOREIGN KEY (entrada_id)
	REFERENCES entrada (id);


ALTER TABLE ENTRADAITEM
	ADD FOREIGN KEY (entrada_id)
	REFERENCES entrada (id);

ALTER TABLE ENTRADAITEM
	ADD FOREIGN KEY (material_id)
	REFERENCES material (id);

ALTER TABLE ENTRADAITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ENTRADAITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ENTRADAITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ENTRADAOBSERVACAO
	ADD FOREIGN KEY (entrada_id)
	REFERENCES entrada (id);

ALTER TABLE ENTRADAOBSERVACAO
	ADD FOREIGN KEY (id)
	REFERENCES observacao (id);


ALTER TABLE ESTADO
	ADD FOREIGN KEY (regiao_id)
	REFERENCES regiao (id);

ALTER TABLE ESTADO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ESTADO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ESTADO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ESTRUTURAORGANIZACIONAL
	ADD FOREIGN KEY (configuracao_id)
	REFERENCES configuracao (id);

ALTER TABLE ESTRUTURAORGANIZACIONAL
	ADD FOREIGN KEY (dominiotipoestruturaorganizacional_id)
	REFERENCES dominio (id);

ALTER TABLE ESTRUTURAORGANIZACIONAL
	ADD FOREIGN KEY (estruturaorganizacionalparent_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE ESTRUTURAORGANIZACIONAL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE ESTRUTURAORGANIZACIONAL
	ADD FOREIGN KEY (estruturaorganizacionalresponsavel_id)
	REFERENCES estruturaorganizacionalresponsavel (id);

ALTER TABLE ESTRUTURAORGANIZACIONAL
	ADD FOREIGN KEY (id)
	REFERENCES estruturaorgao (id);

ALTER TABLE ESTRUTURAORGANIZACIONAL
	ADD FOREIGN KEY (localizacao_id)
	REFERENCES localizacao (id);

ALTER TABLE ESTRUTURAORGANIZACIONAL
	ADD FOREIGN KEY (mapaorganizacional_id)
	REFERENCES mapaorganizacional (id);


ALTER TABLE ESTRUTURAORGANIZACIONALRESPONSAVEL
	ADD FOREIGN KEY (estruturaorganizacional_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE ESTRUTURAORGANIZACIONALRESPONSAVEL
	ADD FOREIGN KEY (funcao_id)
	REFERENCES funcao (id);

ALTER TABLE ESTRUTURAORGANIZACIONALRESPONSAVEL
	ADD FOREIGN KEY (responsavel_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE ESTRUTURAORGANIZACIONALRESPONSAVEL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ESTRUTURAORGANIZACIONALRESPONSAVEL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ESTRUTURAORGANIZACIONALRESPONSAVEL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ESTRUTURAORGAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ESTRUTURAORGAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ESTRUTURAORGAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE FAVORITO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FAVORITO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FAVORITO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE FERIADO
	ADD FOREIGN KEY (cidade_id)
	REFERENCES cidade (id);

ALTER TABLE FERIADO
	ADD FOREIGN KEY (dominiotipoferiado_id)
	REFERENCES dominio (id);

ALTER TABLE FERIADO
	ADD FOREIGN KEY (dominioabrangenciaferiado_id)
	REFERENCES dominio (id);

ALTER TABLE FERIADO
	ADD FOREIGN KEY (estado_id)
	REFERENCES estado (id);

ALTER TABLE FERIADO
	ADD FOREIGN KEY (pais_id)
	REFERENCES pais (id);

ALTER TABLE FERIADO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FERIADO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FERIADO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE "FILTER"
	ADD FOREIGN KEY (searchparams_id)
	REFERENCES searchparams (id);

ALTER TABLE "FILTER"
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE "FILTER"
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE "FILTER"
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE FLUXOTRABALHO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE FLUXOTRABALHO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FLUXOTRABALHO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FLUXOTRABALHO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE FORNECEDOR
	ADD FOREIGN KEY (id)
	REFERENCES parceiro (id);


ALTER TABLE FORNECEDOR_OBSERVACAO
	ADD FOREIGN KEY (fornecedor_id)
	REFERENCES fornecedor (id);

ALTER TABLE FORNECEDOR_OBSERVACAO
	ADD FOREIGN KEY (id)
	REFERENCES observacao (id);


ALTER TABLE FORNECEDORRAMOATIVIDADE
	ADD FOREIGN KEY (subgrupofederalsupply_id)
	REFERENCES classificacaomaterial (id);

ALTER TABLE FORNECEDORRAMOATIVIDADE
	ADD FOREIGN KEY (grupofederalsupply_id)
	REFERENCES classificacaomaterial (id);

ALTER TABLE FORNECEDORRAMOATIVIDADE
	ADD FOREIGN KEY (fornecedor_id)
	REFERENCES fornecedor (id);

ALTER TABLE FORNECEDORRAMOATIVIDADE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FORNECEDORRAMOATIVIDADE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FORNECEDORRAMOATIVIDADE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE FUNCAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FUNCAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE FUNCAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE GARANTIA
	ADD FOREIGN KEY (contrato_id)
	REFERENCES contrato (id);

ALTER TABLE GARANTIA
	ADD FOREIGN KEY (contratotermoaditivo_id)
	REFERENCES contratotermoaditivo (id);

ALTER TABLE GARANTIA
	ADD FOREIGN KEY (dominiotipogarantia_id)
	REFERENCES dominio (id);

ALTER TABLE GARANTIA
	ADD FOREIGN KEY (dominiomodalidadegarantia_id)
	REFERENCES dominio (id);

ALTER TABLE GARANTIA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE GARANTIA
	ADD FOREIGN KEY (seguradora_id)
	REFERENCES parceiro_seguradora (id);

ALTER TABLE GARANTIA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GARANTIA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GARANTIA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE GRUPO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE GRUPO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GRUPO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GRUPO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE GRUPOPRIVILEGIO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE GRUPOPRIVILEGIO
	ADD FOREIGN KEY (grupo_id)
	REFERENCES grupo (id);

ALTER TABLE GRUPOPRIVILEGIO
	ADD FOREIGN KEY (privilegio_id)
	REFERENCES seguranca_privilegio (id);

ALTER TABLE GRUPOPRIVILEGIO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GRUPOPRIVILEGIO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GRUPOPRIVILEGIO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE GRUPOUSUARIO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE GRUPOUSUARIO
	ADD FOREIGN KEY (grupo_id)
	REFERENCES grupo (id);

ALTER TABLE GRUPOUSUARIO
	ADD FOREIGN KEY (usuario_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GRUPOUSUARIO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GRUPOUSUARIO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE GRUPOUSUARIO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE HISTORICOBEMPATRIMONIAL
	ADD FOREIGN KEY (bempatrimonialinativo_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE HISTORICOBEMPATRIMONIAL
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE HISTORICOBEMPATRIMONIAL
	ADD FOREIGN KEY (dominiotipomotivoalteracao_id)
	REFERENCES dominio (id);

ALTER TABLE HISTORICOBEMPATRIMONIAL
	ADD FOREIGN KEY (dominiotipohistorico_id)
	REFERENCES dominio (id);

ALTER TABLE HISTORICOBEMPATRIMONIAL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE HISTORICOBEMPATRIMONIAL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE HISTORICOBEMPATRIMONIAL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE HISTORICOBEMPATRIMONIAL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE INTERNACIONALIZACAO
	ADD FOREIGN KEY (tipodominioidioma_id)
	REFERENCES dominio (id);

ALTER TABLE INTERNACIONALIZACAO
	ADD FOREIGN KEY (modulo_id)
	REFERENCES modulo (id);

ALTER TABLE INTERNACIONALIZACAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE INVENTARIOCOMISSAO
	ADD FOREIGN KEY (estruturaorganizacional_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE INVENTARIOCOMISSAO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE INVENTARIOCOMISSAO
	ADD FOREIGN KEY (presidente_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE INVENTARIOCOMISSAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE INVENTARIOCOMISSAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE INVENTARIOCOMISSAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE INVENTARIOCOMISSAOINTEGRANTE
	ADD FOREIGN KEY (inventariocomissaoinativo_id)
	REFERENCES inventariocomissao (id);

ALTER TABLE INVENTARIOCOMISSAOINTEGRANTE
	ADD FOREIGN KEY (inventariocomissao_id)
	REFERENCES inventariocomissao (id);

ALTER TABLE INVENTARIOCOMISSAOINTEGRANTE
	ADD FOREIGN KEY (id)
	REFERENCES inventariocomissaointegrante (id);

ALTER TABLE INVENTARIOCOMISSAOINTEGRANTE
	ADD FOREIGN KEY (integrante_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE INVENTARIOCOMISSAOINTEGRANTE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE INVENTARIOCOMISSAOINTEGRANTE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE INVENTARIOCOMISSAOINTEGRANTE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE LOCALIZACAO
	ADD FOREIGN KEY (endereco_id)
	REFERENCES endereco (id);

ALTER TABLE LOCALIZACAO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE LOCALIZACAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE LOCALIZACAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE LOCALIZACAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MAPAORGANIZACIONAL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MAPAORGANIZACIONAL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MAPAORGANIZACIONAL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MAPAORGANIZACIONAL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MAPAORGANIZACIONALOBSERVACAO
	ADD FOREIGN KEY (mapaorganizacional_id)
	REFERENCES mapaorganizacional (id);

ALTER TABLE MAPAORGANIZACIONALOBSERVACAO
	ADD FOREIGN KEY (id)
	REFERENCES observacao (id);


ALTER TABLE MATERIAL
	ADD FOREIGN KEY (classificacaomaterial_id)
	REFERENCES classificacaomaterial (id);

ALTER TABLE MATERIAL
	ADD FOREIGN KEY (contacontabil_id)
	REFERENCES contacontabil (id);

ALTER TABLE MATERIAL
	ADD FOREIGN KEY (dominiounidademedida_id)
	REFERENCES dominio (id);

ALTER TABLE MATERIAL
	ADD FOREIGN KEY (dominiotipomaterial_id)
	REFERENCES dominio (id);

ALTER TABLE MATERIAL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MATERIAL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MATERIAL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MATERIAL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MATERIALCARACTERISTICA
	ADD FOREIGN KEY (caracteristica_id)
	REFERENCES caracteristica (id);

ALTER TABLE MATERIALCARACTERISTICA
	ADD FOREIGN KEY (material_id)
	REFERENCES material (id);

ALTER TABLE MATERIALCARACTERISTICA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MATERIALCARACTERISTICA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MATERIALCARACTERISTICA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MATERIALCONSUMO
	ADD FOREIGN KEY (materialconsumo_id)
	REFERENCES material (id);

ALTER TABLE MATERIALCONSUMO
	ADD FOREIGN KEY (material_id)
	REFERENCES material (id);

ALTER TABLE MATERIALCONSUMO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MATERIALCONSUMO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MATERIALCONSUMO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MATERIALIMAGEM
	ADD FOREIGN KEY (material_id)
	REFERENCES material (id);

ALTER TABLE MATERIALIMAGEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MATERIALIMAGEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MATERIALIMAGEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MENU
	ADD FOREIGN KEY (parent_id)
	REFERENCES menu (id);

ALTER TABLE MENU
	ADD FOREIGN KEY (pagina_id)
	REFERENCES pagina (id);

ALTER TABLE MENU
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MENU
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MENU
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MENUFILE
	ADD FOREIGN KEY (dominiomenufile_id)
	REFERENCES dominio (id);

ALTER TABLE MENUFILE
	ADD FOREIGN KEY (menu_id)
	REFERENCES menu (id);

ALTER TABLE MENUFILE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MENUFILE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MENUFILE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MODELOEMAIL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MODELOEMAIL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MODELOEMAIL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MODELOEMAIL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MODULO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MODULO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MODULO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MONITOR
	ADD FOREIGN KEY (dominiotipoperspectiva_id)
	REFERENCES dominio (id);

ALTER TABLE MONITOR
	ADD FOREIGN KEY (dominiotipocoleta_id)
	REFERENCES dominio (id);

ALTER TABLE MONITOR
	ADD FOREIGN KEY (dominiotipoanalise_id)
	REFERENCES dominio (id);

ALTER TABLE MONITOR
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MONITOR
	ADD FOREIGN KEY (questionario_id)
	REFERENCES questionario (id);

ALTER TABLE MONITOR
	ADD FOREIGN KEY (regraevento_id)
	REFERENCES regraevento (id);

ALTER TABLE MONITOR
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITOR
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITOR
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MONITORACAODECORRENTE
	ADD FOREIGN KEY (dominiotipointercorrencia_id)
	REFERENCES dominio (id);

ALTER TABLE MONITORACAODECORRENTE
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MONITORACAODECORRENTE
	ADD FOREIGN KEY (monitor_id)
	REFERENCES monitor (id);

ALTER TABLE MONITORACAODECORRENTE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORACAODECORRENTE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORACAODECORRENTE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MONITORAGENDAMENTO
	ADD FOREIGN KEY (dominiotipocondicao_id)
	REFERENCES dominio (id);

ALTER TABLE MONITORAGENDAMENTO
	ADD FOREIGN KEY (dominiotiporeiteracao_id)
	REFERENCES dominio (id);

ALTER TABLE MONITORAGENDAMENTO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MONITORAGENDAMENTO
	ADD FOREIGN KEY (monitor_id)
	REFERENCES monitor (id);

ALTER TABLE MONITORAGENDAMENTO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORAGENDAMENTO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORAGENDAMENTO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (dominiotiporepeticao_id)
	REFERENCES dominio (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (dominiotipodisparo_id)
	REFERENCES dominio (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (dominiotipodestino_id)
	REFERENCES dominio (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (modeloemail_id)
	REFERENCES modeloemail (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (monitor_id)
	REFERENCES monitor (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (nivelautoridade_id)
	REFERENCES nivelautoridade (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORNOTIFICACAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MONITORPREDECESSORA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MONITORPREDECESSORA
	ADD FOREIGN KEY (predecessora_id)
	REFERENCES monitor (id);

ALTER TABLE MONITORPREDECESSORA
	ADD FOREIGN KEY (monitor_id)
	REFERENCES monitor (id);

ALTER TABLE MONITORPREDECESSORA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORPREDECESSORA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORPREDECESSORA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (dominiotipoatribuicao_id)
	REFERENCES dominio (id);

ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (fluxotrabalho_id)
	REFERENCES fluxotrabalho (id);

ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (monitor_id)
	REFERENCES monitor (id);

ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (nivelautoridade_id)
	REFERENCES nivelautoridade (id);

ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (alcada_id)
	REFERENCES alcada (id);

ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE MONITORRESPONSAVEL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE NIVELAUTORIDADE
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE NIVELAUTORIDADE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE NIVELAUTORIDADE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE NIVELAUTORIDADE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE NOTIFICACAO
	ADD FOREIGN KEY (tipoprioridade_id)
	REFERENCES dominio (id);

ALTER TABLE NOTIFICACAO
	ADD FOREIGN KEY (tiponotificacao_id)
	REFERENCES dominio (id);

ALTER TABLE NOTIFICACAO
	ADD FOREIGN KEY (usuario_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE NOTIFICACAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE NOTIFICACAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE NOTIFICACAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE OBSERVACAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE OBSERVACAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE OBSERVACAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ORGAOEXTERNO
	ADD FOREIGN KEY (id)
	REFERENCES parceiro (id);


ALTER TABLE ORGAOITEM
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE ORGAOITEM
	ADD FOREIGN KEY (usuario_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ORGAOITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ORGAOITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ORGAOITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PAGINA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PAGINAUSUARIO
	ADD FOREIGN KEY (favorito_id)
	REFERENCES favorito (id);

ALTER TABLE PAGINAUSUARIO
	ADD FOREIGN KEY (pagina_id)
	REFERENCES pagina (id);

ALTER TABLE PAGINAUSUARIO
	ADD FOREIGN KEY (usuario_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAGINAUSUARIO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAGINAUSUARIO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAGINAUSUARIO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PAINEL
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE PAINEL
	ADD FOREIGN KEY (usuario_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINEL
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINEL
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINEL
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PAINELITEM
	ADD FOREIGN KEY (painel_id)
	REFERENCES painel (id);

ALTER TABLE PAINELITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINELITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINELITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINELITEM
	ADD FOREIGN KEY (widget_id)
	REFERENCES widget (id);


ALTER TABLE PAINELITEMPARAMETRO
	ADD FOREIGN KEY (tipowidgetparametrodominio_id)
	REFERENCES dominio (id);

ALTER TABLE PAINELITEMPARAMETRO
	ADD FOREIGN KEY (dominiodefault_id)
	REFERENCES dominio (id);

ALTER TABLE PAINELITEMPARAMETRO
	ADD FOREIGN KEY (painelitem_id)
	REFERENCES painelitem (id);

ALTER TABLE PAINELITEMPARAMETRO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINELITEMPARAMETRO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINELITEMPARAMETRO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PAINELITEMUSUARIOCONFIGURACAO
	ADD FOREIGN KEY (usuario_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINELITEMUSUARIOCONFIGURACAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINELITEMUSUARIOCONFIGURACAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAINELITEMUSUARIOCONFIGURACAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PAIS
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAIS
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PAIS
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PARAMETROSISTEMA
	ADD FOREIGN KEY (configuracaosistema_id)
	REFERENCES configuracaosistema (id);

ALTER TABLE PARAMETROSISTEMA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PARAMETROSISTEMA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PARAMETROSISTEMA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PARCEIRO
	ADD FOREIGN KEY (classeparceiro_id)
	REFERENCES classeparceiro (id);

ALTER TABLE PARCEIRO
	ADD FOREIGN KEY (pessoa_id)
	REFERENCES pessoa (id);

ALTER TABLE PARCEIRO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PARCEIRO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PARCEIRO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PARCEIRO_COLABORADOR
	ADD FOREIGN KEY (estruturaorganizacional_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE PARCEIRO_COLABORADOR
	ADD FOREIGN KEY (funcao_id)
	REFERENCES funcao (id);

ALTER TABLE PARCEIRO_COLABORADOR
	ADD FOREIGN KEY (id)
	REFERENCES parceiro (id);


ALTER TABLE PARCEIRO_PORTADOR
	ADD FOREIGN KEY (id)
	REFERENCES parceiro (id);


ALTER TABLE PARCEIRO_SEGURADORA
	ADD FOREIGN KEY (id)
	REFERENCES parceiro (id);


ALTER TABLE PENALIDADE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PESSOA
	ADD FOREIGN KEY (dominio_pessoa)
	REFERENCES dominio (id);

ALTER TABLE PESSOA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE PESSOA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PESSOA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE PESSOA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PESSOAFISICA
	ADD FOREIGN KEY (dominio_sexo)
	REFERENCES dominio (id);

ALTER TABLE PESSOAFISICA
	ADD FOREIGN KEY (dominio_estado_civil)
	REFERENCES dominio (id);

ALTER TABLE PESSOAFISICA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE PESSOAJURIDICA
	ADD FOREIGN KEY (dominio_porte)
	REFERENCES dominio (id);

ALTER TABLE PESSOAJURIDICA
	ADD FOREIGN KEY (dominio_abrangencia)
	REFERENCES dominio (id);

ALTER TABLE PESSOAJURIDICA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE POSSIVELRESPOSTAQUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE POSSIVELRESPOSTAQUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (questionarioperguntainativo_id)
	REFERENCES questionariopergunta (id);

ALTER TABLE POSSIVELRESPOSTAQUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (questionariopergunta_id)
	REFERENCES questionariopergunta (id);

ALTER TABLE POSSIVELRESPOSTAQUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE POSSIVELRESPOSTAQUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE POSSIVELRESPOSTAQUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE ALCADA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE ALCADA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ALCADA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE ALCADA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE QUESTIONARIO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE QUESTIONARIO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE QUESTIONARIO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE QUESTIONARIO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE QUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (dominiotiporesposta_id)
	REFERENCES dominio (id);

ALTER TABLE QUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE QUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (questionario_id)
	REFERENCES questionario (id);

ALTER TABLE QUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (questionarioinativo_id)
	REFERENCES questionario (id);

ALTER TABLE QUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE QUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE QUESTIONARIOPERGUNTA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE REGIAO
	ADD FOREIGN KEY (pais_id)
	REFERENCES pais (id);

ALTER TABLE REGIAO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE REGIAO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE REGIAO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE REGRAEVENTO
	ADD FOREIGN KEY (dominiotipoimplementacao_id)
	REFERENCES dominio (id);

ALTER TABLE REGRAEVENTO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE REGRAEVENTO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE REGRAEVENTO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE REGRAEVENTO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (dominiotipoprojeto_id)
	REFERENCES dominio (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (dominiotipoobjetivo_id)
	REFERENCES dominio (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (estruturaorganizacional_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (destino_id)
	REFERENCES parceiro (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (responsavel_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (portador_id)
	REFERENCES parceiro_portador (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SAIDATEMPORARIA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE SAIDATEMPORARIADOCUMENTO
	ADD FOREIGN KEY (id)
	REFERENCES documento (id);

ALTER TABLE SAIDATEMPORARIADOCUMENTO
	ADD FOREIGN KEY (saidatemporariainativo_id)
	REFERENCES saidatemporaria (id);

ALTER TABLE SAIDATEMPORARIADOCUMENTO
	ADD FOREIGN KEY (saidatemporaria_id)
	REFERENCES saidatemporaria (id);


ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (dominiostatusanterior_id)
	REFERENCES dominio (id);

ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (dominiostatusretorno_id)
	REFERENCES dominio (id);

ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (recebedor_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (saidatemporariainativo_id)
	REFERENCES saidatemporaria (id);

ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (saidatemporaria_id)
	REFERENCES saidatemporaria (id);

ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SAIDATEMPORARIAITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE SAIDATEMPORARIAOBSERVACAO
	ADD FOREIGN KEY (id)
	REFERENCES observacao (id);

ALTER TABLE SAIDATEMPORARIAOBSERVACAO
	ADD FOREIGN KEY (saidatemporaria_id)
	REFERENCES saidatemporaria (id);


ALTER TABLE SEARCHPARAMS
	ADD FOREIGN KEY (paginausuario_id)
	REFERENCES paginausuario (id);

ALTER TABLE SEARCHPARAMS
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEARCHPARAMS
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEARCHPARAMS
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE SEARHPARAMS_FIELDS
	ADD FOREIGN KEY (searchparams_id)
	REFERENCES searchparams (id);


ALTER TABLE SEGURANCA_PRIVILEGIO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEGURANCA_PRIVILEGIO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEGURANCA_PRIVILEGIO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE SEGURANCA_USUARIO
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE SEGURANCA_USUARIO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEGURANCA_USUARIO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEGURANCA_USUARIO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE SEGURANCA_USUARIO_PRIVILEGIO
	ADD FOREIGN KEY (privilegio_id)
	REFERENCES seguranca_privilegio (id);

ALTER TABLE SEGURANCA_USUARIO_PRIVILEGIO
	ADD FOREIGN KEY (usuario_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEGURANCA_USUARIO_PRIVILEGIO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEGURANCA_USUARIO_PRIVILEGIO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE SEGURANCA_USUARIO_PRIVILEGIO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE TELEFONE
	ADD FOREIGN KEY (dominio_telefone)
	REFERENCES dominio (id);

ALTER TABLE TELEFONE
	ADD FOREIGN KEY (pessoa_id)
	REFERENCES pessoa (id);

ALTER TABLE TELEFONE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TELEFONE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TELEFONE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE TERMORESPONSABILIDADE
	ADD FOREIGN KEY (definicaodetentor_id)
	REFERENCES definicaodetentor (id);

ALTER TABLE TERMORESPONSABILIDADE
	ADD FOREIGN KEY (dominiotipomovimentacao_id)
	REFERENCES dominio (id);

ALTER TABLE TERMORESPONSABILIDADE
	ADD FOREIGN KEY (estruturaorganizacionalorigem_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE TERMORESPONSABILIDADE
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE TERMORESPONSABILIDADE
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TERMORESPONSABILIDADE
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TERMORESPONSABILIDADE
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TERMORESPONSABILIDADE
	ADD FOREIGN KEY (transferencia_id)
	REFERENCES transferencia (id);


ALTER TABLE TRANSFERENCIA
	ADD FOREIGN KEY (dominiotipoobjetivo_id)
	REFERENCES dominio (id);

ALTER TABLE TRANSFERENCIA
	ADD FOREIGN KEY (dominiotipomodalidadetransferencia_id)
	REFERENCES dominio (id);

ALTER TABLE TRANSFERENCIA
	ADD FOREIGN KEY (estruturaorganizacionaldestino_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE TRANSFERENCIA
	ADD FOREIGN KEY (orgao_id)
	REFERENCES estruturaorgao (id);

ALTER TABLE TRANSFERENCIA
	ADD FOREIGN KEY (responsavel_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE TRANSFERENCIA
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TRANSFERENCIA
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TRANSFERENCIA
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE TRANSFERENCIADOCUMENTO
	ADD FOREIGN KEY (id)
	REFERENCES documento (id);

ALTER TABLE TRANSFERENCIADOCUMENTO
	ADD FOREIGN KEY (transferenciainativo_id)
	REFERENCES transferencia (id);

ALTER TABLE TRANSFERENCIADOCUMENTO
	ADD FOREIGN KEY (transferencia_id)
	REFERENCES transferencia (id);


ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (bempatrimonial_id)
	REFERENCES bempatrimonial (id);

ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (estruturaorganizacionalorigem_id)
	REFERENCES estruturaorganizacional (id);

ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (recebedor_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (detentororigem_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (detentordestino_id)
	REFERENCES parceiro_colaborador (id);

ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE TRANSFERENCIAITEM
	ADD FOREIGN KEY (transferencia_id)
	REFERENCES transferencia (id);


ALTER TABLE TRANSFERENCIAOBSERVACAO
	ADD FOREIGN KEY (id)
	REFERENCES observacao (id);

ALTER TABLE TRANSFERENCIAOBSERVACAO
	ADD FOREIGN KEY (transferencia_id)
	REFERENCES transferencia (id);


ALTER TABLE WIDGET
	ADD FOREIGN KEY (tipocomponente_id)
	REFERENCES dominio (id);

ALTER TABLE WIDGET
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WIDGET
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WIDGET
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE WIDGETPARAMETRO
	ADD FOREIGN KEY (dominiodefault_id)
	REFERENCES dominio (id);

ALTER TABLE WIDGETPARAMETRO
	ADD FOREIGN KEY (tipowidgetparametrodominio_id)
	REFERENCES dominio (id);

ALTER TABLE WIDGETPARAMETRO
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WIDGETPARAMETRO
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WIDGETPARAMETRO
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WIDGETPARAMETRO
	ADD FOREIGN KEY (widgetinativo_id)
	REFERENCES widget (id);

ALTER TABLE WIDGETPARAMETRO
	ADD FOREIGN KEY (widget_id)
	REFERENCES widget (id);


ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (workdaysun_id)
	REFERENCES workday (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (workdaysat_id)
	REFERENCES workday (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (workdaywed_id)
	REFERENCES workday (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (workdayfri_id)
	REFERENCES workday (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (workdaymon_id)
	REFERENCES workday (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (workdaytue_id)
	REFERENCES workday (id);

ALTER TABLE WORKCALENDAR
	ADD FOREIGN KEY (workdaythu_id)
	REFERENCES workday (id);


ALTER TABLE WORKDAY
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKDAY
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKDAY
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);


ALTER TABLE WORKDAYEXCEPTION
	ADD FOREIGN KEY (editor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKDAYEXCEPTION
	ADD FOREIGN KEY (autor_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKDAYEXCEPTION
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKDAYEXCEPTION
	ADD FOREIGN KEY (workcalendar_id)
	REFERENCES workcalendar (id);

ALTER TABLE WORKDAYEXCEPTION
	ADD FOREIGN KEY (workday_id)
	REFERENCES workday (id);


ALTER TABLE WORKTIME
	ADD FOREIGN KEY (inativador_id)
	REFERENCES seguranca_usuario (id);

ALTER TABLE WORKTIME
	ADD FOREIGN KEY (workday_id)
	REFERENCES workday (id);


